<?php
/*
 * ------------------------------------------------------------------------
 * JA Amazon S3 for joomla 17
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * ------------------------------------------------------------------------
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

@set_time_limit(0);
@ini_set('memory_limit', '1024M');

JToolbarHelper::title(JText::_("JOOMLART_AMAZON_S3"));

// Require constants
require_once(JPATH_COMPONENT.DS.'constants.php');

// Load global assets
if(!defined('JA_GLOBAL_SKIN')) {
	define('JA_GLOBAL_SKIN', 1);
	$assets = JURI::root().'administrator/components/'.JACOMPONENT.'/assets/';

	JHTML::stylesheet('style.css', $assets. 'css/');
	JHTML::stylesheet('ja.popup.css', $assets . 'japopup/');
	
	JHTML::script('jquery.js', $assets. 'js/');
	JHTML::script('jquery.event.drag-1.4.min.js', $assets. 'js/');
	JHTML::script('menu.js', $assets. 'js/');
	JHTML::script('joomlart.js', $assets. 'js/');
	JHTML::script('ja.popup.js', $assets. 'japopup/');
	//jquery alert plugin
	JHTML::stylesheet('jquery.alerts.css', $assets . 'jquery.alerts/');
	JHTML::script('jquery.alerts.js', $assets. 'jquery.alerts/');
	
	JHTML::_('behavior.tooltip');
	JHTML::_('behavior.modal');
}

//check if plugin "JA Amazon S3" has been installed or not
$pluginFile = JPATH_PLUGINS.DS."system".DS."plg_jaamazons3".DS."plg_jaamazons3.php";
if(!is_file($pluginFile)) {
	JError::raiseNotice(100, JText::_("THE_PLUGIN_JA_AMAZON_S3_HAS_NOT_BEEN_INSTALLED_ON_YOUR_SITE_YET"));
}

//check account and buckets
$db = JFactory::getDBO();
$warningMsg = "";
$sqlCheckAccount = "SELECT * FROM #__jaamazons3_account LIMIT 0,1";
$db->setQuery($sqlCheckAccount);
$oAcc = $db->loadObject();
$sqlCheckBucket = "SELECT * FROM #__jaamazons3_bucket LIMIT 0,1";
$db->setQuery($sqlCheckBucket);
$oBucket = $db->loadObject();

if(JRequest::getVar('tmpl') != 'component' || (JRequest::getVar('view') == 'profile' && JRequest::getVar('task') == 'edit')) {
	$session =& JFactory::getSession();
	$sessionQueue = $session->get('application.queue');
	if (!count($sessionQueue)) {
		if(JRequest::getVar('tmpl') != 'component') {
			if(!$oAcc || !$oBucket) {
				$warningMsg .= JText::_("ACTION_REQUIRED_BEFORE_SOME_FUNCTIONS_ARE_AVAILABLE");
				if(!$oAcc) {
					$warningMsg .= "<br />";
		$warningMsg .= JText::sprintf('CONFIG_AT_LEAST_1_AMAZON_S3_ACCOUNT', "index.php?option=".JACOMPONENT."&view=account");
				}
				if(!$oBucket) {
					$warningMsg .= "<br />";
		$warningMsg .= JText::sprintf('UPDATE_BUCKET_INFORMATION_FROM_AMAZON_S3_TO_COMPONENT_DATABASE', "index.php?option=".JACOMPONENT."&view=bucket");
				}
				JError::raiseNotice(100, $warningMsg);
			}
		} else {
			if(!$oAcc) {
				$warningMsg = JText::sprintf('CONFIG_AT_LEAST_1_ACCOUNT_BEFORE_CREATE_PROFILE', "index.php?option=".JACOMPONENT."&view=account");
				JError::raiseNotice(100, $warningMsg);
			} elseif(!$oBucket) {
				$warningMsg = JText::sprintf('CONFIG_AT_LEAST_1_BUCKET_BEFORE_CREATE_PROFILE', "index.php?option=".JACOMPONENT."&view=bucket");
				JError::raiseNotice(100, $warningMsg);
			}
		}
	}
}


// -----
// Require specific controller if requested
if($controller = JRequest::getWord( 'view', 'account' )) {
	$path = JPATH_COMPONENT.DS.'controllers'.DS.$controller.'.php';
	if(file_exists( $path )) {
		require_once $path;
	} else {
		$controller = '';
	}
}

// Create the controller
$className  = 'jaAmazonS3Controller'.$controller;

$controller = new $className();

// Perform the Request task
$controller->execute(JRequest::getVar('task'));

// Redirect if set by the controller
$controller->redirect();
