<?php
/**
 * @desc Modify from component Media Manager of Joomla
 *
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');

/**
 * Weblinks Weblink Controller
 *
 * @package		Joomla
 * @subpackage	Weblinks
 * @since 1.5
 */
class jaAmazonS3ControllerFile extends jaAmazonS3Controller
{
	function update_acl_public() {
		$this->update_acl(AmazonS3::ACL_PUBLIC);
	}
	
	function update_acl_private() {
		$this->update_acl(AmazonS3::ACL_PRIVATE);
	}
	
	function update_acl_open() {
		$this->update_acl(AmazonS3::ACL_OPEN);
	}
	
	function update_acl($acl = AmazonS3::ACL_PRIVATE) {
		
		$mainframe = JFactory::getApplication('administrator');

		JRequest::checkToken( 'request' ) or jexit( 'Invalid Token' );

		// Set FTP credentials, if given
		jimport('joomla.client.helper');
		JClientHelper::setCredentialsFromRequest('ftp');

		// Get some data from the request
		$tmpl	= JRequest::getCmd( 'tmpl' );
		$paths	= JRequest::getVar( 'rm', array(), '', 'array' );
		$folder = JRequest::getVar( 'folder', '');

		// Initialize variables
		$msg = array();
		$ret = true;
		/**
		 * get s3 object
		 */
		$modelRepo = & JModel::getInstance ( 'repo', 'jaAmazonS3Model' );
		$bucket = $modelRepo->getActiveBucket();
		if($bucket === false) {
			return false;
		}
		$s3 = jaStorageHelper::getStorage($bucket);

		//
		if (count($paths)) {
			foreach ($paths as $path)
			{
				/*if ($path !== JFile::makeSafe($path)) {
					JError::raiseWarning(100, JText::_('UNABLE_TO_DELETE').htmlspecialchars($path, ENT_COMPAT, 'UTF-8').' '.JText::_('IT_SEEMS_A_SYSTEM_FILES'));
					continue;
				}*/
				$fullPath = jaStorageHelper::cleanPath($folder."/".$path, false);
				if(substr($fullPath, -1) == '/') {
					//is folder
					$retItem = $modelRepo->updateAcl($bucket, $bucket->bucket_name, $acl, $fullPath);
					$ret &= $retItem;
				} else {
					$response = $s3->set_object_acl($bucket->bucket_name, $fullPath, $acl);
					$retItem = $response->status == 200 ? true : false;
					$ret &= $retItem;
				}
				
			}
		}
		if($ret) {
			$msg = JText::_("SUCCESSFULLY_UPDATE_ACL_FOR_SELECTED_ITEMS");
			$msgType = 'message';
		} else {
			$msg = JText::_("UNSUCCESSFULLY_UPDATE_ACL_FOR_SELECTED_ITEMS");
			$msgType = 'error';
		}
		if ($tmpl == 'component') {
			// We are inside the iframe
			$mainframe->redirect('index.php?option='.JACOMPONENT.'&view=repolist&folder='.$folder.'&tmpl=component', $msg, $msgType);
		} else {
			$mainframe->redirect('index.php?option='.JACOMPONENT.'&view=repolist&folder='.$folder, $msg, $msgType);
		}
	}
	/**
	 * Deletes paths from the current path
	 *
	 * @param string $listFolder The image directory to delete a file from
	 * @since 1.5
	 */
	function delete()
	{
		$mainframe = JFactory::getApplication('administrator');

		JRequest::checkToken( 'request' ) or jexit( 'Invalid Token' );

		// Set FTP credentials, if given
		jimport('joomla.client.helper');
		JClientHelper::setCredentialsFromRequest('ftp');

		// Get some data from the request
		$tmpl	= JRequest::getCmd( 'tmpl' );
		$paths	= JRequest::getVar( 'rm', array(), '', 'array' );
		$folder = JRequest::getVar( 'folder', '');

		// Initialize variables
		$msg = array();
		$ret = true;
		/**
		 * get s3 object
		 */
		$modelRepo = & JModel::getInstance ( 'repo', 'jaAmazonS3Model' );
		$bucket = $modelRepo->getActiveBucket();
		if($bucket === false) {
			return false;
		}
		$s3 = jaStorageHelper::getStorage($bucket);

		//
		if (count($paths)) {
			$db = JFactory::getDBO();
			
			foreach ($paths as $path)
			{
				/*if ($path !== JFile::makeSafe($path)) {
					JError::raiseWarning(100, JText::_('UNABLE_TO_DELETE').htmlspecialchars($path, ENT_COMPAT, 'UTF-8').' '.JText::_('IT_SEEMS_A_SYSTEM_FILES'));
					continue;
				}*/

				$fullPath = jaStorageHelper::cleanPath($folder."/".$path, false);
				
				if(substr($fullPath, -1) == '/') {
					//is folder
					$sqlClean = "UPDATE `#__jaamazons3_file` SET `file_exists` = 0 WHERE `bucket_id` = '{$bucket->id}' AND INSTR(`path`, '{$fullPath}') = 1;";
					$db->setQuery($sqlClean);
					$db->query();
					//
					$retItem = $modelRepo->deleteAdvance($bucket, $fullPath, '');
					$ret |= $retItem;
				} else {
					$sqlClean = "UPDATE `#__jaamazons3_file` SET `file_exists` = 0 WHERE `bucket_id` = '{$bucket->id}' AND path = '{$fullPath}';";
					$db->setQuery($sqlClean);
					$db->query();
					//
					$response = $s3->delete_object($bucket->bucket_name, $fullPath);
					$retItem = $response->status == 200 ? true : false;
					$ret |= $retItem;
				}
				
			}
		}
		$msg = JText::_("SUCCESSFULLY_DELETE_FILE");
		if ($tmpl == 'component') {
			// We are inside the iframe
			$mainframe->redirect('index.php?option='.JACOMPONENT.'&view=repolist&folder='.$folder.'&tmpl=component', $msg);
		} else {
			$mainframe->redirect('index.php?option='.JACOMPONENT.'&view=repolist&folder='.$folder, $msg);
		}
	}
	
	function delete_folder()
	{
		$tmpl	= JRequest::getCmd( 'tmpl' );
		if ($tmpl == 'component') {
			// We are inside the iframe
			$mainframe->redirect('index.php?option='.JACOMPONENT.'&view=repolist&folder='.$folder.'&tmpl=component');
		} else {
			$mainframe->redirect('index.php?option='.JACOMPONENT.'&view=repolist&folder='.$folder);
		}
	}

	/**
	 * download
	 * - Use for download file
	 * @param
	 * @return None
	 */
	function download() {
		$mainframe = JFactory::getApplication('administrator');

		JRequest::checkToken( 'request' ) or jexit( 'Invalid Token' );

		// Set FTP credentials, if given
		jimport('joomla.client.helper');
		JClientHelper::setCredentialsFromRequest('ftp');

		// Get some data from the request
		$tmpl	= JRequest::getCmd( 'tmpl' );
		$paths	= JRequest::getVar( 'rm', array(), '', 'array' );
		$folder = JRequest::getVar( 'folder', '');

		// Initialize variables
		$msg = array();
		$ret = true;
		/**
		 * get s3 object
		 */
		$modelRepo = & JModel::getInstance ( 'repo', 'jaAmazonS3Model' );
		$bucket = $modelRepo->getActiveBucket();
		if($bucket === false) {
			return false;
		}
		$s3 = jaStorageHelper::getStorage($bucket);

		$fullPath = JPath::clean($folder."/".$paths[0], "/");
		//remove first slash
		$file = preg_replace("/^\//", '', $fullPath);
		
		$rs = $s3->get_object($bucket->bucket_name, $file);
		header("Pragma: public");
		header("Expires: 0");
		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
		header("Cache-Control: private",false);
		header("Content-Type: ".$rs->header['content-type']);
		header("Content-Disposition: attachment; filename=".basename($file).";" );
		header("Content-Transfer-Encoding: binary");
		header("Content-Length: ".$rs->header['content-length']);
		//print_r($rs);
		echo $rs->body;
		exit();
	}
	
	function multi_enable() {
		$this->multi_update_status('enable');
	}
	
	function multi_disable() {
		$this->multi_update_status('disable');
	}
	
	function multi_update_status($status) {
		$mainframe = JFactory::getApplication('administrator');

		JRequest::checkToken( 'request' ) or jexit( 'Invalid Token' );
		
		$status = ($status == "disable") ? 0 : 1;

		// Set FTP credentials, if given
		jimport('joomla.client.helper');
		JClientHelper::setCredentialsFromRequest('ftp');

		// Get some data from the request
		$tmpl	= JRequest::getCmd( 'tmpl' );
		$paths	= JRequest::getVar( 'rm', array(), '', 'array' );
		$folder = JRequest::getVar( 'update-folder', '');

		// Initialize variables
		$msg = array();
		$ret = true;
		
		$model	=& $this->getModel('localrepo');
		$profile = $model->getActiveProfile();
		
		if ($profile !== false) {
			//
			if (count($paths)) {
				$db = JFactory::getDBO();
				foreach ($paths as $path)
				{
					$s3Path = jaStorageHelper::cleanPath($path);
					if(!$status) {
						$query = "INSERT IGNORE INTO #__jaamazons3_disabled (`profile_id`, `path`) VALUES ('{$profile->id}', '{$s3Path}')";
					} else {
						$query = "DELETE FROM #__jaamazons3_disabled WHERE `profile_id` = '{$profile->id}' AND `path` = '{$s3Path}'";
					}
					$db->setQuery($query);
					$db->query();
				}
			}
			if(!$status) {
				$msg = JText::_("SUCCESSFULLY_DISABLE_SELECTED_ITEMS");
			} else {
				$msg = JText::_("SUCCESSFULLY_ENABLE_SELECTED_ITEMS");
			}
		} else {
			$msg = JText::_("INVALID_PROFILE");
		}
		if ($tmpl == 'component') {
			// We are inside the iframe
			$mainframe->redirect('index.php?option='.JACOMPONENT.'&view=localrepolist&folder='.$folder.'&tmpl=component', $msg);
		} else {
			$mainframe->redirect('index.php?option='.JACOMPONENT.'&view=localrepolist&folder='.$folder, $msg);
		}
	}
}
