<?php
/*
# ------------------------------------------------------------------------
# JA Showcase component for Joomla 1.5
# ------------------------------------------------------------------------
# Copyright (C) 2004-2010 JoomlArt.com. All Rights Reserved.
# @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
# Author: JoomlArt.com
# Websites: http://www.joomlart.com - http://www.joomlancers.com.
# ------------------------------------------------------------------------
*/

// no direct access
defined('_JEXEC') or die('Restricted access');
jimport('joomla.filesystem.file');
/**
 * @package		Joomla
 * @subpackage	Config
 */
class JashowcaseControllerJaconfig extends JashowcaseController
{
	/**
	 * Constructor
	 */
	function __construct( $default = array())
	{
		parent::__construct( $default );
		$this->registerTask( 'apply', 'save');
		$this->registerTask( 'applyCustomFields', 'saveCustomFields');
		$this->registerTask( 'previewCustomFields', 'previewCustomFields');
		$this->registerTask( 'applyCustomTpl', 'saveCustomTpl');
		$this->registerTask( 'cancelCustomFields', 'cancel');
		
	}

	/**
	 * Display the list of banners
	 */
	function display() {
		JRequest::setVar('view', 'jaconfig');

		$task = JRequest::getVar('task');

		switch ($task) {
		  case 'applyCustomFields':
		    JRequest::setVar('layout', 'form_customfields');
		    break;
		  case 'applyCustomTpl':
		    JRequest::setVar('layout', 'form_customtpl');
		    break;
		}

		parent::display();
	}

	function previewCustomFields() {
	  JRequest::setVar('layout', 'customfields_preview');
    parent::display();
	}

	function cancel(){
		global $option;
		$this->setRedirect("index.php?option=$option");
	}

	/**
	 * save config into setting.php
	 */
	function save(){
		global $option;

		$group = JRequest::getVar('group', 'general');
		$paramsField = JRequest::getVar( 'params', null, 'post', 'array' );

		// Build parameter INI string
		if ($paramsField)	{
			$params = new JParameter('');
			$data = array();
			foreach ($paramsField as $k => $v) {
				$params->set($k, $v);
			}
			$data = $params->toString();
			$file 	= JPATH_COMPONENT_ADMINISTRATOR.DS."views/jaconfig/settings.ini";
			if (!JFile::write($file, $data)) {
				echo "<script> alert('Can not save file !'); window.history.go(-1); </script>\n";
				exit();
			}
		}

		if($this->getTask() == "apply"){
			$this->setRedirect("index.php?option=$option&task=settings&view=jaconfig&group=$group", "Settings saved");
		}
		else{
		   $this->setRedirect("index2.php?option=$option", "Settings saved");
		}
	}

	/**
	 * save config into customfiels.xml
	 *
	 */

	function saveCustomFields(){
		global $option;

		// Make sure that file uploads are enabled in php
		if (!(bool) ini_get('file_uploads')){
			echo "<script> alert('not to allow HTTP file uploads!'); window.history.go(-1); </script>\n";
			return ;
		}
		$file 	= JPATH_COMPONENT_ADMINISTRATOR.DS.'views/jaconfig/customfields.xml';

		if (!is_writable($file)) {
			echo "<script> alert('This file unwritable!'); window.history.go(-1); </script>\n";
			return ;
		}

		$file_content = $_POST['customfields'];
		$file_content = str_replace (array("\\\\","\\\"","\\'"), array("\\","\"","'"), $file_content);
		if(!JFile::write($file, $file_content)){
			echo "<script> alert('Can not save file !'); window.history.go(-1); </script>\n";
			exit();
		}

		if($this->getTask() == "applyCustomFields"){
		  	$this->setRedirect("index.php?option=$option&task=customfields&view=jaconfig", "Custom Field file saved !");
		}	else{
		 	$this->setRedirect("index.php?option=$option", "Custom Field file saved !");
		}
	}
	
	function loadtemplatefile(){
		$theme = JRequest::getVar("theme","");		
		if($theme){
			jimport('joomla.filesystem.file');
			
			$template = JashowcaseHelper::getTemplate(0);
			$data = "";
			
			$file = JPATH_SITE.DS.'templates'.DS.$template.DS.'html'.DS.'com_jashowcase'.DS."themes".DS.$theme.DS."html".DS."jashowcase".DS."default_item.php";						
			if (file_exists($file)) {				
				$data = JFile::read($file);
			}else{
				$file = JPATH_COMPONENT_SITE.DS.'themes'.DS.$theme.DS.'html'.DS."jashowcase".DS.'default_item.php';				
				if (file_exists($file)) {					
					$data = JFile::read($file);
				}else{									
					$sourceFile = JPATH_SITE.DS.'templates'.DS.$template.DS.'html'.DS.'com_jashowcase'.DS."themes".DS."default".DS."html".DS."jashowcase".DS."default_item.php";
					if (file_exists($sourceFile)) {						
						JFile::copy($sourceFile,$file);
						$data = JFile::read($file);	
					}else{
						$sourceFile = JPATH_COMPONENT_SITE.DS.'themes'.DS."default".DS.'html'.DS."jashowcase".DS.'default_item.php';
						if (file_exists($sourceFile)) {						
							JFile::copy($sourceFile,$file);							
							$data = JFile::read($file);		
						}		
					}								
				}	
			}
			$object = array ();
			$k=0;
			
			$object [$k] = new stdClass ( );
			$object [$k]->id = 'jasc_file_path';
			$object [$k]->type = 'innerHTML';							
			$object [$k]->content = $file;
			$k++;
			
			$object [$k] = new stdClass ( );
			$object [$k]->id = 'path_file';
			$object [$k]->type = 'value';							
			$object [$k]->content = $file;
			$k++;
						
			$object [$k] = new stdClass ( );
			$object [$k]->id = 'jasc_custom_file';
			$object [$k]->type = 'value';							
			$object [$k]->content = $data;
			
			$data = "({'data':[";
			$data .= JashowcaseHelper::parse_JSON ( $object );
			$data .= "]})";
			echo $data;
			exit ();
		}	
	}
	
	/**
	 * save config into customfiels.xml
	 *
	 */
	
	function saveCustomTpl(){
		global $option;

		$file 	= JRequest::getVar("pathfile", "");
		
		if (!$file || !is_writable($file)) {
			echo "<script> alert('This file unwritable!'); window.history.go(-1); </script>\n";
			return ;
		}

		$file_content = $_POST['customfiels'];
		$file_content = str_replace (array("\\\\","\\\"","\\'"), array("\\","\"","'"), $file_content);
		if(!JFile::write($file, $file_content)){
			echo "<script> alert('Can not save file !'); window.history.go(-1); </script>\n";
			exit();
		}
		//print_r($_POST);die();
		if($this->getTask() == "applyCustomTpl"){
			$theme = JRequest::getVar("theme","");
		  	$this->setRedirect("index.php?option=$option&task=customtpl&theme=".$theme."&view=jaconfig", "Custom Field file saved !");
		}
		else{
		 	$this->setRedirect("index.php?option=$option", "Custom Field file saved !");
		}

	}
}