<?php
/**
 * @version		$Id: jashowcase.php 10094 2008-05-20 04:35:10Z instance $
 * @package		Joomla
 * @subpackage	jashowcase
 * @copyright	Copyright (C) 2005 - 2008 Joomlart.com. All rights reserved.
 * @license		Joomlart.com
 */
// no direct access
defined('_JEXEC') or die('Restricted access');


/**
 * @package		Joomla
 * @subpackage	Jashowcase
 */
class JashowcaseControllerJashowcase extends JashowcaseController {
	/**
	 * Constructor
	 */
	function __construct( $default = array())
	{
		parent::__construct( $default );
		$this->registerTask( 'apply', 		'save');
		$this->registerTask( 'unpublish', 	'publish');
		$this->registerTask( 'unishot' , 	'ishot' );
		$this->registerTask( 'edit', 		'form');
		$this->registerTask( 'add' , 		'form' );
	}

	/**
	 * Display the list of jashowcase
	 */
	function display() {
		$path = JashowcaseHelper::_getPathTthumbview();

		switch($this->getTask()) {
			case 'add':
  			JRequest::setVar( 'hidemainmenu', 1 );
  			JRequest::setVar( 'edit', false  );
  			JRequest::setVar('layout', 'form');
			  break;
			case 'edit':
				JRequest::setVar( 'hidemainmenu', 1 );
				JRequest::setVar( 'edit', true  );
				JRequest::setVar('layout', 'form');
			  break;
			case 'apply':
			  JRequest::setVar('layout', 'form');
			  break;
		}

		JRequest::setVar( 'path_thumbview', $path );
		JRequest::setVar('view', 'jashowcase');
		parent::display();

	}	
	
	function addTags(){
		global $mainframe;
		$model		=& $this->getModel( 'jashowcase' );
		$data 		= JRequest::getVar("data", "");
		
		$showcatID 	= JRequest::getInt("itemid", 0);
		$action 	= JRequest::getVar("action", 0);
		 
		if($model ->processAddTag($action, $showcatID, $data))
		echo $this->buildForm($model, $showcatID);
		exit();
	}
	
	/*
	 * 
	 */
	function buildForm($model, $showcatID){
		$txt  = '';
		$tags = $model->getAllTag($showcatID);
		foreach ($tags as $tag):
			$txt .= '<li id="jasc-tags'.$tag->tag_id.'" onclick="processTags(\'remove\','.$showcatID.', '.$tag->tag_id.')">'.$tag->name.'</li>';					
		endforeach;	
		return $txt;		
	}
	/**
	 * remove item
	 * @return void
	 **/
	function remove(){
		global $mainframe;
		$model	=& $this->getModel( 'jashowcase' );
       	if(!$count=$model->delete()){
	    	return  false;
       	}
       	$mainframe->redirect("index.php?option=com_jashowcase", $count." deleted");
	}

	/**
	 * publish or unpublish list item
	 * @return void
	 **/
	function ishot(){
		global  $option;
		if($this->getTask()=='ishot'){
			$ishot = 1;
		}
		else{
			$ishot = 0;
		}
		$model = $this->getModel('jashowcase');
		if (!$model->doishot($ishot)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
			exit();
		}
		$cache = & JFactory::getCache('com_jashowcase');
		$cache->clean();
		$this->setRedirect('index.php?option='. $option, "Update successfully !");
	}

	/**
	 * publish or unpublish list item
	 * @return void
	 **/
	function publish(){
		global  $option;
		if($this->getTask()=='unpublish'){
			$publish = 0;
		}
		else{
			$publish = 1;
		}

		$model = $this->getModel('jashowcase');

		if (!$model->dopublish($publish)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
			exit();
		}
		$cache = & JFactory::getCache('com_jashowcase');
		$cache->clean();
		$this->setRedirect('index.php?option='. $option, "Update successfully !");
	}

	/**
	 * Save the new order given by user
	 */
	function saveorder(){
		global $mainframe, $option;
		$model	=& $this->getModel( 'jashowcase' );
		if(!$model->order()){
			return false;
		}
		$mainframe->redirect( 'index.php?option='. $option , "New ordering saved");
	}

	/**
	 * cancel save item
	 * @return void
	 **/
	function cancel(){
		global $option;
		$this->setRedirect("index.php?option=$option");
	}

	/**
	 * save item
	 * @return void
	 **/
	function save(){
		global $option, $mainframe;		
		$cache = & JFactory::getCache('com_jashowcase');
		$cache->clean();

		$model	=& $this->getModel( 'jashowcase' );

		$post	= JRequest::get('post');

		$paramsField	= JRequest::getVar( 'params', null, 'post', 'array' );
		$data = '';
		// Build parameter INI string
		if ($paramsField)
		{
			//jimport('joomla/base/object');
			$params = new JParameter('');
			$data = array();
			foreach ($paramsField as $k => $v) {
				$params->set($k, $v);
			}
			$data = $params->toString();
		}

		$post['datas'] = $data;		
		if($post['info_component']== "com_content"){
			if (!isset($post['info_url'])) {
				$post['info_url'] = '';
			}	
		}else{	
					
			if (!isset($post['info_k2_url'])) {
				$post['info_url'] = '';
			}else{
				$post['info_url'] = $post['info_k2_url'];
			}	
		}		
		
		if (!isset($post['other_info_url'])) {
			$post['other_info_url'] = '';
		}

		// allow name only to contain html
		$post['name'] = JRequest::getVar( 'name', '', 'post', 'string', JREQUEST_ALLOWHTML );

		if(isset($_FILES['file_packimage']['name']) && $_FILES['file_packimage']['name']!=''){
			//upload and unpack ZIP file to success.
			$nameFileZip = basename($_FILES['file_packimage']['name']);
			$msgUp = $this->_doUpload($post['override'], $nameFileZip);
			if($msgUp!='' && !is_array($msgUp)){

			}
			else{
				$post['directory'] = $msgUp[0];
			}
		}

		$model->setState( 'request', $post );

		if ($id = $model->store($post)) {			
			$model->processAddTag($id);
			$msg = JText::_( 'Item item Saved' );
		} else {
			$msg = JText::_( 'Error Saving Item' );
		}
		if($msgUp!='' && !is_array($msgUp)){
			JError::raiseWarning( 500, $msgUp);
			return $this->setRedirect("index.php?option=".$option."&task=edit&view=jashowcase&cid=".$id, $msg);
		}
		switch ($this->getTask()=='apply'){
		  case 'apply':
			$this->setRedirect("index.php?option=".$option."&task=edit&view=jashowcase&cid[]=".$id, $msg);
			break;
		  default:
			$this->setRedirect("index.php?option=".$option."&view=jashowcase",  $msg);
			break;
		}
	}

	/**
	 *
	 * @param string The class name for the installer
	 */
	function _doUpload($override, $nameFileZip)
	{
		if(strtolower(substr($nameFileZip, strlen($nameFileZip)-3, 3))!='zip'){
			return JText::_('WARNINSTALLZLIB');
		}

		$directory = $_FILES['file_packimage']['name'];
		$path = JPATH_ROOT.DS.JashowcaseHelper::_getPathTthumbview();

		$path_temp = dirname(JPATH_BASE).DS."images/stories/temp_jashowcase"."/";
		if (!is_dir($path_temp)) {
			JFolder::create($path_temp);
		}

		$tmp_dest = $path_temp .$directory;

		// Get the uploaded file information
		$userfile = JRequest::getVar('file_packimage', null, 'files', 'array' );

		// Make sure that file uploads are enabled in php
		if (!(bool) ini_get('file_uploads')) {
			return JText::_('not to allow HTTP file uploads');
		}

		// Make sure that zlib is loaded so that the package can be unpacked
		if (!extension_loaded('zlib')) {
			return JText::_('WARNINSTALLZLIB');
		}

		// If there is no uploaded file, we have a problem...
		if (!is_array($userfile) ) {
			return JText::_('No file selected');
		}

		// Check if there was a problem uploading the file.
		if ( $userfile['error'] || $userfile['size'] < 1 )
		{
			return JText::_('Was upload error');
		}

		// Build the appropriate paths
		$tmp_src	= $userfile['tmp_name'];

		// Move uploaded file
		jimport('joomla.filesystem.file');

		$uploaded = JFile::upload($tmp_src, $tmp_dest);

		if(!$uploaded) {
			return JText::_('Upload false');
		}

		// Unpack the downloaded package file
		$package = Unpackage::unpackzip($tmp_dest);
		if(!$package){
			return JText::_('Was unpack');
		}

		//delete zip file
		JFile::delete($tmp_dest);

		//move files uploaded to stories/showcase if FORDER NOT EXITS
		$folder_uploaded = JFolder::folders($path_temp);
		
		if ($folder_uploaded) {
						
			if(substr($path,-1) != "/" || substr($path,-1) != "\\"){				
					$path = $path."/";
			}
			
			$path_folder = $path.$folder_uploaded[0];						
			if (file_exists($path_folder)){
				if ($override==0) {
					JFolder::delete($path_temp);
					return JText::_("THIS FOLDER ALREADY EXITS");
				}
				elseif ($override==2){
					JFolder::delete($path_folder);
				}
			}
			JFolder::copy($path_temp.$folder_uploaded[0], $path.$folder_uploaded[0],'', true);

			//delete file tem
			JFolder::delete($path_temp);
		}
		else{
			//delete file tem
			JFolder::delete($path_temp);
			return JText::_("FOLDER_IS_EMPTY");
		}

		return array($folder_uploaded[0]);
	}

}

jimport('joomla.installer.helper');
class Unpackage extends JInstallerHelper{

	function unpackzip($p_filename)
	{
		// Path to the archive
		$archivename = $p_filename;

		// Temporary folder to extract the archive into
		$tmpdir = '';ob_start();

		// Clean the paths to use for archive extraction
		$extractdir = JPath::clean(dirname($p_filename));
		$archivename = JPath::clean($archivename);

		// do the unpacking of the archive
		$result = JArchive::extract( $archivename, $extractdir);

		if ( $result === false ) {
			return false;
		}
		return true;
	}
}
?>