<?php
/*
# ------------------------------------------------------------------------
# JA Amazon S3 for joomla 16
# ------------------------------------------------------------------------
# Copyright (C) 2004-2009 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
# @license - Copyrighted Commercial Software
# Author: J.O.O.M Solutions Co., Ltd
# Websites:  http://www.joomlart.com -  http://www.joomlancers.com
# This file may not be redistributed in whole or significant part.
# ------------------------------------------------------------------------
*/

// no direct access
defined ( '_JEXEC' ) or die ( 'Restricted access' );

defined('JPATH_BASE') or die();

jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.archive');
jimport('joomla.filesystem.path');

class jaAmazonS3ControllerProfile extends jaAmazonS3Controller {

	function __construct($default = array()) {

		parent::__construct ( $default );
		
		$this->_checkUserState();
		
		$task = JRequest::getWord ( 'task', '' );
		switch ($task) {
			case 'add' :
			case 'save' :
			case 'apply' :
			case 'edit' :
				JToolBarHelper::apply ();
				JToolBarHelper::save ();
				JToolBarHelper::cancel ();
				break;
			default :
			    // Add a popup configuration button
				JToolBarHelper::addNew();
				JToolBarHelper::deleteList(JText::_("DO_YOU_REALLY_WANT_TO_DELETE_PROFILE"));
			    JToolBarHelper::preferences(JACOMPONENT, 250, 570);
				break;
		}
		// Register Extra tasks
		JRequest::setVar ( 'view', 'profile' );
		$this->registerTask ( 'add', 'edit' );
		$this->registerTask ( 'apply', 'save' );
		$this->registerTask ( 'delete', 'remove' );
		$this->registerTask ( 'publish', 'setDefault' );
	}
	
	function _checkUserState() {
		$model	=& $this->getModel('profile');
		$lists = $model->_getVars_admin ();
		return true;
	}

	function display() {

		$user = JFactory::getUser ();
		$task =$this->getTask();
		switch ($task){
			case 'edit':
				JRequest::setVar ( 'layout', 'form' );
				break;
		}
		if ($user->id == 0) {

			JError::raiseWarning ( 1001, JText::_("YOU_MUST_BE_SIGNED_IN" ) );

			$this->setRedirect ( JRoute::_ ( "index.php?option=com_user&view=login" ) );

			return;
		}

		parent::display();
	}

	function cancel() {
		$this->setRedirect ( 'index.php?option='.JACOMPONENT.'&view=profile' );

		return TRUE;
	}
	function save(&$errors = '') {
		$task = $this->getTask ();

		$model	=& $this->getModel('profile');
		$post	= JRequest::get('post');

		$post['profile_name'] 	= JRequest::getString( 'profile_name', '');
		$post['site_path'] 	= JRequest::getString('site_path', '');
		$post['allowed_extension'] 	= JRequest::getString('allowed_extension', '');
		$post['site_url'] 	= JRequest::getString( 'site_url', '');
		$post['profile_acl'] 	= JRequest::getString('profile_acl', '');

		$model->setState( 'request', $post );
		$row = $model->store(true);
		if (!isset($row->id)){
			$errors = $row;
			return FALSE;

		}
		return $row;
	}
	function saveIFrame() {
		global $jauc;
		
		$post = JRequest::get ( 'request', JREQUEST_ALLOWHTML );
		$number = $post ['number'];
		$errors = array ();
		$row = $this->save ( $errors );

		$helper = new JAFormHelpers();

		if(isset($row->id)) {		
			//$this->setRedirect('index.php?option='.JACOMPONENT.'&view=profile', JText::_("SAVE_DATA_SUCCESSFULLY" ));
			$id = $row->id;
			$model	=& $this->getModel('profile');

			$item = $model->getRow2($id);

			/*$reload = 0;
			if($post['id']=='0'){
				$reload = 1;
			}*/
			$reload = 1;
			$objects [] = $helper->parseProperty ( "reload", "#reload" . $item->id, $reload );
			$objects [] = $helper->parseProperty ( "redirecturl", "#redirecturl" . $item->id, "index.php?option=".JACOMPONENT."&view=localrepo&profile_id=".$item->id );
			$objects [] = $helper->parseProperty ( "html", "#system-message", $helper->message ( 0, JText::_("SAVE_DATA_SUCCESSFULLY" ) ) );

			if(!$reload){
				$objects [] = $helper->parseProperty ( "html", "#profile_name" . $item->id, $item->profile_name );
				$objects [] = $helper->parseProperty ( "html", "#site_path" . $item->id, $item->site_path );
				$objects [] = $helper->parseProperty ( "html", "#allowed_extension" . $item->id, $item->allowed_extension );
				$objects [] = $helper->parseProperty ( "html", "#site_url" . $item->id, $item->site_url );
			}
		} else {
			$objects [] = $helper->parseProperty ( "html", "#system-message", $helper->message ( 1, $errors ) );
		}
		$data = "({'data':[";

		$data .= $helper->parse_JSON ( $objects );

		$data .= "]})";

		echo '
		<script type="text/javascript">
			jacFormHideIFrame();
        	parseData_admin('.$data.');
		</script>
		';
	}
	
	function saveConfig() {
		if(count($_POST)) {
			$post = JRequest::get ( 'request', JREQUEST_ALLOWHTML );
			$number = $post ['number'];
			$errors = array ();
			$row = $this->save ( $errors );
	
			$backUrl = JRequest::getVar('backUrl', '');
			if(!empty($backUrl)) {
				$backUrl = urldecode($backUrl);
				$this->setRedirect ( $backUrl);
			} else {
				$this->setRedirect ('index.php?option='.JACOMPONENT.'&view=profile');
			}
		}
	}

	function saveorder() {
		$model = $this->getModel ( 'profile' );
		$msg = '';
		if (! $model->saveOrder ()) {
			JError::raiseWarning ( 1001, JText::_('ERROR_OCCURRED_DATA_NOT_SAVED' ) );
		} else {
			$msg = JText::_('SAVE_DATA_SUCCESSFULLY' );
		}
		$this->setRedirect ( 'index.php?option='.JACOMPONENT.'&view=profile', $msg );
	}

	function setDefault() {
		$model = $this->getModel ( 'profile' );
		$createdate = JRequest::getInt('createdate',0);
		if (! $model->setDefault ( 1 )) {
			JError::raiseWarning ( 1001, JText::_('ERROR_OCCURRED_DATA_NOT_SAVED' ) );
		} else {
			$msg = JText::_('SAVE_DATA_SUCCESSFULLY' );
		}
		$link = 'index.php?option='.JACOMPONENT.'&view=profile';
		if($createdate) $link.="&createdate=".$createdate;
		$this->setRedirect ( $link, $msg );
	}

	function remove() {
		$model = $this->getModel ( 'profile' );
		$cids = JRequest::getVar ( 'cid', null );
		$error = array ();
		foreach ( $cids as $cid ) {
			if (! $model->delete ( $cid )) {
				$error = $cid;
			} else {
			}
		}
		if (count ( $error ) > 0) {
			$err = implode ( ",", $error );
			JError::raiseWarning ( 1001, JText::_('ERROR_OCCURRED_UNABLE_TO_DELETE_THE_ITEMS_WITH_ID' ).': ' . " [$err]" );
		} else
		$msg = JText::_("DELETE_DATA_SUCCESSFULLY" );
		$this->setRedirect ( 'index.php?option='.JACOMPONENT.'&view=profile', $msg );
	}
	
	function import() {
		$model = $this->getModel ( 'profile' );
		$result = $model->import();
		$msg = ($result === false) 
				? JText::_("ERROR_OCCURRED_DURING_IMPORT_PROFILE_LIST_FROM_S3") 
				: JText::_("SUCCESSFULLY_IMPORT_PROFILE_LIST_FROM_S3");
		$this->setRedirect ( 'index.php?option='.JACOMPONENT.'&view=profile', $msg );
	}
}
?>