<?php 
/*
# ------------------------------------------------------------------------
# JA Showcase component for Joomla 1.5
# ------------------------------------------------------------------------
# Copyright (C) 2004-2010 JoomlArt.com. All Rights Reserved.
# @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
# Author: JoomlArt.com
# Websites: http://www.joomlart.com - http://www.joomlancers.com.
# ------------------------------------------------------------------------
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

class JElementJasccategory extends JElement
{
	/*
	 * Category name
	 *
	 * @access	protected
	 * @var		string
	 */
	var	$_name = 'Jascategory';
	
	var $_controlName = '';
	/**
	 * fetch Element 
	 */
	function fetchElement($name, $value, &$node, $control_name){
		$this->_controlName = $name; 
		
		$_title		= ( isset( $node->_attributes['title'] ) ) ? $node->_attributes['title'] : 'SELECT ALL';
		$multiple 	= !( isset( $node->_attributes['notmultiple'] ) ) ? ' multiple="multiple" ' : '';
	
		$categories=array();
		$categories[0]->id = '0';
		$categories[0]->name = JText::_($_title	);
		
		$categoriesq = $this->getCategorieTree();
		

		$categories= array_merge($categories,$categoriesq);
	

		$out = JHTML::_('select.genericlist',  $categories, ''.$control_name.'['.$name.'][]', 'class="inputbox" style="width:95%;" '.$multiple.' size="10"', 'id', 'name', $value );

		return $out;
	}
	
	function getCategorieTree($published_only = false){
		global $mainframe;
	
		$cid  = JRequest::getVar( 'cid', array(0), '', 'array' );
	
		$db		=& JFactory::getDBO();
		$query = "SELECT * FROM #__jasc_categories";
		$where = array();
		if($published_only){
		  $where[] = " published = 1 ";
		}
	
		if (!empty($cid[0])) {
		  $where[] = " id <> {$cid[0]}";
		}
	
		$where = count($where) ? ' WHERE ' . implode(' AND ', $where) : '';
	
		$query .= "$where ORDER BY parent_id, title";
		$db->setQuery($query);
		$rows = $db->loadObjectList();
	
		echo $db->getErrorMsg();
	
		$level = 0;
		$tree = array();
		//sort by parent
		for($i=0,$n=count($rows);$i<$n;$i++){
		  $row = $rows[$i];
	
		  $tree[$row->parent_id][] = $row;
		}
	
		$final = array();
		$level = 0;
		//loop through all items
		if(isset($tree[0]) && count($tree[0]) > 0){
		  for($i=0,$n=count($tree[0]);$i<$n;$i++){
			$row = $tree[0][$i];
			$this->buildCategoriesTree($tree, $final, $row, $level, 0);
		  }
		}
		return $final;
	  }
	
	  function buildCategoriesTree($rows, &$tree, $row, $level, $type=1){
		$name = '';
	
		$spacer = '<sup>.</sup>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
		$pre = '<sup>|_</sup>&nbsp;&nbsp;';
	
		if (!$type) {
		  $spacer = '&nbsp;&nbsp;';
		  $pre = '-&nbsp;';
		}
	
		for($i=1;$i<$level;$i++){
		  $name .= $spacer;
		}
	
		if($level != 0){
		  $name = $spacer . $name;
		} else {
		  $pre = '';
		}
	
		$row->name = $name . $pre . $row->title;
	
		$tree[] = $row;
	
		if(@sizeof($rows[$row->id]) && $row->id != 0){
		  for($i=0,$n=count($rows[$row->id]);$i<$n;$i++){
			$child = $rows[$row->id][$i];
			$this->buildCategoriesTree($rows, $tree, $child, $level + 1);
		  }
		}
	
	  }
}

?>
