<?php 
/**
 * ------------------------------------------------------------------------
 * JA Showcase component for Joomla 1.7
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - Copyrighted Commercial Software
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites:  http://www.joomlart.com -  http://www.joomlancers.com
 * This file may not be redistributed in whole or significant part.
 * ------------------------------------------------------------------------
 */

class JashowcaseHelper {
	function getlistFolder($path){
		$listObj = array();
		
		if (JFolder::exists($path)){
			$list = JAFolder::jaListFolderTree($path, '.');
			if ($list) {
				foreach ($list as $k=>$folder){
					$obj = new stdClass;										
					$space = '';
					for ($i=0; $i<$folder['level']; $i++){
						$space .= ' -- ';
					}
					$parent = '';	
					if ($space!='') {
						$parent = $listObj[$folder['parent']-1]->value.'/';						
					}
					
					$obj->value = $parent.$folder['name'];
					$obj->text  = $space.$folder['name'];
					
					$listObj[] = $obj;					
				}
			}
		}
		return $listObj;
	}
	
	function parse_JSON($objects) {
		if (! $objects)
			return;
		$db = JFactory::getDBO ();
		
		$html = '';
		$item_tem = array ();
		foreach ( $objects as $i => $row ) {
			$tem = array ();
			$item_tem [$i] = '{';
			foreach ( $row as $k => $value ) {
				//$value = $db->Quote($value);
				$tem [$i] [] = "'$k' : " . $db->Quote ( $value ) . "";
			}
			$item_tem [$i] .= implode ( ',', $tem [$i] );
			$item_tem [$i] .= '}';
		}
		
		if ($item_tem)
			$html = implode ( ',', $item_tem );
		
		return $html;
	}
	
	function getTemplate($client_id = 0) {		
		// Load the template name from the database
		$db = & JFactory::getDBO ();
		$query = 'SELECT template FROM #__template_styles WHERE client_id = ' . $client_id . ' AND home = 1';
		$db->setQuery ( $query );
		$template = $db->loadResult ();
		$template = JFilterInput::clean ( $template, 'cmd' );		
		
		return $template;
	}
	
	function _getSetting(){
		$myParams = JComponentHelper::getParams('com_jashowcase');
		$_params = new JRegistry;
		$_params->loadObject($myParams->get('params'));
		return $_params;
	}
	
	/**
	 * return path base
	 *
	 */
	function _getPathTthumbview($params=''){
		$path = '';		
		if(!$params)
			$params = JashowcaseHelper::_getSetting();
			
		if($params->get('use_path_thumb-input-general_path_thumb')==''){
			$path	= $path.'images/sampledata';
		}
		else {
			$path .= $params->get('use_path_thumb-input-general_path_thumb');
		}
		return $path;
	}
	/**
	 *
	 */
	/**
	 *
	 * @param string The class name for the installer
	 */
	function _doUpload($override, $nameFileZip)
	{
		
	}
	 
	/**
	 * Checks if the file is an image
	 * @param string The filename
	 * @return boolean
	 */
	function isImage( $fileName ) {
		static $imageTypes = 'xcf|odg|gif|jpg|png|bmp';
		return preg_match("/$imageTypes/i",$fileName);
	}
	
	
	function uploadImage( $source, $des ){
	
		if( !JashowcaseHelper::isImage($source['name']) ){
			return JText::_('PLEASE_CHOOSE_FILE_IS_IMAGE');
		}
		
		// Move uploaded file
		
		jimport('joomla.filesystem.file');
		
		$uploaded = JFile::upload( $source['tmp_name'], $des );
		
		if(!$uploaded) {
			return JText::_('UPLOAD_FALSE');
		}
		
		return false;
	}
}

class JAFolder extends JFolder {
	function jaListFolderTree($path, $filter, $maxLevel = 3, $level = 0, $parent = 0)
	{
		$dirs = array ();
		if ($level == 0) {
			$GLOBALS['_JFolder_folder_tree_index'] = 0;
		}
		if ($level < $maxLevel) {
			$folders = JFolder::folders($path, $filter);
			// first path, index foldernames
			for ($i = 0, $n = count($folders); $i < $n; $i ++) {
				$id = ++ $GLOBALS['_JFolder_folder_tree_index'];
				$name = $folders[$i];
				$fullName = JPath::clean($path.DS.$name);

				$dirs[] = array ('id' => $id, 'parent' => $parent, 'level'=>$level, 'name' => $name);
				$dirs2 = JAFolder::jaListFolderTree($fullName, $filter, $maxLevel, $level +1, $id);
				$dirs = array_merge($dirs, $dirs2);
			}
		}
		return $dirs;
	}
}
?>