<?php
/**
 * ------------------------------------------------------------------------
 * JA Showcase component for Joomla 1.7
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - Copyrighted Commercial Software
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites:  http://www.joomlart.com -  http://www.joomlancers.com
 * This file may not be redistributed in whole or significant part.
 * ------------------------------------------------------------------------
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport('joomla.application.component.model');

/**
 * Hello Hello Model
 *
 * @package    Joomla.Tutorials
 * @subpackage Components
 */
class jashowcaseModelJacategories extends JModel
{
	/**
	 * category id
	 *
	 * @var int
	 */
	var $_id = null;

	/**
	 * category data
	 *
	 * @var array
	 */
	var $_data = null;

	var $_categories = null;

	/**
	 * Constructor
	 *
	 * @since 1.5
	 */

	function __construct()
	{
		parent::__construct();

		$array = JRequest::getVar('cid', array(0), '', 'array');
		$edit	= JRequest::getVar('edit',true);
		if($edit)
			$this->setId((int)$array[0]);
	}

	/**
	 * Method to set the Category identifier
	 *
	 * @access	public
	 * @param	int Category identifier
	 */
	function setId($id)
	{
		// Set weblink id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}


	function getCategories($isShortList = false) {
	  if (empty($this->_categories)) {
	    if ($isShortList) {
	      $query = 'SELECT id, title as name FROM #__jasc_categories'.
	                ' WHERE id <> '.(int)$this->_id;
	    } else {
	      $query = 'SELECT * FROM #__jasc_categories';//.
	    }
//	    var_dump($query);
	    $this->_db->setQuery($query);
	    $this->_categories = $this->_db->loadObjectList();
	  }
	  if (!$this->_categories) {
	    $this->_categories = array();
	  }

	  return $this->_categories;
	}

	/**
	 * Method to get a hello
	 * @return object with data
	 */
	function &getData()
	{
		if (!$this->_loadData())
		{
			// Initialize some variables
			$this->_initData();
		}
		return $this->_data;
	}

	function _loadData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$query = 'SELECT * FROM #__jasc_categories'.
					'  WHERE id= '.(int) $this->_id;
			$this->_db->setQuery($query);
			$this->_data = $this->_db->loadObject();
			return (boolean) $this->_data;
		}
		return true;
	}

	/**
	 * Method to initialise the category data
	 *
	 * @access	private
	 * @return	boolean	True on success
	 * @since	1.5
	 */
	function _initData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$this->_data = new stdClass();
			$this->_data->id           = 0;
        	$this->_data->title        = null;
        	$this->_data->alias        = null;
        	$this->_data->parent_id    = null;
        	$this->_data->description  = null;
        	$this->_data->published    = null;
        	$this->_data->ordering     = null;
        	$this->_data->access       = null;
        	$this->_data->thumbnail     = null;
			return (boolean) $this->_data;
		}
		return true;
	}

	/**
	 * Method to store a record
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */
	function store()
	{
		$row =& $this->getTable();

		$data = JRequest::get( 'post' );

		// Bind the form fields to the hello table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		if(!$row->id){
		  $row->ordering = 0;
		}

		// avoid linking category to itself
		if($row->parent_id == $row->id){
		  $row->parent_id = 0;
		}

//		$row->section = 'com_jashowcase';

		$row->published = JRequest::getVar('published', 0);
		if (!$row->check()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			return false;
		}
		// Store the web link table to the database
		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			return false;
		}

		return $row->id;
	}

	function delete($cid = null)	{
		if ($cid != null) {
			$query = "DELETE FROM #__jasc_categories WHERE id = $cid";
			$this->_db->setQuery( $query );
			if(!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}

		return true;
	}

	function order(){
		$row =& $this->getTable();
		$cid 		= JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger($cid, array(0));
		$total		= count( $cid );
		$order		= JRequest::getVar( 'order', array(0), 'post', 'array' );
		JArrayHelper::toInteger($order, array(0));

		// update ordering values
		for( $i=0; $i < $total; $i++ )
		{
			$row->load( (int) $cid[$i] );
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					JError::raiseError(500, $db->getErrorMsg() );
				}
			}
		}
		$row->reorder();
		return true;
	}

	function dopublish($publish) {
		$db		=& JFactory::getDBO();
		$cid = JRequest::getVar('cid', 0);

		if (!is_array( $cid ) || count( $cid ) < 1) {
			echo "<script> alert('Select a module to $action'); window.history.go(-1);</script>\n";
			exit;
		}

		$cids = implode( ',', $cid );
		$query = "UPDATE #__jasc_categories SET published='$publish' WHERE id IN ($cids)";

		$db->setQuery( $query );
		if (!$db->query()) {
			return false;
		}
		return true;
	}

	function _getTotalCategories($id){
		$db		=& JFactory::getDBO();
		$query = "SELECT COUNT(1) FROM #__jasc_categories WHERE parent_id = $id";
		$db->setQuery($query);
		$total = $db->loadResult();
		return $total;
	}

	function _getTotalShowcase($id){
		$db		=& JFactory::getDBO();
		$query = "SELECT COUNT(1) FROM #__jashowcase WHERE catid = $id";
		$db->setQuery($query);
		$total = $db->loadResult();
		return $total;
	}
}
?>