<?php
/**
 * Hello Model for Hello World Component
 * 
 * @package    Joomla.Tutorials
 * @subpackage Components
 * @link http://dev.joomla.org/component/option,com_jd-wiki/Itemid,31/id,tutorials:components/
 * @license		GNU/GPL
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport('joomla.application.component.model');

/**
 * Hello Hello Model
 *
 * @package    Joomla.Tutorials
 * @subpackage Components
 */
class jashowcaseModelJashowcase extends JModel
{
	/**
	 * category id
	 *
	 * @var int
	 */
	var $_id = null;

	/**
	 * category data
	 *
	 * @var array
	 */
	var $_data = null;
	
	/**
	 * Constructor that retrieves the ID from the request
	 *
	 * @access	public
	 * @return	void
	 */
	function __construct()
	{
		parent::__construct();

		$array = JRequest::getVar('cid',  0, '', 'array');//print_r($_REQUEST);
		$this->setId((int)$array[0]);
	}

	/**
	 * Method to set the hello identifier
	 *
	 * @access	public
	 * @param	int Hello identifier
	 * @return	void
	 */
	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}


	/**
	 * Method to get a hello
	 * @return object with data
	 */
	function &getData()
	{
		// Load the data
		if (!$this->_loadData())
		{
			// Initialize some variables
			$this->_initData();
		}		
		return $this->_data;
	}
	function _loadData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$query = 'SELECT * FROM #__jashowcase'.
					'  WHERE id= '.(int) $this->_id;
					
			$this->_db->setQuery($query);
			$this->_data = $this->_db->loadObject();
			return (boolean) $this->_data;
		}
		return true;
	}
	/**
	 * Method to initialise the category data
	 *
	 * @access	private
	 * @return	boolean	True on success
	 * @since	1.5
	 */
	function _initData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$this->_data = new stdClass();
			$this->_data->id = 0;
			$this->_data->ishot = 0;
			$this->_data->name			= null;
			$this->_data->description 	= null;
			$this->_data->published 		= 0;
			$this->_data->thumbnail   	= null;
			$this->_data->info_component   	= null;
			$this->_data->info_url  		= null;
			$this->_data->other_info_url  		= null;
			$this->_data->demo_url  		= null;
			$this->_data->ordering  		= null;
			$this->_data->catid  		= null;		
			$this->_data->datas  		= null;			
			$this->_data->directory  	= null;
			$this->_data->date_released  	= null;			
			return (boolean) $this->_data;
		}
		return true;
	}
	
	/*
	 * 
	 */
	function processAddTag($showcase_id){
		$db		=& JFactory::getDBO();
		$arrayTags = JRequest::getVar("jasctags", array());		
		//first delete all
		$query = 'DELETE FROM #__jashowcase_tags WHERE showcase_id='.(int)$showcase_id;		
		$this->_db->setQuery( $query );
		$this->_db->query();
		
		//get all tags
		$arrayTags = JRequest::getVar("jasctags", array());
		if($arrayTags){
			$table =& $this->getTable('jatags');
			foreach( $arrayTags as $item ){							
				$pk = 0;
				$row = $this->findTagByName( trim($item) );
				if( is_object($row) ){
					$pk = $row->id;
				} else {
					$table->bind( array( 'name' => $item ) );
					// Store the web link table to the database
					if ( $table->store()) {
						$pk  = $table->id;		
					}
				}
				// add
				if( $pk > 0 ){
					$query = ' INSERT INTO #__jashowcase_tags(tag_id, showcase_id) VALUES("'.$pk.'","'.$showcase_id.'") ';
					$this->_db->setQuery( $query );
					if(!$this->_db->query()){
						return false;
					}
				}
			}
		}		
		
		return true;	
	}
	
	/**
	  * find tag  existed.
	  */  
	function findTagByName( $name ){
		

		$query = ' SELECT id FROM #__jatags WHERE name LIKE "'.$name.'"';
		$this->_db->setQuery( $query );
		$row = $this->_db->loadObject();
		return $row;
	}	
	
	/*
	 * get tag of item
	 */
	function getAllTag($itemid){
		$db		=& JFactory::getDBO();
		
		$query = "SELECT a.tag_id,j.name"
		. "\n FROM #__jashowcase_tags AS a"
		. " INNER JOIN #__jatags j ON j.id = a.tag_id"		
		. "\n WHERE showcase_id = ".$itemid;
		$db->setQuery( $query );		
		$contents = $db->loadObjectList( );

		return $contents;	
	}
	
	/**
	 * Method to store a record
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */
	function store($data)
	{
		$row =& $this->getTable();
				
		// Bind the form fields to the hello table
		if (!$row->bind($data)) {
			echo "<script> alert('" . $row->getError() . "'); window.history.go(-1); </script>\n";
			return false;
		}
			 
		// Make sure the hello record is valid
		if (!$row->check()) {
			 echo "<script> alert('" . $row->getError() . "'); window.history.go(-1); </script>\n";
			return false;
		}
		
		// Store the web link table to the database
		if (!$row->store()) {
			echo "<script> alert('" . $row->getError() . "'); window.history.go(-1); </script>\n";
			return false;
		}
		return $row->id;
	}

	/**
	 * Method to delete record(s)
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */
	function delete()
	{
		$ids = JRequest::getVar( 'cid', array(0), 'post', 'array' );

		$row =& $this->getTable();		
		$k=0;
		if (count( $ids ))
		{
			foreach($ids as $id) {
				$item = $this->getData();
				$thum	= $item->thumbnail;				
				if (!$row->delete( $id )) {
					$this->setError( $row->getErrorMsg() );
					return false;
				}
				else if($thum != ''){
					$path	= '../images/sampledata/jashowcase/';
					$dirThum = substr($thum, 0, strlen($thum)-4);
					
					if (file_exists($path.$thum)) {
						jimport('joomla.filesystem.file');
						JFile::delete($path.$thum);
					}
					if (file_exists($path.$dirThum)) {
						jimport('joomla.filesystem.folder');
						JFolder::delete($path.$dirThum);
					}
				}
				$k++;
			}						
		}
		return $k;
	}
	
	function getItems($xQuery = '') {
		$query = "SELECT s.* FROM #__jashowcase as s WHERE 1=1".$xQuery;
		$this->_db->setQuery($query);	
		return $this->_db->loadObjectList();
	}
	
	function order(){
		$row =& $this->getTable();		
		$cid 		= JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger($cid, array(0));		
		$total		= count( $cid );
		$order		= JRequest::getVar( 'order', array(0), 'post', 'array' );
		JArrayHelper::toInteger($order, array(0));
		
		// update ordering values
		for( $i=0; $i < $total; $i++ )
		{
			$row->load( (int) $cid[$i] );
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					JError::raiseError(500, $db->getErrorMsg() );
				}
			}
		}
	
		$row->reorder();
		return true;
	}	
	
	/*
	 * get data from content 
	 */	
	function _getContents($component = "com_content",$db){
		if($component == "com_content"){
			$query = "SELECT a.id AS value, a.title AS text, c.title as cattitle "
			. "\n FROM #__content AS a"
			. "\n LEFT JOIN #__categories AS c ON a.catid = c.id"			
			. "\n WHERE a.state = 1"
			. "\n ORDER BY a.catid, a.title"
			;
			$db->setQuery( $query );									
			$contents = $db->loadObjectList( );			
		}else{			         
			$query = "SELECT i.id AS value, i.title AS text,c.name AS category"
			. "\n FROM #__k2_items AS i"
			. "\n LEFT JOIN #__k2_categories AS c"
			. "\n ON c.id = i.catid ORDER BY c.id, i.id";
			
			$db->setQuery( $query );			
			$contents = $db->loadObjectList( );
		}
		return $contents;
	}	
	/*
	 * 
	 */
	function _getTitleContent($id, $db){
		$query = "SELECT s.title"
				. "\n FROM #__sections AS s"
				. "\n WHERE s.scope = 'content'"
				. "\n AND s.id = '$id'"
				;
		$db->setQuery( $query );
		$section = $db->loadResult();
		return $section;
	}
	
	function _getContentCatTitle($id, $db){
		$query = "SELECT c.title"
				. "\n FROM #__categories AS c"
				. "\n WHERE c.id = $id"
				;
		$db->setQuery( $query );
		$category = $db->loadResult();
		return $category;
	}
	
	function _getTitleCategories($id, $db){
		$query = "SELECT c.title"
				. "\n FROM #__jasc_categories AS c"
				. "\n WHERE c.id = $id"
				;
		$db->setQuery( $query );
		$category = $db->loadResult();
		return $category;
	}
	
	function _getStaticContents($db){
		$query = "SELECT a.id AS value, a.title AS text "
		. "\n FROM #__content AS a"
		. "\n WHERE a.sectionid = 0"
		. "\n AND a.catid = 0"
		. "\n AND a.state != -2"
		;
		$db->setQuery( $query );
		$static_contents = $db->loadObjectList( );
		return $static_contents;
	}
	function _getCategoriesJashowcase($db){
		$query = "	SELECT id AS value, title AS text 
					FROM #__jasc_categories
					ORDER BY ordering";				
		$db->setQuery( $query );
		$categoriesJashowcase = $db->loadObjectList();
		return $categoriesJashowcase;
	}
	
	function dopublish($publish){
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();

		$id = JRequest::getVar('cid', 0);
		JArrayHelper::toInteger($id, array(0));

		$ids = implode( ',', $id );
		
		$query = "UPDATE #__jashowcase"
		. "\n SET published = " . intval( $publish )
		. "\n WHERE id IN ( $ids )"
		;
		$db->setQuery( $query );
		if (!$db->query()) {
			return false;
		}
		return true;
	}
	
	function doishot($ishot){
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();

		$id = JRequest::getVar('cid', 0);
		JArrayHelper::toInteger($id, array(0));

		$ids = implode( ',', $id );
		
		$query = "UPDATE #__jashowcase"
		. "\n SET ishot = " . intval( $ishot )
		. "\n WHERE id IN ( $ids )"
		;
		$db->setQuery( $query );
		if (!$db->query()) {
			return false;
		}
		return true;
	}
	
	function _getlistFolder($path){
		$listObj = array();
		
		if (JFolder::exists($path)){
			$list = JAFolder::jaListFolderTree($path, '.');			
			if ($list) {
				foreach ($list as $k=>$folder){
					$obj = new stdClass;										
					$space = '';
					for ($i=0; $i<$folder['level']; $i++){
						$space .= '--';
					}
					$parent = '';	
					if ($space!='') {
						$parent = $listObj[$folder['parent']-1]->value.'/';						
					}
					
					$obj->value = $parent.$folder['name'];
					$obj->text  = $space.$folder['name'];
					
					$listObj[] = $obj;					
				}
			}
		}		
		return $listObj;
	}
		
	
	function _getlistFile($path){
		$listObj = array();
		if (JFolder::exists($path)) {
			$list = JFolder::files($path);											
			if ($list) {				
				foreach ($list as $k=>$value){										
					$typeFile = strtolower(substr($value,-3));									
					if($typeFile == "bmp" || $typeFile == "dib" || $typeFile == "jpg" || $typeFile == "jpeg" || $typeFile == "jpe" || $typeFile == "jfif" || $typeFile == "gif" || $typeFile == "tif" || $typeFile == "tiff" || $typeFile == "png"){
						$obj = new stdClass;
						$obj->value = $value;
						$obj->text  = $value;					
						$obj->disable = '';
						$listObj[] = $obj;
					}
				}
			}
		}
		
		return $listObj;
	}
}
?>
