DROP TABLE IF EXISTS `#__janews_frontpage`, `#__janews_sections`, `#__janews_templates`;
DELETE FROM `#__menu` WHERE `menutype`='janews';
DELETE FROM `#__menu_types` WHERE `menutype`='janews';
-- 
-- Table structure for table `#__janews_frontpage`
-- 

CREATE TABLE `#__janews_frontpage` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `headline` varchar(255) NOT NULL default '',
  `blog` varchar(255) NOT NULL default '',
  `sections` text NOT NULL,
  `default_f` int(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Table structure for table `#__janews_sections`
-- 

CREATE TABLE `#__janews_sections` (
  `secid` int(11) unsigned NOT NULL,
  `categories` text NOT NULL,
  `headline` int(11) NOT NULL default '0',
  `blog` int(11) NOT NULL default '0',
  `params` text NOT NULL,
  PRIMARY KEY  (`secid`),
  KEY `headline` (`headline`),
  KEY `blog` (`blog`)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Table structure for table `#__janews_templates`
-- 

CREATE TABLE `#__janews_templates` (
  `id` int(11) NOT NULL auto_increment,
  `template` varchar(255) NOT NULL default '',
  `title` varchar(255) NOT NULL default '',
  `type` varchar(255) NOT NULL default '',
  `params` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `type` (`type`),
  KEY `templ` (`template`)
) TYPE=MyISAM;

-- 
-- Dumping data for table `#__janews_templates`
-- 

INSERT INTO `#__janews_templates` (`id`, `template`, `title`, `type`, `params`) VALUES 
(1, 'default', 'default headline', 'headline', 'listofhlcontent=1\nhlarticles_id=\nnumberofheadlinenews=3\nbigitems=1\nbigmaxchars=450\nbigshowimage=1\nautoresize=1\nbigalign=0\nbigimg_w=100\nbigimg_h=100\nsmallmaxchars=150\nsmallshowimage=1\nsmallalign=1\nsmallimg_w=100\nsmallimg_h=100\nshowhltitle=1\nshowhlreadmore=0'),
(2, 'slide', 'slide headline', 'headline', 'listofhlcontent=1\nhlarticles_id=\nnumberofheadlinenews=3\nheadlinelang=Headline\nshowhltools=1\nshowhltitle=1\nshowhlreadmore=1\nheadlineheight=220\nautoroll=1\ndelaytime=5'),
(3, 'groupby_sec_or_cat', 'group content blog', 'blog', 'datatype=group_by\norder=created desc\nshowcattitle=1\nintroitems=2\nlinkitems=2\nmaxchars=300\nshowimage=1\nalign=0\nautoresize=1\nwidth=100\nheight=100\ncolumns=2\nshowreadmore=0\nhiddenClasses='),
(4, 'no_group_by', 'no group content blog', 'blog', 'datatype=no_group_by\nintroitems=6\nlinkitems=2\nmaxchars=300\nshowimage=1\nalign=0\nautoresize=1\nwidth=100\nheight=100\nhiddenClasses=\ncolumns=3\nshow_create_date=1\nshow_author=1\nshow_title=1\nlink_titles=1\nshow_readmore=1\nshow_description=0\nshow_description_image=0\nshow_pagination=2\nshow_pagination_results=1');

INSERT INTO `#__menu_types` (`menutype`,`title`,`description`) VALUES ('janews', 'JA News','Real Magazine Portal');