<?php
/*
# ------------------------------------------------------------------------
# JA Amazon S3 installation Package (component & Plugin)
# ------------------------------------------------------------------------
# Copyright (C) 2004-2010 JoomlArt.com. All Rights Reserved.
# @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
# Author: JoomlArt.com
# Websites: http://www.joomlart.com - http://www.joomlancers.com.
# ------------------------------------------------------------------------
*/

// no direct access
defined ( '_JEXEC' ) or die ( 'Restricted access' ); 
?>
<fieldset>
<legend class="heading"><?php echo JText::_("HELP_AND_SUPPORT");?></legend>
<div>
<p><strong>Overview</strong></p>
<p>This component enables your <a href="http://www.joomla.org">Joomla!</a> powered website to use cloud computing and syncronize the data from your site with <strong>Amazon Cloud Servers</strong>.</p>
<p>To be able to use this component you need an <a href="http://aws.amazon.com/s3/" title="Amazon S3" target="_blank">Account</a> for <strong>Amazon S3 Service</strong> and the <a target="_blank" href="http://php.net/manual/en/book.curl.php">cURL</a> library enabled on your server.</p>
<p>Syncronization of your site with <strong>Amazon Cloud Servers</strong> is managed by the <strong>JA Amazon S3 Plugin</strong>. This plugin is installed and enabled when you install the component, but you have to make sure it is ordered just above the core <strong>Cache Plugin</strong>. <br /><a href="index.php?option=com_plugins">Click here</a> to check now.</p>
</div>
<div>
<p>&nbsp; </p>
<p><strong>Main Features</strong></p>
<ul>
<li>Amazon S3 (Simple Storage Service) - Amazon S3 provides a simple web services interface that can be used to store and retrieve any amount of data, at any time, from anywhere on the web.</li>
<li>CloudFront & CDN Support - Amazon CloudFront delivers your static and streaming content using a global network (CDN) of more than 16 locations. Requests for your objects are automatically routed to the nearest edge location, so content is delivered with the best possible performance.</li>
<li>Multiple Buckets Support - Create unlimited buckets for each and / or all media content types, link them all to clouds!</li>
<li>Cron Job Support - Depending on the file types and change frequency, set cron job every day, hour or minute!</li>
<li>Multiple Sync Profiles - Create unlimited profiles to combine settings for various file types & cron job settings, set folders to upload from, explore true power with simple administration interface.</li>
<li>Include / Exclude File Types or Extensions - Select only the file types or extensions you need to be uploaded to Amazon S3.</li>
<li>Enable / Disable Sync for specific files or folders - Select only the most important / accessed files to be uploaded to Amazon S3.</li>
<li>Multiple Amazon S3 Accounts - Each administrator of your website can use his own Amazon S3 Account.</li>
<li>Upload new & update modified files capability - The component is quite capable to detect changes made on the files so it can skip overwriting existing ones.</li>
<li>File & Folder ACL System - Set an access level for each of your file or folder.</li>
</ul>
</div>
<div>
<p>&nbsp; </p>
<p><strong>Getting Started</strong></p>
<p>Read the absolute begginers guide on <strong><em>"Getting Started with Amazon S3"</em></strong> in the <a href="http://www.joomlart.com/forums/showthread.php?46333-Getting-started-with-JA-Amazon-S3-component" title="Amazon S3" target="_blank">JA Amazon S3 Forum</a>.</p>
<p>The guide on <a href="http://www.joomlart.com/forums/forumdisplay.php?242-JA-Amazon-S3-Component" title="JA Amazon S3 Forum" target="_blank">JA Amazon S3 forum</a> provide Installation and Upgrade instructions, tips for creating new buckets, setting parent folder, updating or replacing the files on S3.</p>
<p>Paid members (JAEC / Developer) have access to support and can ask for support in the <a href="http://www.joomlart.com/forums/forumdisplay.php?242-JA-Amazon-S3-Component" title="JA Amazon S3 Forum" target="_blank">JA Amazon S3 Forum</a>.</p>
<p>&nbsp; </p>
</div>
<div>
<p>&nbsp; </p>
<p><strong>Video Tutorial</strong></p>
<object width="640" height="385"><param name="movie" value="http://www.youtube.com/v/dtknH2ljq5Q?fs=1&amp;hl=en_US"></param><param name="allowFullScreen" value="true"></param><param name="allowscriptaccess" value="always"></param><embed src="http://www.youtube.com/v/dtknH2ljq5Q?fs=1&amp;hl=en_US" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="640" height="385"></embed></object>
</div>
<div>
<p>&nbsp; </p>
<p><strong>Upgrade Guide</strong></p>
<p>We recommend uninstalling the old version and installing the new version. Please check the <a href="http://www.joomlart.com/forums/forumdisplay.php?242-JA-Amazon-S3-Component" title="JA Amazon S3 Forum" target="_blank">JA Amazon S3 Forum</a> for more information.</p>
</div>
<div>
<p>&nbsp; </p>
<p><a href="http://www.joomlart.com/joomla/extensions/ja-amazon-s3" title="JA Amazon S3 Home" target="_blank">Home</a> | <a href="http://update.joomlart.com" title="JA Updates" target="_blank">Version info &amp; Updates</a> | <a href="http://www.joomlart.com/forums/downloads.php?do=cat&id=367" title="JA Amazon S3 Downloads" target="_blank">Downloads</a> | <a href="http://pm.joomlart.com/browse/JAECCOMAMAZON" title="JA Amazon S3 JIRA" target="_blank">Changelog</a> | <a href="http://www.joomlart.com/forums/forumdisplay.php?242-JA-Amazon-S3-Component" title="JA Amazon S3 Forums" target="_blank">Forums</a></p>
</div>
</fieldset>