<?php
/**
 * Jacategories View for Jashowcase Component
 *
 * @package    	Joomla.Jashowcase
 * @subpackage 	Components
 * @link 		http://joomlart.com/extension/
 * @license		Joomlart.com
 * @author 		Joomlart.com
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view' );

/**
 * Jacategories View
 *
 * @package    Joomla.Jashowcase
 * @subpackage Components
 */
class jashowcaseViewjacategories extends JAView
{

  /**
   * display method of jacategories view
   * @return void
   **/
  function display($tpl = null)	{
    $task = JRequest::getVar('task');

    switch ($task){
      case 'edit':
		$this->displayForm($tpl);
        break;
	  case 'add':
        $this->displayForm($tpl);
        break;
      default:
        $this->displayListCategories($tpl);
    }
  }

  /**
   * display list categories, template default
   * @return void
   **/
  function displayListCategories($tpl){
    global $mainframe, $option;

    $db = &JFactory::getDBO();

    if(!isset($_REQUEST['filter_order_1']) && !isset($_REQUEST['filter_order_Dir_1'])){

    }
    $context = $option.'.jacategories.list.';
	
    $limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
    $limitstart = $mainframe->getUserStateFromRequest( $context.'limitstart', 'limitstart', 0, 'int' );

    $filter_order		= 	$mainframe->getUserStateFromRequest( $context.'order_1',	'order_1',		'c.ordering',	'cmd' );
	
    $filter_order_Dir	= 	$mainframe->getUserStateFromRequest( $context.'order_Dir_1', 'order_Dir_1',	'',				'word' );	

    $search				= 	$mainframe->getUserStateFromRequest( $option.".search", 'search', '' );
    $search				= 	$db->getEscaped( trim( strtolower( $search ) ) );

    $where = array();
    if(!empty($search)){
      $where[] = " c.title LIKE '%" . $search . "%'";
    }
    $orderbyTotalshow = '';
    $where		= count($where) ? ' WHERE ' . implode(' AND ', $where) : '';
	$orderby	= '';
    $orderby	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', c.ordering';	

    $query = "SELECT COUNT(*) FROM #__jasc_categories c $where";
    $db->setQuery($query);	
    $total = $db->loadResult();

    if ($limit > $total) {
      $limitstart = 0;
    }

    if ($limit==0) {
      $limit = $total;
    }

    jimport('joomla.html.pagination');
    $pagination = new JPagination( $total, $limitstart, $limit );

    $query = "SELECT c.* FROM #__jasc_categories c $where $orderby";
    $db->setQuery($query);
	//die($db->getQuery());
    $rows = $db->loadObjectList();
    if ($db->getErrorNum()) {
      echo $db->stderr();
      return false;
    }
    $level = 0;
    $tree = array();
    $totalShow = array();

    for($i=0,$n=count($rows);$i<$n;$i++){
      $row = $rows[$i];
      $query = "SELECT COUNT(1) FROM #__jashowcase WHERE catid=".$row->id;
      $db->setQuery($query);
      $totalShow[] = $db->loadResult();
      $tree[$row->parent_id][] = $row;
    }

    $final = array();
    $level = 0;
    if(isset($tree[0]) && count($tree[0]) > 0){
      for($i=0,$n=count($tree[0]);$i<$n;$i++){
        $row = $tree[0][$i];
        $this->buildCategoriesTree($tree, $final, $row, $level, 1);
      }
    }

    $final = array_slice($final, $limitstart, $limit);
    $lists['search'] = $search;
    $lists['order_Dir_1']	= $filter_order_Dir;
    $lists['order_1']		= $filter_order;

    $task = JRequest::getVar('task', '');
    $this->assignRef('rows', $final);
    $this->assignRef('pageNav', $pagination);
    $this->assignRef('lists', $lists);
    $this->assignRef('totalShow', $totalShow);
    $this->assignRef('task', $task);
    parent::display($tpl);
  }

  /**
   * display form edit, template form
   * @return void
   **/
  function displayForm($tpl){
 	global $mainframe;
    $db		=& JFactory::getDBO();
    $user 	=& JFactory::getUser();
    $cid 	= JRequest::getVar( 'cid', array(0), '', 'array' );
    JArrayHelper::toInteger($cid, array(0));
    $edit		= JRequest::getVar('edit',true);

    $row = array();
    $row =& $this->get('Data');

    $categories = $this->getCategorieTree();

    $obj = new stdClass();
    $obj->id = 0;
    $obj->name = 'Top';
    $obj->status = 1;
    //		$model = $this->getModel('jacategories');
    //		$categories = $model->getCategories(true);
    array_unshift($categories, $obj);
    $parent_id =  isset($row->parent_id)?$row->parent_id:$obj->id ;

    $lists = array();
    $lists['parent_id'] = JHTML::_( 'select.genericlist', $categories, 'parent_id', 'class="inputbox" size="5"', 'id', 'name', $parent_id);
    $lists['published'] = JHTML::_('select.booleanlist',  'published', '', isset($row->published)?intval($row->published):'1');
    $lists['access'] 	= JHTML::_('list.accesslevel', $row);
	
 //Get list of folder in showcase folder
    $head_path_thumb = 	JashowcaseHelper::_getPathTthumbview();
	if (JFolder::exists(JPATH_SITE.DS.$head_path_thumb)) {
    
	  $listFolder	 		= JashowcaseHelper::getlistFolder(JPATH_SITE.DS.$head_path_thumb);
      $lists['listFolder'] = JHTML::_('select.genericlist', $listFolder, 'directory', 'class="inputbox" size="10"', 'value', 'text', '');
    }
    else{
      $lists['listFolder'] = '<select id="directory" class="inputbox" size="10" name="directory">
									</select>';
    }
 //Get list of file in item folder
    $choose_file[] 		= JHTML::_('select.option', '', "Select file");
    $lists['listFile'] = JHTML::_('select.genericlist', $choose_file,
     'thumbnail', 'class="inputbox" size="1" onchange="getSrcThumb();"', 
     'value', 'text', $row->thumbnail);
		
	if( $row->thumbnail ){
		$row->thumbnail = $mainframe->getSiteURL().$row->thumbnail;	
	}

	//die;
    $this->assignRef('lists', $lists);
    $this->assignRef('row', $row);
    $this->assignRef("path_site", $head_path_thumb);
    $path_thumbview = $mainframe->getSiteURL().$head_path_thumb;
    $this->assignRef('path_thumbview',  $path_thumbview);
    parent::display($tpl);
  }

  function getCategorieTree($published_only = false){
    global $mainframe;

    $cid  = JRequest::getVar( 'cid', array(0), '', 'array' );

    $db		=& JFactory::getDBO();
    $query = "SELECT * FROM #__jasc_categories";
    $where = array();
    if($published_only){
      $where[] = " published = 1 ";
    }

    if (!empty($cid[0])) {
      $where[] = " id <> {$cid[0]}";
    }

    $where = count($where) ? ' WHERE ' . implode(' AND ', $where) : '';

    $query .= "$where ORDER BY parent_id, title";
    $db->setQuery($query);
    $rows = $db->loadObjectList();

    echo $db->getErrorMsg();

    $level = 0;
    $tree = array();
    //sort by parent
    for($i=0,$n=count($rows);$i<$n;$i++){
      $row = $rows[$i];

      $tree[$row->parent_id][] = $row;
    }

    $final = array();
    $level = 0;
    //loop through all items
    if(isset($tree[0]) && count($tree[0]) > 0){
      for($i=0,$n=count($tree[0]);$i<$n;$i++){
        $row = $tree[0][$i];
        $this->buildCategoriesTree($tree, $final, $row, $level, 0);
      }
    }
    return $final;
  }

  function buildCategoriesTree($rows, &$tree, $row, $level, $type=1){
    $name = '';

    $spacer = '<sup>.</sup>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
    $pre = '<sup>|_</sup>&nbsp;&nbsp;';

    if (!$type) {
      $spacer = '&nbsp;&nbsp;';
      $pre = '-&nbsp;';
    }

    for($i=1;$i<$level;$i++){
      $name .= $spacer;
    }

    if($level != 0){
      $name = $spacer . $name;
    } else {
      $pre = '';
    }

    $row->name = $name . $pre . $row->title;

    $tree[] = $row;

    if(@sizeof($rows[$row->id]) && $row->id != 0){
      for($i=0,$n=count($rows[$row->id]);$i<$n;$i++){
        $child = $rows[$row->id][$i];
        $this->buildCategoriesTree($rows, $tree, $child, $level + 1);
      }
    }

  }
}
