<?php
/*
# ------------------------------------------------------------------------
# JA Showcase component for Joomla 1.5
# ------------------------------------------------------------------------
# Copyright (C) 2004-2010 JoomlArt.com. All Rights Reserved.
# @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
# Author: JoomlArt.com
# Websites: http://www.joomlart.com - http://www.joomlancers.com.
# ------------------------------------------------------------------------
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view' );

/**
 * Jaconfig View
 *
 * @package    Joomla.Jashowcase
 * @subpackage Components
 */
class jashowcaseViewjaconfig extends JAView {

	/**
	 * display method of Jaconfig view
	 * @return void
	 **/
  function display($tpl = null) {
    global $option;

    $task = JRequest::getVar('task');

 	  switch ($task){
 	    case 'previewCustomFields':
 	      parent::display($tpl);
 	      return;
 	    case 'customfields':
 	      $this->_displayFormCustomfield($tpl);
 	      break;

 	    case 'customtpl':
 	      $this->_displayFormCustomtpl($tpl);
 	      break;

 	    default:
 	      $this->_displayForm($tpl);
 	  }
  }  	

	function _displayFormCustomtpl($tpl){
		global $option,$mainframe;

		$this->_layout = 'form_customtpl';
		//$file 	= JPATH_ROOT.DS.'components'.DS.$option.DS.'views'.DS.'jashowcase'.DS.'tmpl'.DS.'item.tpl';		
		$fileInCom = JPATH_SITE.DS."components".DS."com_jashowcase".DS."themes";
		$themes = JFolder::folders($fileInCom);
		$template = JashowcaseHelper::getTemplate(0);		
		$fileInTem = JPATH_SITE.DS.'templates'.DS.$template.DS.'html'.DS.'com_jashowcase'.DS.'themes';		
		if(is_dir($fileInTem)){
			$overThemes = JFolder::folders($fileInTem);
			$themes = array_unique(array_merge_recursive($themes, $overThemes));
		}
		$theme = JRequest::getVar("theme","");
		//die($theme."--");
		$string = '<select name="theme" onchange="jascSelectCusTheme(this.value)">';		
		$string .='<option  value="0">'.JText::_("Select theme").'</option>';		
		foreach ($themes as $item){
			if($theme == $item){		
				$string .='<option value="'.$item.'" selected="seleted">'.$item.'</option>';
			}else{
				$string .='<option value="'.$item.'">'.$item.'</option>';
			}			
		}		
		$string .= '</select>';
				
		if($theme){
			$file = JPATH_SITE.DS.'templates'.DS.$template.DS.'html'.DS.'com_jashowcase'.DS."themes".DS.$theme.DS."html".DS."jashowcase".DS."default_item.php";						
			if (file_exists($file)) {				
				$data = JFile::read($file);
			}else{
				$file = JPATH_COMPONENT_SITE.DS.'themes'.DS.$theme.DS.'html'.DS."jashowcase".DS.'default_item.php';				
				if (file_exists($file)) {					
					$data = JFile::read($file);
				}
			}
			$data = JFile::read($file);
					
	  		$this->assignRef('data', $data);
	  		$this->assignRef('file', $file);
		}
	  	$this->assignRef('themes', $string);
	  	$this->assignRef('option', $option);
		$com_k2 = JComponentHelper::getComponent('com_k2');
		$show_extrafield=false;
		if ($com_k2&&$com_k2->id&&$com_k2->enabled)
		{
			$db = JFactory::getDBO();
			$query = "SELECT t.id, t.name FROM  #__k2_extra_fields t WHERE t.published =1 ORDER BY ordering ";
			$db->setQuery($query);	
			$extra_fields = ($db->loadObjectList('id'));
			$exf_options= array();
			$object = new stdClass();
			$object->text = JText::_('Choose an option below to generate item-extrafield');
			$object->value = "";
			$exf_options[] = $object;
			foreach ($extra_fields as $item)
			{
				$object = new stdClass();
				$object->text = "{{$item->name}}->Label : Value ";
				$object->value = htmlspecialchars('<div class="ja-extrafield-item clearfix"><label>'.$item->name.'</label>',ENT_QUOTES)."\n". htmlspecialchars('<span> <?php echo $this->item->extra_fields["'.str_replace(' ','_',trim(strtolower($item->name))).'"]?></span> </div>',ENT_QUOTES);
				$exf_options[] = $object;
			}
			$this->assign('extra_fields',$exf_options);
			$show_extrafield = true;
		}
		$this->assign('show_extrafield',$show_extrafield);
	  	parent::display($tpl);
	}

	function _displayFormCustomfield($tpl){
		global $option;

		$this->_layout = 'form_customfields';

		$file 	= JPATH_COMPONENT_ADMINISTRATOR.DS.'views'.DS.'jaconfig'.DS.'customfields.xml';

		$data = '';

		if (file_exists($file)) {
			$data = JFile::read($file);
		}

	  	$this->assignRef('data', $data);
	  	$this->assignRef('option', $option);
	
	  	parent::display($tpl);
	}

	function _displayForm($tpl){
		global $option;

		$file 	= JPATH_COMPONENT_ADMINISTRATOR.DS.'views'.DS.'jaconfig' . DS . 'settings' .'.ini';
		$data = JFile::read($file);

		$file 	= JPATH_COMPONENT_ADMINISTRATOR.DS.'views'.DS.'jaconfig' . DS . 'settings' .'.xml';

		$params = new JParameter($data, $file);
		$this->assignRef('option', $option);
		$this->assignRef('params', $params);
		parent::display($tpl);
	}
}

?>