<?php
/**
 * ------------------------------------------------------------------------
 * JA Showcase component for Joomla 1.7
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - Copyrighted Commercial Software
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites:  http://www.joomlart.com -  http://www.joomlancers.com
 * This file may not be redistributed in whole or significant part.
 * ------------------------------------------------------------------------
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view' );

/**
 * Jaconfig View
 *
 * @package    Joomla.Jashowcase
 * @subpackage Components
 */
class jashowcaseViewjaconfig extends JAView {

	/**
	 * display method of Jaconfig view
	 * @return void
	 **/
  function display($tpl = null) {
	$option = JRequest::getCmd('option');

    $task = JRequest::getVar('task');

 	  switch ($task){
 	    case 'previewCustomFields':
		  $this->setLayout('customfields_preview');			  
 	      parent::display($tpl);
 	      return;
 	    case 'customfields':
 	      $this->_displayFormCustomfield($tpl);
 	      break;

 	    case 'customtpl':
 	      $this->_displayFormCustomtpl($tpl);
 	      break;

 	    default:
 	      $this->_displayForm($tpl);
 	  }
  }  	

	function _displayFormCustomtpl($tpl){
		$option = JRequest::getCmd('option');
		$mainframe  = JFactory::getApplication();
		$compParams = JashowcaseHelper::_getSetting();
		
		$this->setLayout('form_customtpl');
		//$file 	= JPATH_ROOT.DS.'components'.DS.$option.DS.'views'.DS.'jashowcase'.DS.'tmpl'.DS.'item.tpl';		
		$fileInCom = JPATH_SITE.DS."components".DS."com_jashowcase".DS."themes";
		$themes = JFolder::folders($fileInCom);
		$template = JashowcaseHelper::getTemplate(0);		
		$fileInTem = JPATH_SITE.DS.'templates'.DS.$template.DS.'html'.DS.'com_jashowcase'.DS.'themes';		
		if(is_dir($fileInTem)){
			$overThemes = JFolder::folders($fileInTem);
			$themes = array_unique(array_merge_recursive($themes, $overThemes));
		}
		$theme = JRequest::getVar("theme","");
		if ($theme == '') {
			$theme = $compParams->get('theme', 'default');
		}
		//die($theme."--");
		$string = '<select name="theme" onchange="jascSelectCusTheme(this.value)">';		
		$string .='<option  value="0">'.JText::_("SELECT_THEME").'</option>';		
		foreach ($themes as $item){
			if($theme == $item){		
				$string .='<option value="'.$item.'" selected="seleted">'.$item.'</option>';
			}else{
				$string .='<option value="'.$item.'">'.$item.'</option>';
			}			
		}		
		$string .= '</select>';
				
		if($theme){
			$file = JPATH_SITE.DS.'templates'.DS.$template.DS.'html'.DS.'com_jashowcase'.DS."themes".DS.$theme.DS."html".DS."jashowcase".DS."default_item.php";						
			if (file_exists($file)) {				
				$data = JFile::read($file);
			}else{
				$file = JPATH_COMPONENT_SITE.DS.'themes'.DS.$theme.DS.'html'.DS."jashowcase".DS.'default_item.php';				
				if (file_exists($file)) {					
					$data = JFile::read($file);
				}
			}
			$data = JFile::read($file);
					
	  		$this->assignRef('data', $data);
	  		$this->assignRef('file', $file);
		}
	  	$this->assignRef('themes', $string);
	  	$this->assignRef('option', $option);
		$com_k2=0;
	  	if(is_file( JPATH_SITE.DS.  "components" . DS . "com_k2" . DS . "k2.php" ))	
		$com_k2 = JComponentHelper::getComponent('com_k2');
		$show_extrafield=false;
		if ($com_k2&&$com_k2->id&&$com_k2->enabled)
		{
			$db = JFactory::getDBO();
			$query = "SELECT t.id, t.name FROM  #__k2_extra_fields t WHERE t.published =1 ORDER BY ordering ";
			$db->setQuery($query);	
			$extra_fields = ($db->loadObjectList('id'));
			$exf_options= array();
			$object = new stdClass();
			$object->text = JText::_('CHOOSE_AN_OPTION_BELOW_TO_GENERATE_ITEMEXTRAFIELD');
			$object->value = "";
			$exf_options[] = $object;
			foreach ($extra_fields as $item)
			{
				$object = new stdClass();
				$object->text = "{{$item->name}}->Label : Value ";
				$object->value = htmlspecialchars('<label>'.$item->name.'</label>',ENT_QUOTES)."\n". htmlspecialchars('<span> <?php echo $this->item->extra_fields["'.str_replace(' ','_',trim(strtolower($item->name))).'"]?></span>',ENT_QUOTES);
				$exf_options[] = $object;
			}
			$this->assign('extra_fields',$exf_options);
			$show_extrafield = true;
		}
		$this->assign('show_extrafield',$show_extrafield);
	  	parent::display($tpl);
	}

	function _displayFormCustomfield($tpl){
		$option = JRequest::getCmd('option');

		$this->setLayout('form_customfields');

		$file 	= JPATH_COMPONENT_ADMINISTRATOR.DS.'views'.DS.'jaconfig'.DS.'customfields.xml';

		$data = '';

		if (file_exists($file)) {
			$data = JFile::read($file);
		}

	  	$this->assignRef('data', $data);
	  	$this->assignRef('option', $option);
	
	  	parent::display($tpl);
	}

	function _displayForm($tpl){
		$option = JRequest::getCmd('option');	
		jimport('joomla.html.parameter');
		jimport('joomla.form.form');
		
		$file 	= JPATH_COMPONENT_ADMINISTRATOR.DS.'views'.DS.'jaconfig' . DS . 'settings' .'.ini';
		if (is_file ($file)) $content = file_get_contents($file);			 
		$params = new JParameter($content);
				
		$jsonData = $params->toArray();
						
		$paramsFile = JPATH_COMPONENT_ADMINISTRATOR.DS.'views'.DS.'jaconfig' . DS . 'settings' .'.xml';		
		if (file_exists($paramsFile)) {
			/* For General Tab */
			$paramsForm = JForm::getInstance('params', $paramsFile, array('control' => 'jform'));
			$paramsForm->bind($jsonData);			
		}
		//print_r($paramsForm->getField());die();
		
//		$file 	= JPATH_COMPONENT_ADMINISTRATOR.DS.'views'.DS.'jaconfig' . DS . 'settings' .'.ini';
//		$data = JFile::read($file);
//
//		$file 	= JPATH_COMPONENT_ADMINISTRATOR.DS.'views'.DS.'jaconfig' . DS . 'settings' .'.xml';
//		/* For General Form */
//		$options = array("control"=>"jaform");
//		$paramsForm = &JForm::getInstance('jform', $file,$options);
//		print_r($paramsForm);die();
//		//$HTML_Profile = JHTML::_('select.genericlist',  $profiles, ''.$this->name,'style="width:150px;" onchange="japarams2.changeProfile(this.value)"', 'id', 'title', $this->value );
//		
//		$params = new JParameter($data, $file);
		$this->assignRef('option', $option);
		$this->assignRef('paramsForm', $paramsForm);
		parent::display($tpl);
	}
}

?>