<?php
/**
 * ------------------------------------------------------------------------
 * JA Showcase component for Joomla 1.7
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - Copyrighted Commercial Software
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites:  http://www.joomlart.com -  http://www.joomlancers.com
 * This file may not be redistributed in whole or significant part.
 * ------------------------------------------------------------------------
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view' );

/**
 * Jamanagelang View
 *
 * @package    Joomla.Jashowcase
 * @subpackage Components
 */
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');

class JashowcaseViewJamanagelang extends JAView {
	/**
	 * Jamanagelang view display method
	 * @return void
	 **/
	function display($tpl = null){
		$option = JRequest::getCmd('option');
		$mainframe  = JFactory::getApplication();

		$task = JRequest::getVar('task');

		switch ($task){
			case 'edit':
				$this->edit($tpl, $task);
				break;
			default:
				$this->view($tpl, $task);
		}
	}

	function edit($tpl, $task){
		$option = JRequest::getCmd('option');
		
		$lang = JRequest::getVar('lang', '');
		$client = & JApplicationHelper::getClientInfo(JRequest::getVar('client', '1', '', 'int'));
		$path_dest = JLanguage::getLanguagePath($client->path);
		$path = $path_dest.DS.$lang.DS.$lang.'.'.$option.'.ini';
		$data = '';
		$root = '';

		if($lang!='' && JFile::exists($path)){
			$data = JFile::read($path);
		}	else {
			if($client->id){
				$root = JPATH_BASE.DS.'components'.DS.$option.DS.'language'.DS.$lang.'.'.$option.'.ini';
			}
			else {
				$root = JPATH_ROOT.DS.'components'.DS.$option.DS.'language'.DS.$lang.'.'.$option.'.ini';
			}
		}

		if(JFile::exists($root)){
			$data = JFile::read($root);
		}	else {
			$root = $path_dest.DS.'en-GB'.DS.'en-GB'.'.'.$option.'.ini';
			if($root){
				$data = JFile::read($root);
			}
		}

		$file = $lang.'.'.$option.'.ini';

		$this->assignRef('data', $data);
		$this->assignRef('filename', $file);
		$this->assignRef('lang', $lang);
		$this->assignRef('client', $client);
		$this->assignRef('path_lang', $path_dest);
		$this->assignRef('task', $task);
		$this->assignRef('root', $root);

		parent::display($tpl);
	}
	/**
	* Compiles a list of installed languages
	*/
	function view($tpl, $task) {
		$option = JRequest::getCmd('option');
		$mainframe  = JFactory::getApplication();
		// Initialize some variables
		$db		=& JFactory::getDBO();
		$client	=& JApplicationHelper::getClientInfo(JRequest::getVar('client', '0', '', 'int'));
		$rows	= array ();

		$limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart = $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart', 0, 'int' );

		//load folder filesystem class

		$type 	   = JRequest::getVar('client', '0', '', 'int') ? 'SITE ' : 'ADMIN ';
		$pateTitle = JRequest::getVar('client', '0', '', 'int') ? JText::_("ADMIN_LANGUAGE_MANAGER") : JText::_("SITE_LANGUAGE_MANAGER");
		
		$path = JLanguage::getLanguagePath($client->path);
		$dirs = JFolder::folders( $path );
		$i = 0; $data['name'] = '';
		foreach ($dirs as $dir) {

				$files = JFolder::files( $path.DS.$dir, '^([-_A-Za-z]*)\.xml$' );
				foreach ($files as $file)	{
					$data = JApplicationHelper::parseXMLLangMetaFile($path.DS.$dir.DS.$file);
					$row 			= new StdClass();
					$row->id 		= $i;
					$row->language 	= substr($file,0,-4);

					if (!is_array($data)) {
						continue;
					}
					foreach($data as $key => $value) {
						$row->$key = $value;
					}

					// if current than set published
					$params = JComponentHelper::getParams('com_languages');
					if ( $params->get($client->name, 'en-GB') == $row->language) {
						$row->published	= 1;
					} else {
						$row->published = 0;
					}

					$row->checked_out = 0;
					$row->mosname = JString::strtolower( str_replace( " ", "_", $row->name ) );
					$rows[] = $row;
				}
				$i++;

		}

		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $i, $limitstart, $limit );

		$rows = array_slice( $rows, $pageNav->limitstart, $pageNav->limit );

		$this->assignRef('rows', $rows);
		$this->assignRef('page', $pageNav);
		$this->assignRef('client', $client);
		$this->assignRef('task', $task);
		$this->assignRef('type', $type);
		$this->assignRef('pateTitle', $pateTitle);		

		parent::display($tpl);
	}

}