<?php
/**
 * @desc Modify from component Media Manager of Joomla
 *
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the Media component
 *
 * @static
 * @package		Joomla
 * @subpackage	Media
 * @since 1.0
 */
class jaAmazonS3ViewRepo extends JView
{
	function display($tpl = null)
	{
		$mainframe = JFactory::getApplication('administrator');
		jaComponentMenuHeader();

		$config =& JComponentHelper::getParams(JACOMPONENT);

		//$style = $mainframe->getUserStateFromRequest('media.list.layout', 'layout', 'details', 'word');
		$style = "details";

		$document =& JFactory::getDocument();

		JHTML::_('behavior.mootools');
		$document->addScript('components/'.JACOMPONENT.'/assets/repo_manager/repomanager.php?view=repo');
		$document->addStyleSheet('components/'.JACOMPONENT.'/assets/repo_manager/repomanager.css');

		JHTML::_('behavior.modal');
		$document->addScriptDeclaration("
		window.addEvent('domready', function() {
			document.preview = SqueezeBox;
		});");

		JHTML::script('mootree.js');
		JHTML::stylesheet('mootree.css');

		if ($config->get('enable_flash', 0)) {
			JHTML::_('behavior.uploader', 'file-upload', array('onAllComplete' => 'function(){ MediaManager.refreshFrame(); }'));
		}
		/**
		 * get list buckets
		 */
		$model = & JModel::getInstance ( 'repo', 'jaAmazonS3Model' );
		$lists = $model->_getVars_admin ();
		
		$modelBucket = & JModel::getInstance ( 'bucket', 'jaAmazonS3Model' );
		$lists ['boxBuckets'] = $modelBucket->getBoxBuckets('bucket_id', $lists['bucket_id'], "onchange=\"this.form.submit();\"");
		
		$bucket = $model->getActiveBucket();

		/*if(DS == '\\')
		{
			$base = str_replace(DS,"\\\\",$bucket->bucket_name);
		} else {
			$base = $bucket->bucket_name;
		}*/
		$base = "";

		$js = "
			var basepath = '".$base."';
			var viewstyle = '".$style."';
		" ;
		$document->addScriptDeclaration($js);

		/*
		 * Display form for FTP credentials?
		 * Don't set them here, as there are other functions called before this one if there is any file write operation
		 */
		jimport('joomla.client.helper');
		$ftp = !JClientHelper::hasCredentials('ftp');

		$this->assignRef('lists', $lists);
		$this->assignRef('session', JFactory::getSession());
		$this->assignRef('config', $config);
		$this->assignRef('state', $this->get('state'));
		$this->assign('require_ftp', $ftp);
		$this->assign('folders_id', ' id="media-tree"');
		$this->assign('folders', $this->get('folderTree'));
		
		$user =& JFactory::getUser();
		$this->assignRef('user', $user);

		// Set the toolbar
		$this->_setToolBar();

		parent::display($tpl);
		echo JHTML::_('behavior.keepalive');
		jaComponentMenuFooter();
	}

	function _setToolBar()
	{
		// Get the toolbar object instance
		$bar =& JToolBar::getInstance('toolbar');

		// Set the titlebar text
		JToolBarHelper::title( JText::_('JOOMLART_AMAZON_S3' ), 'generic');
		
		
		$model = & JModel::getInstance ( 'repo', 'jaAmazonS3Model' );
		
		$bucket = $model->getActiveBucket();
	    
		if($bucket) {
			// Add a upload button
			$title = JText::_('CREATE_DIRECTORY');
			JToolBarHelper::custom('create_folder', 'new', 'new', $title, false);
		    
			// Add a `Update S3 File list` button
			$title = JText::_('UPDATE_S3_FILE_LIST');
			JToolBarHelper::custom('update_list_s3_files', 'update_list', 'update_list', $title, false);
			
			/*JToolBarHelper::divider();
			JToolBarHelper::custom('update_acl_open', 'publish', 'publish', JText::_("SET_OPEN"), false);
			JToolBarHelper::custom('update_acl_public', 'publish', 'publish', JText::_("SET_PUBLIC"), false);
			JToolBarHelper::custom('update_acl_private', 'unpublish', 'unpublish', JText::_("SET_PRIVATE"), false);
			
		    JToolBarHelper::divider();
			// Add a delete button
			$title = JText::_('DELETE');
			$dhtml = "<a href=\"#\" onclick=\"multiDelete(); return false;\" class=\"toolbar\">
						<span class=\"icon-32-delete\" title=\"$title\" type=\"Custom\"></span>
						$title</a>";
			$bar->appendButton( 'Custom', $dhtml, 'delete' );*/
			
			JToolBarHelper::custom('delete_advance', 'delete', 'delete', JText::_("ADVANCED_DELETE"), false);
		}
	    // Add a popup configuration button
	    JToolBarHelper::preferences(JACOMPONENT, 250, 570);

		// Add a popup configuration button
		//JToolBarHelper::help( 'screen.mediamanager' );
	}

	function getFolderLevel($folder)
	{
		$this->folders_id = null;
		$txt = null;
		if (isset($folder['children']) && count($folder['children'])) {
			$tmp = $this->folders;
			$this->folders = $folder;
			$txt = $this->loadTemplate('folders');
			$this->folders = $tmp;
		}
		return $txt;
	}
}
