<?php
/**
 * @package Joomla
 * @subpackage Component
 * @license GNU/GPL
 * @author Joomlart.com
 * @version 1.0
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view' );

/**
 * News View
 * @package Joomlart
 * @subpackage Components
 */
class janewsViewsectionslayout extends JView 
{	
	function display($tpl = null)
	{
		if($this->getLayout() == 'form') {
			$this->_displayForm($tpl);
			return;
		}
		
		global $mainframe, $option;
		
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'.filter_order',		'filter_order',		's.ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		$limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart	= $mainframe->getUserStateFromRequest( $option.'.limitstart', 'limitstart', 0, 'int' );
		$model = $this->getModel();
		$list_sections = $model->getListSections($filter_order, $filter_order_Dir, $limit, $limitstart);
		$total = $model->getTotal();
		
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		= $filter_order;
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
		
		
		$task = isset($_REQUEST['task'])?$_REQUEST['task']:'';
		
		$this->assignRef('list_sections', $list_sections);
		$this->assignRef('lists', $lists);
		$this->assignRef('pageNav', $pageNav);
		$this->assignRef('task', $task);
		
		parent::display($tpl);
	}
	
	function _toolbarDefault()
	{
		$document = & JFactory::getDocument();
		$document->setTitle( JText::_('Sections Layout Manager') );
		JToolBarHelper::title( JText::_( 'SECTIONS LAYOUT MANAGER' ), 'generic.png' );
		JToolBarHelper::editListX();
		JToolBarHelper::cancel('cancel','Close');
	}
	
	function _toolbarEdit($cid)
	{
		$document = & JFactory::getDocument();
		$document->setTitle( JText::_('Sections Layout Edit') );
		JToolBarHelper::title( JText::_( 'SECTIONS LAYOUT EDIT' ), 'generic.png' );
		JToolBarHelper::save();
		JToolBarHelper::apply();
		JToolBarHelper::cancel('cancel','Close');
	}
	
	function _displayForm($tpl)
	{
		$model = $this->getModel();
		$sections = JRequest::getVar('cid',  0, '', 'array');
		$cid = $sections[0];
		$sec_info = $model->getJASectionInfo($cid);
		if (!$sec_info) {
			$sec_info = $model->getSectionInfo($cid);
			$edit = false;
		}
		else {
			$edit = true;
		}
		$list_cats = $model->getListCats($cid);
		$headlines = $model->getListTemplates('headline');
		$blogs = $model->getListTemplates('blog');
		$str_catids = $edit ? $model->getStrCatIds($cid) : null;
		$catSelect = $edit ? $model->getSelectedCats($cid) : null;
		$secparams = $model->getSectionParams($cid);
		$mcatparams = $model->getMenuCategoryParams($cid);
		
		$this->assignRef('sec_info', $sec_info);
		$this->assignRef('edit', $edit);
		$this->assignRef('list_cats', $list_cats);
		$this->assignRef('headlines', $headlines);
		$this->assignRef('blogs', $blogs);
		$this->assignRef('str_catids', $str_catids);
		$this->assignRef('catSelect', $catSelect);
		$this->assignRef('secparams', $secparams);
		$this->assignRef('mcatparams', $mcatparams);
		
		parent::display($tpl);
	}
}
?>