<?php 
/*
 * ------------------------------------------------------------------------
 * JA News Flash module for Joomla 1.5
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 JoomlArt.com. All Rights Reserved.
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * Author: JoomlArt.com
 * Websites: http://www.joomlart.com - http://www.joomlancers.com.
 * ------------------------------------------------------------------------
*/
  // no direct access
defined('_JEXEC') or die('Restricted access');

require_once (JPATH_SITE . '/components/com_content/helpers/route.php');
//Check com k2 was installed
if(file_exists(JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'route.php'))
{
	require_once(JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'route.php');
}
if(file_exists(JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'utilities.php'))
{
	require_once(JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'utilities.php');
}
//end check
/**
 * modJASildeNews class.
 */
class modJAnewsFlashHelper {

	/**
	 * @var string $condition;
	 *
	 * @access private
	 */
	var $conditons = '';
	
	/**
	 * @var string $order 
	 *
	 * @access private
	 */
	var $order = 'ordering';
	
	/**
	 * @var string $limit
	 *
	 * @access private
	 */
	var $limit  = '';
	
	/**
	*@var integer $iwidth
	*@var integer $iheight
	*
	*
	*/
	var $iwidth = 0;
	var $iheight = 0;
	
	/**
	 * get listing items from rss link or from list of categories.
	 *
	 * @param JParameter $params
	 * @return array
	 */
	function getList( $params ){
		$rows = array();

		// check cache was endable ?
		if ( $params->get('enable_cache',1) ) {
			$cache =& JFactory::getCache();
			$cache->setCaching( true );
			$cache->setLifeTime( $params->get( 'cache_time', 30 ) * 60 );	
			$rows = $cache->get( array( $this , 'getArticles' ), array( $params ) ); 
		} else {
			$rows = $this->getArticles( $params );
		}					

		return $rows;
	}
	
	/**
	 * get articles from list of categories and follow up owner paramer.
	 *
	 * @param JParameter $params.
	 * @return array list of articles
	 */
	function getArticles( $params ){
		$order =  $params->get('sort_order_field' ,'created');
		if( trim($order) != "rand" ) {
			$this->setOrder("a.". $order, $params->get('sort_order','DESC') );
		}else {
			$this->setOrder( "RAND()", "" );
		} 
		$this->setLimit( $params->get('max_items', 5) );
		$using_mode = $params->get( 'using_mode', 'catids' );
		if($using_mode == "com_k2")
		{
		    $rows = $this->getListK2($params);
		}
		else
		{
			$rows = $this->getListArticles( $params );
		}

		return $rows;							
	}
	public function getListK2($params)
	{
		global $mainframe;
		
		$db	    = &JFactory::getDBO();
		
		$my = &JFactory::getUser();

		$aid	= $my->get( 'aid', 0 );
		$date =& JFactory::getDate();
		$now  = $date->toMySQL();
		// User Filter
		switch ($params->get ( 'user_id' )) {
			case 'by_me' :
				$where .= ' AND (created_by = ' . ( int ) $userId . ' OR modified_by = ' . ( int ) $userId . ')';
				break;
			case 'not_me' :
				$where .= ' AND (created_by <> ' . ( int ) $userId . ' AND modified_by <> ' . ( int ) $userId . ')';
				break;
		}
		
		$query = "SELECT a.*, cc.name AS categoryname,cc.id AS categoryid, cc.alias AS categoryalias, cc.params AS categoryparams";
		$query .= " FROM #__k2_items as a LEFT JOIN #__k2_categories cc ON cc.id = a.catid";
		$query .= " WHERE a.published = 1 AND a.access <= {$aid} AND a.trash = 0 AND cc.published = 1 AND cc.access <= {$aid} AND cc.trash = 0";
		$query .= " AND ( a.publish_up = ".$db->Quote( $db->getNullDate() )." OR a.publish_up <= ".$db->Quote($now)." )";
		$query .= " AND ( a.publish_down = ".$db->Quote( $db->getNullDate() )." OR a.publish_down >= ".$db->Quote($now)." )";
		
		if(is_array($params->get('k2catsid'))){
			$catids = implode(',', $params->get('k2catsid'));
			$query .= " AND cc.id IN($catids)";
		}
		elseif($params->get('k2catsid')>0){
			$catids = $params->get('k2catsid');
			$query .= " AND cc.id = $catids";
		}
		$query .= ' ORDER BY '.$this->order;
	
		if( $this->limit ) {
			$query .=  ' LIMIT ' . $this->limit;
		}	
		$db->setQuery($query);
		
		return $db->loadObjectlist();
	}
	/**
	 * get list articles follow setting configuration.
	 *
	 * @param JParameter $param
	 * @return array 
	 */ 
	function getListArticles( $params ){
	
		global $mainframe; 
		
	 	$db	    = &JFactory::getDBO();
		
		$my = &JFactory::getUser();

		$aid	= $my->get( 'aid', 0 );
		$date =& JFactory::getDate();
		$now  = $date->toMySQL();
		
		$query 	= 	'SELECT a.*,cc.description as catdesc, cc.title as cattitle,s.description as secdesc, s.title as sectitle,' .
					' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
					' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":",cc.id,cc.alias) ELSE cc.id END as catslug,'.
					' CASE WHEN CHAR_LENGTH(s.alias) THEN CONCAT_WS(":", s.id, s.alias) ELSE s.id END as secslug'
					. "\n FROM #__content AS a".
					' INNER JOIN #__categories AS cc ON cc.id = a.catid' .
					' INNER JOIN #__sections AS s ON s.id = a.sectionid'
					. "\n WHERE a.state = 1"
					. "\n AND ( a.publish_up = " . $db->Quote( $db->getNullDate() ) . " OR a.publish_up <= " . $db->Quote( $now  ) . " )"
					. "\n AND ( a.publish_down = " . $db->Quote( $db->getNullDate() ) . " OR a.publish_down >= " . $db->Quote( $now  ) . " )"
					. ( ( !$mainframe->getCfg( 'shownoauth' ) ) ? "\n AND a.access <= " . (int) $aid : '' )
					;
		
		$query .=  $this->getCondition( $params );
		$query .= ' ORDER BY ' . $this->order;

		if( $this->limit ) {
			$query .=  ' LIMIT ' . $this->limit;
		}	
		$db->setQuery($query);
		$data = $db->loadObjectlist();
	
		return $data;
	}
	
	/**
	 * get condition from setting configuration.
	 *
	 * @param JParameter $params
	 * @return string.
	 */
	function getCondition( $params ){
		
		$condition = '';
		$categories = $params->get( 'catid' , '' );	
		
		if( $categories != '' ) {
			$ids = $this->getIds( $categories );		
			$condition = " AND cc.id IN($ids)";
		}
		return $condition;
	}
	
	/**
	 * parser options, helper for clause where sql.
	 *
	 * @string array $options
	 * @return string.
	 */
	function getIds( $options ){
		if( !is_array($options) ){
			return (int)$options;
		} else {
			return "'".implode( "','", $options  )."'";
		}		
	}
	
	/**
	 * add sort order sql
	 *
	 * @param string $order is article's field.
	 * @param string $mode is DESC or ASC
	 * @return .
	 */
	function setOrder( $order, $mode ){
		$this->order = $order . ' '. $mode;
		return $this;
	}
	
	/**
	 * add set limit sql
	 * 
	 * @param integer $limit.
	 * @return .
	 */
	function setLimit( $limit ){
		$this->limit = $limit; 
		return $this;
	}
	
	/**
	 * trim string with max specify
	 *  
	 * @param string $title
	 * @param integer $max.
	 */
	function trimString( $title, $max=60  ){

		if( strlen($title) > $max ){
			return substr( $title, 0, $max ) . '...';
		} 
		return $title;
	}
	
	/**
	 * detect and get link with each resource
	 *
	 * @param string $item
	 * @param bool $useRSS.
	 * @return string.
	 */
	function getLink( $item ){
		if(!isset($item->slug) && !isset($item->catslug) && !isset($item->sectionid) && isset($item->categoryalias))
		{
			return	urldecode(JRoute::_(K2HelperRoute::getItemRoute($item->id.':'.urlencode($item->alias), $item->catid.':'.urlencode($item->categoryalias))));
		}
		else
		{
			return  JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catslug, $item->sectionid));
		}
	}
	
	/**
	 *
	 *
	 */
	function replaceImage( &$row, $autoresize, $maxchars, $width = 0, $height = 0 ) {
		global $database, $_MAMBOTS, $current_charset;
		$image = "";
		//Get image
		$regex = "/\<img.*\/\>/";
		preg_match ($regex, $row->introtext, $matches);
		$row->text = preg_replace ($regex, '', $row->introtext);
		
		$row->introtext = preg_replace( $regex, '', $row->introtext );
		$row->introtext = trim($row->introtext);
		
		$image  = count($matches) ? $matches[0] : "";
		// clean up globals
		return $image;
	}
	/**
	 *
	 *
	 */
	function renderImage( &$row, $params, $width = 0, $height = 0 ,$maxchars = 100) {
		
			global $database, $_MAMBOTS, $current_charset;
			$image = "";
			$regex = "/\<img.+src\s*=\s*\"([^\"]*)\"[^\>]*\>/";
			preg_match ($regex, $row->text, $matches);
			$align = ($tmp = $params->get("image_alignment","left")) != "auto" ? 'align="'.$tmp.'"' : "";
			$images = (count($matches)) ? $matches : array();
			if (count($images)) $image = $images[1];
		
			if ($image) {
				$thumbnailMode = $params->get( 'thumbnail_mode', 'crop' );
				$aspect 	   = $params->get( 'thumbnail_mode-resize-use_ratio', '1' );
				$crop = $thumbnailMode == 'crop' ? true:false;
				$jaimage = JAImage::getInstance();
				
				if( $thumbnailMode != 'none' && $jaimage->sourceExited($image) ) {
					$imageURL = $jaimage->resize( $image, $width, $height, $crop, $aspect );
					if ( $imageURL == $image ) {
						$width = $width ? "width=\"$width\"" : "";
						$height = $height ? "height=\"$height\"" : "";
						$image = "<img src=\"".JURI::base()."$imageURL\" $align  alt=\"{$row->title}\" title=\"{$row->title}\" $width $height />";
					} else {
						$image = "<img src=\"".JURI::base()."$imageURL\"  $align  alt=\"{$row->title}\" title=\"{$row->title}\" />";
					}
				} else {
					$width = $width ? "width=\"$width\"" : "";
					$height = $height ? "height=\"$height\"" : "";
					$image = "<img src=\"$image\" alt=\"{$row->title}\" $align  title=\"{$row->title}\" $width $height />";	
				}	
			} else {
				$image = '';	
			} 

			$regex1 = "/\<img.*\/\>/";
			$row->introtext = preg_replace( $regex1, '', $row->introtext );
			$row->introtext = trim($row->introtext);
			
			// clean up globals
			return $image;
		}
	/**
	 * output html form custom layout which put in the template of configuration.
	 */
	function outputNewsFlash( &$row, &$params ) {
		
		global $mainframe;

		$row->text 		= $row->introtext;
		$row->readmore 	= (trim( $row->fulltext ) != '') && ($params->get( 'readmore' ));


		$params->set('image', 1);

		
		$results = $mainframe->triggerEvent( 'onPrepareContent', array( &$row, &$params, null ), true );
		
		$html = "";
		$newTitle = "";
		if ($params->get('link_titles')) $newTitle .= "<a href=\"".$this->getLink( $row )."\" title=\"".$row->title."\">".$row->title."</a>";
		else $newTitle .= "".$row->title."";

		//Get image
		$regex = "/\<img.*\/\>/";
	    $img = $this->renderImage($row, $params,$this->iwidth, $this->iheight);
		//preg_match ($regex, $row->text, $matches);
		$row->text = preg_replace ($regex, '', $row->text);

		$newReadmore 	=	"<a href=\"".$this->getLink( $row )."\" title=\"".$row->title."\">".JText::_('READ MORE...')."</a>";
		$html = str_replace( "##TITLE##",$newTitle,$params->get("templates",'<div style="overflow:hidden; height:323px;" ><div class="nfimages">##IMAGE##</div><div class="nftitle">##TITLE##</div><div class="nfcontent">##CONTENT##</div></div>') );
		$html = str_replace("##CONTENT##",$row->text,$html);
		
		//$img  = count($matches) ? $matches[0] : "";
		
		if( $img && ($params->get('link_images',0)) ) {
			$img =  "<a href=\"".$this->getLink( $row )."\" title=\"".$row->title."\">".$img."</a>";
		}
		$html = str_replace("##IMAGE##", $img, $html);
		$html =	str_replace("##READMORE##",$newReadmore,$html );
	
		return $html;
	}
}
?>