<?php
/*
# ------------------------------------------------------------------------
# JA Flowlist module for Joomla 1.5
# ------------------------------------------------------------------------
# Copyright (C) 2004-2010 JoomlArt.com. All Rights Reserved.
# @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
# Author: JoomlArt.com
# Websites: http://www.joomlart.com - http://www.joomlancers.com.
# ------------------------------------------------------------------------
*/

defined('_JEXEC') or die('Restricted access');
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');
require_once (JPATH_SITE . '/components/com_content/helpers/route.php');

class modJaFlowListHelper {
	/**
	 * get instance of modJaFlowListHelper.
	 */
	function &getInstance(){
		static $instance = null;
		if( !$instance ){
			$instance = new modJaFlowListHelper();
		}
		return $instance;
	}
	/**
	 * get data xml from a centain forder, store and get data from cache if owner would like.
	 */
	function buildXMLF( $params ){
		if ( $params->get('enable_cache', 1) ) {
			$cache =& JFactory::getCache();
			$cache->setCaching( true );
			$cache->setLifeTime( $params->get( 'cache_time', 30 ) * 60 );	
			return $cache->get( array( $this , 'renderXMLFromFolder' ), array( $params ) ); 
		} else {
			return $this->renderXMLFromFolder( $params );
		}		
	}
	/**
	 * build xml with image in a centain folder.
	 */
	function renderXMLFromFolder( $params ) {
	
		$folder = trim( $params->get( 'folder-folder' ));
		$f_order = trim( $params->get( 'folder-order' ));
		
		$path = JURI::base().'images/';
		$folder = str_replace( DS, '/' , JPath::clean( $folder ) );
		
		$basePath = JPATH_SITE.DS.'images'.DS.$folder;
		

		$files = JFolder::files( $basePath );
		// sort files
		switch ($f_order){
			case 'sort':
				sort($files);
				break;
			case 'natsort':
				natsort($files);
				break;
			case 'asort':
				asort($files);
				break;
		}
		$iwidth 			=  intval($params->get( 'iwidth', '0'));
		$iheight 			=  intval($params->get( 'iheight', '0' ));
		$autoresize 		=  intval($params->get( 'autoresize', '0' ));
				
		$data = '<?xml version="1.0" encoding="iso-8859-1"?>
							<content>';
		foreach ($files as $file)
		{
			if (is_file($basePath.DS.$file) && substr($file, 0, 1) != '.' && strtolower($file) !== 'index.html')
			{
				$subpath = str_replace(DS, '/', JPath::clean($folder)).'/'.$file;
				$image = $path.$subpath;
				$ext = strtolower(JFile::getExt($file));
				
		
				switch ($ext)
				{
					// Image
					case 'jpg':
					case 'png':
					case 'gif':
					case 'xcf':
					case 'odg':
					case 'bmp':
					case 'jpeg':
						if( $autoresize  ) {
							$tmp = 'images'.DS.$subpath;
							$image = $this->processImage( $tmp, $iwidth, $iheight ); 
						}
						$data .= '<image>
      						<path><![CDATA['.$image.']]></path>
      						<description><![CDATA[]]></description>
      						<data><![CDATA[]]></data>
    						</image>';
						break;
					// Non-image document
					default:
						break;
				}
			}
		}
		$data .= '</content>';
		return $data;
	}
	
	/**
	 * get xml data from image of articles
	 */	
	 function buildXML($catids,  $params ){
		  if ( $params->get('enable_cache', 1) ) {
			$cache =& JFactory::getCache();
			$cache->setCaching( true );
			$cache->setLifeTime( $params->get( 'cache_time', 30 ) * 60 );	
			$rows = $cache->get( array( $this , 'renderXML' ), array($catids, $params ) ); 
		  } else {
			$rows = $this->renderXML($catids, $params );
		  }					
		  return $rows;
	  }
	  /**
	   * render xml data using for articles.
	   */
	  function renderXML($catids, $params )  {
	
		$catorsec	= trim( $params->get( 'content-catorsec' , 1));
		$ordering	= $params->get( 'content-order', 'created desc' );
		$limit =  $params->get( 'content-max_items', 10 );
		$rows = $this->getListItems( $catids, $ordering, $limit );
		$iwidth 			=  intval($params->get( 'iwidth', '0'));
		$iheight 			=  intval($params->get( 'iheight', '0' ));
		$autoresize 		=  intval($params->get( 'autoresize', '0' ));
		$data = '<?xml version="1.0" encoding="iso-8859-1"?>
								<content>';
		
			for( $i=0; $i < count($rows); $i++ ) { 
			 
			  $image = $this->getImage( $rows[$i] );
			  if ( $image ){
			   	if( $autoresize ){
					$image = $this->processImage( $image, $iwidth, $iheight );
				}
				
				$link   = JRoute::_( ContentHelperRoute::getArticleRoute($rows[$i]->slug, $rows[$i]->catslug, $rows[$i]->sectionid) );
				$link = str_replace('&amp;','&',$link);
				$data .= '<image>
							<path><![CDATA['.JURI::base().$image.']]></path>
							<description><![CDATA['.$rows[$i]->title.']]></description>
							<data><![CDATA['.$link.']]></data>
						  </image>';
			  }  
		}
		$data .= '</content>';
	
		return $data;
		
	  }
	/**
	 *
	 */	
	function getListItems( $catid, $ordering, $limit=10 ) {
	  global $mainframe;

		$db 	=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		$aid	= $user->get('aid', 0);

		$contentConfig	= &JComponentHelper::getParams( 'com_content' );
		$noauth			= !$contentConfig->get('shownoauth');

		jimport('joomla.utilities.date');
		$date = new JDate();
		$now = $date->toMySQL();

		$nullDate = $db->getNullDate();
		
		$query = 'SELECT a.*,'
		   .' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'
		   .' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug,'
		   .' CHAR_LENGTH( a.`fulltext` ) AS readmore,'
		   .' u.name AS author, u.usertype, cc.title AS category, g.name AS groups'
		   .' FROM #__content AS a'
		   .' INNER JOIN #__categories AS cc ON cc.id = a.catid'
		   .' LEFT JOIN #__sections AS s ON s.id = a.sectionid'
		   .' LEFT JOIN #__users AS u ON u.id = a.created_by'
		   .' LEFT JOIN #__groups AS g ON a.access = g.id'
		   .' WHERE a.state = 1'
		   .($noauth ? ' AND a.access <= ' .(int) $aid. ' AND s.access <= ' .(int) $aid. ' AND cc.access <= ' .(int) $aid : ''); 
		   
		if( $catid != "" ){   
	       $query .= ' AND cc.id IN ('. $catid.')';
		}  
		
		$query .= ' AND s.published = 1 AND cc.published = 1'
		   .' AND ( publish_up = '.$db->Quote($nullDate).' OR publish_up <= '.$db->Quote($now).' )'
		   .' AND ( publish_down = '.$db->Quote($nullDate).' OR publish_down >= '.$db->Quote($now).' )'
		   ." ORDER BY  a.$ordering LIMIT " . (int) $limit ;
		
		$db->setQuery($query);
		
		$rows = $db->loadObjectList();
		
		return $rows;
	}
	
	/**
	 *
	 */
	function getImage( $row ) {
	
		global $database, $_MAMBOTS, $current_charset;
		$regex = "/\<img.+src\s*=\s*\"([^\"]*)\"[^\>]*\>/";
		$text = $row->introtext.$row->fulltext;
		preg_match ($regex, $text, $matches);          
		$tmpAr = array(1);
		$result = array();
		if( !isset($matches[0]) ){
			return '';
		}
		while (count($tmpAr) && $matches[0]) {
		  $result = $matches;
		  preg_match ($regex, $text, $matches); 
		  if (@$matches[0] == '') break;
		  $tmpAr = explode($matches[1],$matches[0]);
		  $text = $tmpAr[0]; 
		}
		$image = (count($result)) ? $result[1] : array();
		return $image;
	}
	
	function getTotalItems( $catids, $params  ) {
	
		if ( $params->get('enable_cache', 1) ) {
			$cache =& JFactory::getCache();
			$cache->setCaching( true );
			$cache->setLifeTime( $params->get( 'cache_time', 30 ) * 60 );	
			return  $cache->get( array( $this , '_findCountArticles' ), array( $catids, $params ) ); 
		} else {
			return $this->_findCountArticles(  $catids, $params );
		}	
	}
	
	function _findCountArticles( $catids, $params  )
	{	
		$catorsec	= trim( $params->get( 'content-catorsec' , 1));
		$ordering	= $params->get( 'content-order', 'created desc' );
		$limit =  $params->get( 'content-max_items', 10 );
		$iwidth 		=  trim($params->get( 'iwidth', ''));
		$iheight 		=  trim($params->get( 'iheight', '' ));
		
		$rows = $this->getListItems( $catids, $ordering, $limit );
		
		$count = 0;
		for($i=0;$i<count($rows);$i++) {
			  $image = $this->getImage( $rows[$i] );
			  if ( $image ){
			     $count++;
			  } 
		}
		$count = floor((int)$count/2);
		return $count;
	}
	
   function genID( $lenght = 5 ) {
      $chars = "abcdefghijkmnopqrstuvwxyz";
      srand((double)microtime() * 1000000);
      $str = '';

      for($i=0; $i<=$lenght; $i++) {
         $num = rand() % 23;
         $tmp = substr($chars, $num, 1);
         $str = $str . $tmp;
      }
      return $str;
   }
	
	/**
	 *
	 */
	function processImage ( &$image, $width, $height ) {
		$imagesurl = ( file_exists(JPATH_SITE .DS.$image) ) ? $this->jaResize($image,$width,$height) :  $image ;
		return $imagesurl;
	}
	
	/**
	 *
	 */
	function jaResize($image, $max_width, $max_height) {
		$path = JPATH_SITE;
		$imgInfo = getimagesize ( $path . '/' . $image );
		$width = $imgInfo [0];
		$height = $imgInfo [1];
		if (! $max_width && ! $max_height) {
			$max_width = $width;
			$max_height = $height;
		} else {
			if (! $max_width)
				$max_width = 1000;
			if (! $max_height)
				$max_height = 1000;
		}
		$x_ratio = $max_width / $width;
		$y_ratio = $max_height / $height;
		if (($width <= $max_width) && ($height <= $max_height)) {
			$tn_width = $width;
			$tn_height = $height;
		} else if (($x_ratio * $height) < $max_height) {
			$tn_height = ceil ( $x_ratio * $height );
			$tn_width = $max_width;
		} else {
			$tn_width = ceil ( $y_ratio * $width );
			$tn_height = $max_height;
		}
		
		$ext = strtolower ( substr ( strrchr ( $image, '.' ), 1 ) ); // get the file extension
		$rzname = strtolower ( substr ( $image, 0, strpos ( $image, '.' ) ) ) . "_{$tn_width}_{$tn_height}.{$ext}"; // get the file extension
		$resized = $path . '/images/resized/' . $rzname;
		if (file_exists ( $resized )) {
			$smallImg = getimagesize ( $resized );
			if (($smallImg [0] <= $tn_width && $smallImg [1] == $tn_height) || ($smallImg [1] <= $tn_height && $smallImg [0] == $tn_width)) {
				return "images/resized/" . $rzname;
			}
		}
		if (! file_exists ( $path . '/images/resized/' ) && ! mkdir ( $path . '/images/resized/', 0755 ))
			return '';
		$folders = explode ( '/', strtolower ( $image ) );
		$tmppath = $path . '/images/resized/';
		for($i = 0; $i < count ( $folders ) - 1; $i ++) {
			if (! file_exists ( $tmppath . $folders [$i] ) && ! mkdir ( $tmppath . $folders [$i], 0755 ))
				return '';
			$tmppath = $tmppath . $folders [$i] . '/';
		}
		
		switch ($imgInfo [2]) {
			case 1 :
				$im = imagecreatefromgif ( $path . '/' . $image );
				break;
			case 2 :
				$im = imagecreatefromjpeg ( $path . '/' . $image );
				break;
			case 3 :
				$im = imagecreatefrompng ( $path . '/' . $image );
				break;
			default :
				return '';
				break;
		}
		
		$newImg = imagecreatetruecolor ( $tn_width, $tn_height );
		
		/* Check if this image is PNG or GIF, then set if Transparent*/
		if (($imgInfo [2] == 1) or ($imgInfo [2] == 3)) {
			imagealphablending ( $newImg, false );
			imagesavealpha ( $newImg, true );
			$transparent = imagecolorallocatealpha ( $newImg, 255, 255, 255, 127 );
			imagefilledrectangle ( $newImg, 0, 0, $tn_width, $tn_height, $transparent );
		}
		imagecopyresampled ( $newImg, $im, 0, 0, 0, 0, $tn_width, $tn_height, $imgInfo [0], $imgInfo [1] );
		
		//Generate the file, and rename it to $newfilename
		switch ($imgInfo [2]) {
			case 1 :
				imagegif ( $newImg, $resized );
				break;
			case 2 :
				imagejpeg ( $newImg, $resized, 90 );
				break;
			case 3 :
				imagepng ( $newImg, $resized );
				break;
			default :
				return '';
				break;
		}
		return "images/resized/" . $rzname;
	}
	
	function getModuleParams( $modid ){
		//get module as an object
		$params = array();
		$db =& JFactory::getDBO();
		$db->setQuery("SELECT * FROM #__modules WHERE id='$modid' ");
		$module = $db->loadObject();
		if( $module ){
			$params = new JParameter( $module->params );
		}	
		return $params;

	}
}
