<?php
/*
# ------------------------------------------------------------------------
# JA flowlist module for Joomla 1.6.x
# ------------------------------------------------------------------------
# Copyright (C) 2004-2009 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
# @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
# Author: J.O.O.M Solutions Co., Ltd
# Websites: http://www.joomlart.com - http://www.joomlancers.com
# ------------------------------------------------------------------------
*/

defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.model');
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');
require_once JPATH_SITE.'/components/com_content/helpers/route.php';
JModel::addIncludePath(JPATH_SITE.'/components/com_content/models');
require_once( dirname(__FILE__).DS.'jaimage.php' );

if(!defined('DEFAULT_ARTICLE_IMAGE'))
{
	define('DEFAULT_ARTICLE_IMAGE','modules/mod_jaflowlist/ja_flowlist/images/no_image.gif');
}

class modJaFlowListHelper {
	/**
	 * get instance of modJaFlowListHelper.
	 */
	function &getInstance(){
		static $instance = null;
		if( !$instance ){
			$instance = new modJaFlowListHelper();
		}
		return $instance;
	}
	/**
	 * get data xml from a centain forder, store and get data from cache if owner would like.
	 */
	function buildXMLF( $params ){
		if ( $params->get('enable_cache', 1) ) {
			$cache =& JFactory::getCache();
			$cache->setCaching( true );
			$cache->setLifeTime( $params->get( 'cache_time', 30 ) * 60 );	
			return $cache->get( array( $this , 'renderXMLFromFolder' ), array( $params ) ); 
		} else {
			return $this->renderXMLFromFolder( $params );
		}		
	}
	/**
	 * build xml with image in a centain folder.
	 */
	function renderXMLFromFolder( $params ) {
	
		$folder = trim( $params->get( 'folder-folder' ));
		$f_order = trim( $params->get( 'folder-order' ));
		
		$path = JURI::base();
		$folder = str_replace( DS, '/' , JPath::clean( $folder ) );
		
		$basePath = JPATH_SITE.DS.$folder;
		

		$files = JFolder::files( $basePath );
		// sort files
		switch ($f_order){
			case 'sort':
				sort($files);
				break;
			case 'natsort':
				natsort($files);
				break;
			case 'asort':
				asort($files);
				break;
		}
		$iwidth 			=  intval($params->get( 'iwidth', '0'));
		$iheight 			=  intval($params->get( 'iheight', '0' ));
		$imagemode 		=  intval($params->get( 'imagemode', '0' ));
				
		$data = '<?xml version="1.0" encoding="iso-8859-1"?>
							<content>';
		foreach ($files as $file)
		{
			if (is_file($basePath.DS.$file) && substr($file, 0, 1) != '.' && strtolower($file) !== 'index.html')
			{
				$subpath = str_replace(DS, '/', JPath::clean($folder)).'/'.$file;
				$image = $path.$subpath;
				$ext = strtolower(JFile::getExt($file));
				
		
				switch ($ext)
				{
					// Image
					case 'jpg':
					case 'png':
					case 'gif':
					case 'xcf':
					case 'odg':
					case 'bmp':
					case 'jpeg':
						if( $imagemode==1  ) {
						
							$tmp = $subpath;
							$image = $tmp;
							$jaimage = JAImage::getInstance();
							if( $jaimage->sourceExited($subpath) ) {
								$image = $jaimage->resize( $subpath, $iwidth, $iheight, false, 0 );
							}
							
							//$image = $this->processImage( $tmp, $iwidth, $iheight ); 
							
							$data .= '<image>
								<path><![CDATA['.JURI::base().$image.']]></path>
								<description><![CDATA[]]></description>
								<data><![CDATA[]]></data>
								</image>';
								
						} elseif($imagemode==2){
						
							$imagemode = $params->get( 'imagemode', 'crop' );
							$aspect 	   = $params->get( 'use_ratio', '1' );
							$crop = $imagemode == 'crop' ? true:false;
							
							$jaimage = JAImage::getInstance();								
							
							if( $jaimage->sourceExited($subpath) ) {
								
								$imageURL = $jaimage->resize( $subpath, $iwidth, $iheight, $crop, $aspect );
								$data .= '<image>
										<path><![CDATA['.$path.$imageURL.']]></path>
										<description><![CDATA[]]></description>
										<data><![CDATA[]]></data>
										</image>';
							}
							
						} else{
						
							$data .= '<image>
									<path><![CDATA['.$image.']]></path>
									<description><![CDATA[]]></description>
									<data><![CDATA[]]></data>
									</image>';
									
						}
						break;
					// Non-image document
					default:
						break;
				}
			}
		}
		$data .= '</content>';
		return $data;
	}
	
	/**
	 * get xml data from image of articles
	 */	
	 function buildXML($catids,  $params ){
		  if ( $params->get('enable_cache', 1) ) {
			$cache =& JFactory::getCache();
			$cache->setCaching( true );
			$cache->setLifeTime( $params->get( 'cache_time', 30 ) * 60 );	
			$rows = $cache->get( array( $this , 'renderXML' ), array($catids, $params ) ); 
		  } else {
			$rows = $this->renderXML($catids, $params );
		  }					
		  return $rows;
	  }
	  /**
	   * render xml data using for articles.
	   */
	  function renderXML($catids, $params )  {
	
		$catorsec	= trim( $params->get( 'content-catorsec' , 1));
		$ordering	= $params->get( 'content-order', 'created desc' );
		$limit =  $params->get( 'content-max_items', 10 );
		$rows = $this->getListItems( $catids, $ordering, $limit );
		$iwidth 			=  intval($params->get( 'iwidth', '200'));
		$iheight 			=  intval($params->get( 'iheight', '150' ));
		$imagemode 		=  intval($params->get( 'imagemode', '0' ));
		$data = '<?xml version="1.0" encoding="iso-8859-1"?>
								<content>';
		for( $i=0; $i < count($rows); $i++ ) { 
			 
			$image = $this->getImage( $rows[$i] );
			
			//set default link images when article hasn't images
			if(empty($image) || !file_exists(JPATH_SITE .DS.$image))
			{
				$image = DEFAULT_ARTICLE_IMAGE;
			}
			if ( $image ){
				if( $imagemode==1  ) {
					$jaimage = JAImage::getInstance();
					if( $jaimage->sourceExited($image) ) {
						$image = $jaimage->resize( $image, $iwidth, $iheight, false, 0 );
					}
					//$image = $this->processImage( $image, $iwidth, $iheight ); 

				} elseif($imagemode==2){
				
					$imagemode = $params->get( 'imagemode', 'crop' );
					$aspect 	   = $params->get( 'use_ratio', '1' );
					$crop = $imagemode == 'crop' ? true:false;
					
					$jaimage = JAImage::getInstance();								
					
					if( $jaimage->sourceExited($image) ) {
						
						$image = $jaimage->resize( $image, $iwidth, $iheight, $crop, $aspect );
					}
					
				} 

				$link   = JRoute::_( ContentHelperRoute::getArticleRoute($rows[$i]->slug, $rows[$i]->catslug) );
				$link = str_replace('&amp;','&',$link);
				$data .= '<image>
							<path><![CDATA['.JURI::base().$image.']]></path>
							<description><![CDATA['.$rows[$i]->title.']]></description>
							<data><![CDATA['.$link.']]></data>
						  </image>';
			}		
		}
		
		$data .= '</content>';
	
		return $data;
		
	  }
	/**
	 *
	 */	
	function getListItems( $catid, $ordering, $limit=10 ) {
            $db = JFactory::getDbo();
            //jimport('joomla.application.component.model');
            // Get an instance of the generic articles model
            $model = JModel::getInstance('Articles', 'ContentModel', array('ignore_request' => true));
              
            // Set application parameters in model
            $appParams = JFactory::getApplication()->getParams();

            $model->setState('params', $appParams);

            // Set the filters based on the module params
            $model->setState('list.start', 0);
            //if($limit>0) {

            $model->setState('list.limit', $limit);
            //}

            $model->setState('filter.published', 1);

            $model->setState('list.select', 'a.fulltext, a.id, a.title, a.alias, a.title_alias, a.introtext, a.state, a.catid, a.created, a.created_by, a.created_by_alias,' .
			' a.modified, a.modified_by,a.publish_up, a.publish_down, a.attribs, a.metadata, a.metakey, a.metadesc, a.access,' .
			' a.hits, a.featured,' .
			' LENGTH(a.fulltext) AS readmore');
            
            // Access filter
            $access = !JComponentHelper::getParams('com_content')->get('show_noauth');
            $authorised = JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));
            $model->setState('filter.access', $access);

            // Category filter
            $model->setState('filter.category_id', explode(",", $catid));

            if($ordering =="ordering"){
                    $model->setState('list.ordering', 'a.ordering');
                    $model->setState('list.direction', 'ASC');
            }else{
                    $model->setState('list.ordering', $ordering);
                    $model->setState('list.direction', 'ASC');
            }

            $items = $model->getItems();

            foreach ($items as &$item) {
                $item->slug = $item->id.':'.$item->alias;
                $item->catslug = $item->catid.':'.$item->category_alias;

                if ($access || in_array($item->access, $authorised))
                {
                        // We know that user has the privilege to view the article
                        $item->link = JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catslug));
                }
                else {
                        $item->link = JRoute::_('index.php?option=com_user&view=login');
                }

                $item->introtext = JHtml::_('content.prepare', $item->introtext);

            }
           return $items;
            
	}
	
	/**
	 *
	 */
	function getImage( $row ) {
		
		global $database, $_MAMBOTS, $current_charset;
		
		$regex = "/\<img.+src\s*=\s*\"([^\"]*)\"[^\>]*\>/";
		$text = $row->introtext.$row->fulltext;
               
		preg_match ($regex, $text, $matches);          
		$tmpAr = array(1);
		$result = array();
		if( !isset($matches[0]) ){
			return '';
		}
		while (count($tmpAr) && $matches[0]) {
		  $result = $matches;
		  preg_match ($regex, $text, $matches); 
		  if (@$matches[0] == '') break;
		  $tmpAr = explode($matches[1],$matches[0]);
		  $text = $tmpAr[0]; 
		}
		$image = (count($result)) ? $result[1] : array();
                
		return $image;
	}
	
	function getTotalItems( $catids, $params  ) {
	
		if ( $params->get('enable_cache', 1) ) {
			$cache =& JFactory::getCache();
			$cache->setCaching( true );
			$cache->setLifeTime( $params->get( 'cache_time', 30 ) * 60 );	
			return  $cache->get( array( $this , '_findCountArticles' ), array( $catids, $params ) ); 
		} else {
			return $this->_findCountArticles(  $catids, $params );
		}	
	}
	
	function _findCountArticles( $catids, $params  )
	{	
		
		$catorsec	= trim( $params->get( 'content-catorsec' , 1));
		
		$ordering	= $params->get( 'content-order', 'created desc' );
		$limit =  $params->get( 'content-max_items', 10 );
		$iwidth 		=  trim($params->get( 'iwidth', ''));
		$iheight 		=  trim($params->get( 'iheight', '' ));
		
		$rows = $this->getListItems( $catids, $ordering, $limit );

		$count = 0;

		for($i=0;$i<count($rows);$i++) {
			  $image = $this->getImage( $rows[$i] );
			 
			  if ( $image ){
			     $count++;
			  } 
		}
		$count = floor((int)$count/2);
		return $count;
	}
	
   function genID( $lenght = 5 ) {
      $chars = "abcdefghijkmnopqrstuvwxyz";
      srand((double)microtime() * 1000000);
      $str = '';

      for($i=0; $i<=$lenght; $i++) {
         $num = rand() % 23;
         $tmp = substr($chars, $num, 1);
         $str = $str . $tmp;
      }
      return $str;
   }
   
	function getModuleParams( $modid ){
		//get module as an object
		$params = array();
		$db =& JFactory::getDBO();
		$db->setQuery("SELECT * FROM #__modules WHERE id='$modid' ");
		$module = $db->loadObject();
		if( $module ){
			//$params = new JParameter( $module->params );
			$params = new JRegistry;
			$params->loadJSON($module->params);
		}	
		return $params;

	}
}
