<?php 
/*
 # ------------------------------------------------------------------------
# JA Newsflash module for Joomla 1.6.x
# ------------------------------------------------------------------------
# Copyright (C) 2004-2009 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
# @license - Copyrighted Commercial Software
# Author: J.O.O.M Solutions Co., Ltd
# Websites:  http://www.joomlart.com -  http://www.joomlancers.com
# This file may not be redistributed in whole or significant part.
# ------------------------------------------------------------------------
*/
  // no direct access
defined('_JEXEC') or die('Restricted access');

require_once JPATH_SITE.'/components/com_content/helpers/route.php';
JModel::addIncludePath(JPATH_SITE.'/components/com_content/models');
if(file_exists(JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'route.php'))
{
	require_once(JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'route.php');
}
if(file_exists(JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'utilities.php'))
{
	require_once(JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'utilities.php');
}
/**
 * modJASildeNews class.
 */
class modJAnewsFlashHelper {

	/**
	 * @var string $condition;
	 *
	 * @access private
	 */
	var $conditons = '';
	
	/**
	 * @var string $order 
	 *
	 * @access private
	 */
	var $order = 'ordering';
	
	/**
	 * @var string $limit
	 *
	 * @access private
	 */
	var $limit  = '';
	
	var $mode = '';
	
	/**
	*@var integer $iwidth
	*@var integer $iheight
	*
	*
	*/
	var $iwidth = 0;
	var $iheight = 0;
	
	
	var $_html = array();
	
	var $_img = array();
	/**
	 * get listing items from rss link or from list of categories.
	 *
	 * @param JParameter $params
	 * @return array
	 */
	function getList( $params ){
		$rows = array();

		// check cache was endable ?
		if ( $params->get('enable_cache',1) ) {
			$cache =& JFactory::getCache();
			$cache->setCaching( true );
			$cache->setLifeTime( $params->get( 'cache_time', 30 ) * 60 );	
			$rows = $cache->get( array( $this , 'getArticles' ), array( $params ) ); 
		} else {
			$rows = $this->getArticles( $params );
		}					

		return $rows;
	}
	
	/**
	 * get articles from list of categories and follow up owner paramer.
	 *
	 * @param JParameter $params.
	 * @return array list of articles
	 */
	function getArticles( $params ){
		$order =  $params->get('sort_order_field' ,'created');
		if( trim($order) != "rand" ) {
			$this->setOrder("a.". $order, $params->get('sort_order','DESC') );
		}else {
			$this->setOrder( "RAND()", "" );
		} 
		$this->setLimit( $params->get('max_items', 5) );
		$rows = $this->getListArticles( $params );
		
		return $rows;							
	}
	
	/**
	 * get list articles follow setting configuration.
	 *
	 * @param JParameter $param
	 * @return array 
	 */
	function getListArticles($params, $showcontentfrontpage = false)
	{
			// Get the dbo
		$db = JFactory::getDbo();

		// Get an instance of the generic articles model
		$model = JModel::getInstance('Articles', 'ContentModel', array('ignore_request' => true));

		// Set application parameters in model
		$appParams = JFactory::getApplication()->getParams();
		$model->setState('params', $appParams);

		// Set the filters based on the module params
		$model->setState('list.start', 0);
		$catid = $params->get( 'catid' , '' );
		if(!empty($catid) && $this->limit > 0) {
			$model->setState('list.limit', $this->limit);
		}
		
		$model->setState('filter.published', 1);

		// Access filter
		$access = !JComponentHelper::getParams('com_content')->get('show_noauth');
		$authorised = JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));
		$model->setState('filter.access', $access);

		// Category filter
		if(!empty($catid)){
			$model->setState('filter.category_id', $catid);
		}
		// Set ordering
		$order_map = array(
			'm_dsc' => 'a.modified DESC, a.created',
			'mc_dsc' => 'CASE WHEN (a.modified = '.$db->quote($db->getNullDate()).') THEN a.created ELSE a.modified END',
			'c_dsc' => 'a.created',
			'p_dsc' => 'a.publish_up',
		);
		$ordering = JArrayHelper::getValue($order_map, 'a.ordering', 'a.publish_up');
		//$dir = 'DESC';
		$model->setState('list.ordering', $this->order);
		$model->setState('list.direction', $this->mode);

		$items = $model->getItems(true);
		if(empty($items)) return;
		foreach ($items as &$item) {
			$item->slug = $item->id.':'.$item->alias;
			$item->catslug = $item->catid.':'.$item->category_alias;

			if ($access || in_array($item->access, $authorised))
			{
				// We know that user has the privilege to view the article
				$item->link = JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catslug));
			}
			else {
				$item->link = JRoute::_('index.php?option=com_user&view=login');
			}

			$item->introtext = JHtml::_('content.prepare', $item->introtext);
		}

		return $items;
	}
	
	/**
	 * parser options, helper for clause where sql.
	 *
	 * @string array $options
	 * @return string.
	 */
	function getIds( $options ){
		if( !is_array($options) ){
			return (int)$options;
		} else {
			return "'".implode( "','", $options  )."'";
		}		
	}
	
	/**
	 * add sort order sql
	 *
	 * @param string $order is article's field.
	 * @param string $mode is DESC or ASC
	 * @return .
	 */
	function setOrder( $order, $mode ){
		$this->order = $order;
		$this->mode = $mode;
		return $this;
	}
	
	/**
	 * add set limit sql
	 * 
	 * @param integer $limit.
	 * @return .
	 */
	function setLimit( $limit ){
		$this->limit = $limit; 
		return $this;
	}
	
	/**
	 * trim string with max specify
	 *  
	 * @param string $title
	 * @param integer $max.
	 */
	function trimString( $title, $max=60  ){

		if( strlen($title) > $max ){
			return substr( $title, 0, $max ) . '...';
		} 
		return $title;
	}
	
	/**
	 * detect and get link with each resource
	 *
	 * @param string $item
	 * @param bool $useRSS.
	 * @return string.
	 */
	function getLink( $item ){
		if(!isset($item->slug) && !isset($item->catslug) && isset($item->categoryalias))
		{
			return	urldecode(JRoute::_(K2HelperRoute::getItemRoute($item->id.':'.urlencode($item->alias), $item->catid.':'.urlencode($item->categoryalias))));
		}
		else
		{
			return  JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catslug));
		}
	
	}
	
	/**
	 *
	 *
	 */
	function replaceImage( &$row, $autoresize, $maxchars, $width = 0, $height = 0 ) {
		global $database, $_MAMBOTS, $current_charset;
		$image = "";
		//Get image
		$regex = "/\<img.*\/\>/";
		preg_match ($regex, $row->introtext, $matches);
		$row->text = preg_replace ($regex, '', $row->introtext);
		
		$row->introtext = preg_replace( $regex, '', $row->introtext );
		$row->introtext = trim($row->introtext);
		
		$image  = count($matches) ? $matches[0] : "";
		
		// clean up globals
		return $image;
	}
	/**
	 *
	 *
	 */
	function renderImage( &$row, $params, $width = 0, $height = 0 ,$maxchars = 100) {
		
			global $database, $_MAMBOTS, $current_charset;
			$image = "";
			$regex = "/\<img.+src\s*=\s*\"([^\"]*)\"[^\>]*\>/";
			preg_match ($regex, $row->text, $matches);
			$align = ($tmp = $params->get("image_alignment","left")) != "auto" ? 'align="'.$tmp.'"' : "";
			$images = (count($matches)) ? $matches : array();
			if (count($images)) $image = $images[1];
		
			if ($image) {
				$thumbnailMode = $params->get( 'thumbnail_mode', 'crop' );
				$aspect 	   = $params->get( 'thumbnail_mode-resize-use_ratio', '1' );
				$crop = $thumbnailMode == 'crop' ? true:false;
				$jaimage = JAImage::getInstance();
				
				if( $thumbnailMode != 'none' && $jaimage->sourceExited($image) ) {
					$imageURL = $jaimage->resize( $image, $width, $height, $crop, $aspect );
					if ( $imageURL == $image ) {
						$width = $width ? "width=\"$width\"" : "";
						$height = $height ? "height=\"$height\"" : "";
						$image = "<img src=\"".JURI::base()."$imageURL\" $align  alt=\"{$row->title}\" title=\"{$row->title}\" $width $height />";
					} else {
						$image = "<img src=\"".JURI::base()."$imageURL\"  $align  alt=\"{$row->title}\" title=\"{$row->title}\" />";
					}
				} else {
					$width = $width ? "width=\"$width\"" : "";
					$height = $height ? "height=\"$height\"" : "";
					$image = "<img src=\"$image\" alt=\"{$row->title}\" $align  title=\"{$row->title}\" $width $height />";	
				}	
			} else {
				$image = '';	
			} 

			$regex1 = "/\<img.*\/\>/";
			$row->introtext = preg_replace( $regex1, '', $row->introtext );
			$row->introtext = trim($row->introtext);
			
			// clean up globals
			return $image;
		}
	/**
	 * output html form custom layout which put in the template of configuration.
	 */
	function outputNewsFlash( &$row, &$params ) {
		
		$mainframe = JFactory::getApplication();
		$row->text 		= $row->introtext;
		$row->readmore 	= (trim( $row->text ) != '') && ($params->get( 'readmore' ));


		$params->set('image', 1);

		$results = $mainframe->triggerEvent( 'onPrepareContent', array( &$row, &$params, null ), true );
		$html = "";
		$newTitle = "";
		if ($params->get('link_titles')) $newTitle .= "<a href=\"".$this->getLink( $row )."\" title=\"".$row->title."\">".$row->title."</a>";
		else $newTitle .= "".$row->title."";
		//Get image
		$regex = "/\<img.*\/\>/";
		$img = $this->renderImage($row, $params,$this->iwidth, $this->iheight);
		//preg_match ($regex, $row->text, $matches);
		$row->text = preg_replace ($regex, '', $row->text);
		$strTemplate =$params->get("templates",'[div style="overflow:hidden; height:323px;" ][div class="nfimages"]##IMAGE##[/div][div class="nftitle"]##TITLE##[/div][div class="nfcontent"]##CONTENT##[/div][/div]');
		
		$strTemplate = $this->_replaceBBCode($strTemplate);
		$newReadmore 	=	"<a href=\"".$this->getLink( $row )."\" title=\"".$row->title."\">".JText::_('READ_MORE')."</a>";
		//$html = str_replace( "##TITLE##",$newTitle, );
		$html = str_replace( "##TITLE##",$newTitle,$strTemplate);
		$html = str_replace("##CONTENT##",$row->text,$html);
		
		//$img  = count($matches) ? $matches[0] : "";
		$regex = "/src\=\"images/";
		$img = preg_replace($regex,'src="'.JURI::base().'images/', $img );
		$this->_img[] = $img;
		if( $img && ($params->get('link_images',0)) ) {
			$img =  "<a href=\"".$this->getLink( $row )."\" title=\"".$row->title."\">".$img."</a>";
		}
		$html = str_replace("##IMAGE##", $img, $html);
		$html =	str_replace("##READMORE##",$newReadmore,$html );
		$this->_html[] = $html;
		return $html;
	}
	private function _replaceBBCode($strBB = "")
	{
		$strReturn = "";
		if(!empty($strBB))
		{
			$arrFind = array("[","]");
			$arrReplace = array("<",">");
			$strReturn = str_replace($arrFind,$arrReplace,$strBB);
		}
		return $strReturn;
	}
}
?>