<?php
/*
# ------------------------------------------------------------------------
# JA Amazon S3 installation Package (component & Plugin)
# ------------------------------------------------------------------------
# Copyright (C) 2004-2010 JoomlArt.com. All Rights Reserved.
# @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
# Author: JoomlArt.com
# Websites: http://www.joomlart.com - http://www.joomlancers.com.
# ------------------------------------------------------------------------
*/

// Try extending time, as unziping/ftping took already quite some... :
@set_time_limit( 0 );

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.installer.installer');

// Load Component JA Amazon S3 language file
$lang = &JFactory::getLanguage();
$lang->load('com_jaamazons3');
$component_name = JText::_('COMPONENT_JA_AMAZON_S3');

$db = & JFactory::getDBO();
$status = new JObject();
$status->modules = array();
$status->plugins = array();
//path to install folder
$src = $this->parent->getPath('source');
//path to extended extensions
$src .= DS.'packages';

/**
 * Structure of folder package' elements
 * 
 * packages
 * 	- modules
 * 		- administrator (client="administrator")
 * 			- mod_ja...
 * 		- site
 * 			- mod_ja...
 * 	- plugins
 * 		- system
 * 			- plg_system_ja...
 * 		- editor
 * 		- other groups ...
 */

$modules = &$this->manifest->getElementByPath('package_elements/modules');
$plugins = &$this->manifest->getElementByPath('package_elements/plugins');
//other extensions type..

//install modules
if (is_a($modules, 'JSimpleXMLElement') && count($modules->children())) {
	foreach ($modules->children() as $module) {
		$mname 		= $module->attributes('module');
		$client 	= $module->attributes('client');
		if(is_null($client)) $client = 'site';

		$path 		=  $src.DS.'modules'.DS.$client.DS.$mname;
		$installer 	= new JInstaller;
		$result 	= $installer->install($path);
		$status->modules[] = array('name'=>$mname,'client'=>$client, 'result'=>$result);
	}
}

//install plugins
if (is_a($plugins, 'JSimpleXMLElement') && count($plugins->children())) {

	foreach ($plugins->children() as $plugin) {
		$pname 		= $plugin->attributes('plugin');
		$pgroup 	= $plugin->attributes('group');
		if(is_null($pgroup)) continue;

		$path 		= $src.DS.'plugins'.DS.$pgroup.DS.$pname;
		$installer 	= new JInstaller;
		$result 	= $installer->install($path);
		$status->plugins[] = array('name'=>$pname,'group'=>$pgroup, 'result'=>$result);

		//Enable plugin
		//Remove below comment if you want to automatically enable plugins
		/*$query = "UPDATE #__plugins SET published=1 WHERE element=".$db->Quote($pname)." AND folder=".$db->Quote($pgroup);
		$db->setQuery($query);
		$db->query();*/
	}
}

// Update Database Tables
// for joomla upgrade method
// if user using JAEM, the upgrade script file will be excute instead of
$db = &JFactory::getDBO();

//alter talbe bucket
$fields = $db->getTableFields('#__jaamazons3_bucket');

if (!array_key_exists('bucket_cloudfront_domain', $fields['#__jaamazons3_bucket'])) {
	$query = "ALTER TABLE `#__jaamazons3_bucket` ADD `bucket_cloudfront_domain` VARCHAR( 255 ) NOT NULL AFTER `bucket_acl`";
	$db->setQuery($query);
	$db->query();
}
if (!array_key_exists('bucket_url_format', $fields['#__jaamazons3_bucket'])) {
	$query = "ALTER TABLE `#__jaamazons3_bucket` ADD `bucket_url_format` VARCHAR(20) NOT NULL AFTER `bucket_acl`";
	$db->setQuery($query);
	$db->query();
}
if (!array_key_exists('bucket_protocol', $fields['#__jaamazons3_bucket'])) {
	$query = "ALTER TABLE `#__jaamazons3_bucket` ADD `bucket_protocol` VARCHAR(20) NOT NULL AFTER `bucket_acl`";
	$db->setQuery($query);
	$db->query();
}
if (!array_key_exists('last_sync', $fields['#__jaamazons3_bucket'])) {
	$query = "ALTER TABLE `#__jaamazons3_bucket` ADD `last_sync` datetime NOT NULL";
	$db->setQuery($query);
	$db->query();
}

if (!array_key_exists('site_path', $fields['#__jaamazons3_bucket'])) {
	$query = "
		ALTER TABLE `#__jaamazons3_bucket` DROP `bucket_vhost`;
		ALTER TABLE `#__jaamazons3_bucket` DROP `site_path`;
		ALTER TABLE `#__jaamazons3_bucket` DROP `site_url`;
		ALTER TABLE `#__jaamazons3_bucket` DROP `cron_enable`;
		ALTER TABLE `#__jaamazons3_bucket` DROP `cron_minute`;
		ALTER TABLE `#__jaamazons3_bucket` DROP `cron_hour`;
		ALTER TABLE `#__jaamazons3_bucket` DROP `cron_day`;
		ALTER TABLE `#__jaamazons3_bucket` DROP `cron_last_run`;";
	$db->setQuery($query);
	$db->query();
}

//alter table #__jaamazons3_disabled
$fields = $db->getTableFields('#__jaamazons3_disabled');

if (array_key_exists('bucket_id', $fields['#__jaamazons3_disabled'])) {
	//change field `bucket_id` to `profile_id`
	
	$query = "ALTER TABLE `#__jaamazons3_disabled` CHANGE `bucket_id` `profile_id` int(11) NOT NULL";
	$db->setQuery($query);
	$db->query();
	
	//remove old data (this data is not correct on new version)
	$query = "TRUNCATE `#__jaamazons3_disabled`";
	$db->setQuery($query);
	$db->query();
}

//alter talbe file
$fields = $db->getTableFields('#__jaamazons3_file');

if (!array_key_exists('file_original_checksum', $fields['#__jaamazons3_file'])) {
	$query = "ALTER TABLE `#__jaamazons3_file` ADD `file_original_checksum` varchar(100) NOT NULL AFTER `file_checksum`";
	$db->setQuery($query);
	$db->query();
}

//alter talbe profile
$fields = $db->getTableFields('#__jaamazons3_profile');

if (!array_key_exists('cache_lifetime', $fields['#__jaamazons3_profile'])) {
	$query = "ALTER TABLE `#__jaamazons3_profile` ADD `cache_lifetime` INT(11) NOT NULL AFTER `site_url`";
	$db->setQuery($query);
	$db->query();
}
if (!array_key_exists('use_smushit', $fields['#__jaamazons3_profile'])) {
	$query = "ALTER TABLE `#__jaamazons3_profile` ADD `use_smushit` tinyint(1) NOT NULL AFTER `site_url`";
	$db->setQuery($query);
	$db->query();
}

//create default profile for table #__jaamazons3_profile
$query = "
INSERT IGNORE INTO `jos_jaamazons3_profile` 
(`id`, `bucket_id`, `profile_name`, `allowed_extension`, `site_path`, `site_url`, `use_smushit`, `cache_lifetime`, `cron_enable`, `cron_minute`, `cron_hour`, `cron_day`, `cron_last_run`, `is_default`, `profile_status`) VALUES
(1, 0, 'Default', 'js,css,jpg,gif,png,bmp,doc,pdf', '{jpath_root}', '{juri_root}', 0, 0, 0, 30, 0, 0, '0000-00-00 00:00:00', 1, 1),
(2, 0, 'caches folder', 'js,css,jpg,gif,png,bmp,doc,pdf', '{jpath_root}', '{juri_root}', 0, 0, 0, 10, 0, 0, '0000-00-00 00:00:00', 0, 0);
";
$db->setQuery($query);
$db->query();

//set default disabled item
$query = "
INSERT IGNORE INTO `#__jaamazons3_disabled` (`profile_id`, `path`) VALUES
(1, 'administrator'),
(1, 'cache'),
(1, 'includes'),
(1, 'language'),
(1, 'libraries'),
(1, 'logs'),
(1, 'resources'),
(1, 'xmlrpc'),
(1, '_installation'),
(2, 'administrator'),
(2, 'components'),
(2, 'images'),
(2, 'includes'),
(2, 'language'),
(2, 'libraries'),
(2, 'logs'),
(2, 'media'),
(2, 'modules'),
(2, 'plugins'),
(2, 'resources'),
(2, 'templates'),
(2, 'xmlrpc'),
(2, '_installation');
";
$db->setQuery($query);
$db->query();

//Remove an old version of Library Cloudfusion
$oldLibPath = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jaamazons3'.DS.'lib'.DS.'cloudfusion';
if(JFolder::exists($oldLibPath)) {
	JFolder::delete($oldLibPath);
}

//Auto enable and reordering plugin
//this plugin should be run after plugin but before cache plugin
$queryOdering = "SELECT * FROM `#__plugins` WHERE `element` = 'cache' AND `folder` = 'system'";
$db->setQuery($queryOdering);
$rowCache = $db->loadObject();
if(is_object($rowCache)) {
	$cachePosition = (int) $rowCache->ordering;
	$plgPosition = ($cachePosition) ? $cachePosition - 1 : 0;
} else {
	$plgPosition = 100;
}

$query = "UPDATE `#__plugins` SET `published` = 1, `ordering` = {$plgPosition} WHERE `element` = 'plg_jaamazons3'";
$db->setQuery($query);
$db->query();
?>
<br /><br />
<div style="padding:10px; text-align: center;">
	<div style="font-size: 38px;text-descoration: bold;"><?php echo JText::_('ALMOST_DONE'); ?></div>
	<?php echo JText::_('VIDEO_GUIDELINE_MESSAGE'); ?>
	<h2><?php echo JText::_('OVERVIEW_AND_GUIDELINE'); ?></h2>
	<object width="640" height="385"><param name="movie" value="http://www.youtube.com/v/dtknH2ljq5Q?fs=1&amp;hl=en_US"></param><param name="allowFullScreen" value="true"></param><param name="allowscriptaccess" value="always"></param><embed src="http://www.youtube.com/v/dtknH2ljq5Q?fs=1&amp;hl=en_US" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="640" height="385"></embed></object>
</div>

<?php $rows = 0;?>
<h2><?php echo JText::_('JA_AMAZON_S3').': '.JText::_('INSTALLATION_STATUS'); ?></h2>
<table class="adminlist">
  <thead>
    <tr>
      <th class="title" colspan="2"><?php echo JText::_('EXTENSION'); ?></th>
      <th width="30%"><?php echo JText::_('STATUS'); ?></th>
    </tr>
  </thead>
  <tfoot>
    <tr>
      <td colspan="3"></td>
    </tr>
  </tfoot>
  <tbody>
    <tr class="row0">
      <td class="key" colspan="2"><?php echo $component_name; ?></td>
      <td><strong><?php echo JText::_('INSTALLED'); ?></strong></td>
    </tr>
    <?php if (count($status->modules)) : ?>
    <tr>
      <th><?php echo JText::_('MODULE'); ?></th>
      <th><?php echo JText::_('CLIENT'); ?></th>
      <th></th>
    </tr>
    <?php foreach ($status->modules as $module) : ?>
    <tr class="row<?php echo (++ $rows % 2); ?>">
      <td class="key"><?php echo $module['name']; ?></td>
      <td class="key"><?php echo ucfirst($module['client']); ?></td>
      <td><strong><?php echo ($module['result'])?JText::_('INSTALLED'):JText::_('NOT_INSTALLED'); ?></strong></td>
    </tr>
    <?php endforeach;?>
    <?php endif;?>
    <?php if (count($status->plugins)) : ?>
    <tr>
      <th><?php echo JText::_('PLUGIN'); ?></th>
      <th><?php echo JText::_('GROUP'); ?></th>
      <th></th>
    </tr>
    <?php foreach ($status->plugins as $plugin) : ?>
    <tr class="row<?php echo (++ $rows % 2); ?>">
      <td class="key"><?php echo ucfirst($plugin['name']); ?></td>
      <td class="key"><?php echo ucfirst($plugin['group']); ?></td>
      <td><strong><?php echo ($plugin['result'])?JText::_('INSTALLED'):JText::_('NOT_INSTALLED'); ?></strong></td>
    </tr>
    <?php endforeach; ?>
    <?php endif; ?>
  </tbody>
</table>