<?php
/*
 * ------------------------------------------------------------------------
 * JA Amazon S3 for joomla 17
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * ------------------------------------------------------------------------
*/

// Try extending time, as unziping/ftping took already quite some... :
@set_time_limit( 0 );

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.installer.installer');

// Load Component JA Amazon S3 language file
$lang = &JFactory::getLanguage();
$lang->load('com_jaamazons3');
$component_name = JText::_('COMPONENT_JA_AMAZON_S3');

$db = & JFactory::getDBO();
$status = new JObject();
$status->modules = array();
$status->plugins = array();
//path to install folder
$src = $this->parent->getPath('source');
//path to extended extensions
$src .= DS.'packages';

/**
 * Structure of folder package' elements
 * 
 * packages
 * 	- modules
 * 		- administrator (client="administrator")
 * 			- mod_ja...
 * 		- site
 * 			- mod_ja...
 * 	- plugins
 * 		- system
 * 			- plg_system_ja...
 * 		- editor
 * 		- other groups ...
 */

if($this->manifest->package_elements->modules) {
	$modules = $this->manifest->package_elements->modules;
} else {
	$modules = null;
}

if($this->manifest->package_elements->plugins) {
	$plugins = $this->manifest->package_elements->plugins;
} else {
	$plugins = null;
}
//other extensions type..

//install modules
if ($modules && count((array) $modules)) {
	foreach ($modules->module as $module) {
		$mname 		= $module->attributes()->module;
		$client 	= $module->attributes()->client;
		if(is_null($client)) $client = 'site';

		$path 		=  $src.DS.'modules'.DS.$client.DS.$mname;
		$installer 	= new JInstaller();
		$result 	= $installer->install($path);
		$status->modules[] = array('name'=>$mname,'client'=>$client, 'result'=>$result);
	}
}

//install plugins
if ($plugins && count((array) $plugins)) {
	foreach ($plugins->plugin as $plugin) {
		$pname 		= $plugin->attributes()->plugin;
		$pgroup 	= $plugin->attributes()->group;
		if(is_null($pgroup)) continue;

		$path 		= $src.DS.'plugins'.DS.$pgroup.DS.$pname;
		$installer 	= new JInstaller();
		$result 	= $installer->install($path);
		$status->plugins[] = array('name'=>$pname,'group'=>$pgroup, 'result'=>$result);

		//Enable plugin
		//Remove below comment if you want to automatically enable plugins
		/*$query = "UPDATE #__extensions SET enabled=1 WHERE `type`='plugin' element=".$db->Quote($pname)." AND folder=".$db->Quote($pgroup);
		$db->setQuery($query);
		$db->query();*/
	}
}

// Update Database Tables
// for joomla upgrade method
$db = &JFactory::getDBO();

//Remove an old version of Library Cloudfusion
$oldLibPath = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jaamazons3'.DS.'lib'.DS.'cloudfusion';
if(JFolder::exists($oldLibPath)) {
	JFolder::delete($oldLibPath);
}

//Auto enable and reordering plugin
//this plugin should be run after plugin but before cache plugin
$queryOdering = "SELECT * FROM `#__extensions` WHERE `type`='plugin' AND `element` = 'cache' AND `folder` = 'system'";
$db->setQuery($queryOdering);
$rowCache = $db->loadObject();
if(is_object($rowCache)) {
	$cachePosition = (int) $rowCache->ordering;
	$plgPosition = ($cachePosition) ? $cachePosition - 1 : 0;
} else {
	$plgPosition = 100;
}

$query = "UPDATE `#__extensions` SET `enabled` = 1, `ordering` = {$plgPosition} WHERE `type`='plugin' AND `element` = 'plg_jaamazons3'";
$db->setQuery($query);
$db->query();
?>
<br /><br />
<div style="padding:10px; text-align: center;">
	<div style="font-size: 38px;text-descoration: bold;"><?php echo JText::_('ALMOST_DONE'); ?></div>
	<?php echo JText::_('VIDEO_GUIDELINE_MESSAGE'); ?>
	<h2><?php echo JText::_('OVERVIEW_AND_GUIDELINE'); ?></h2>
	<object width="640" height="385"><param name="movie" value="http://www.youtube.com/v/dtknH2ljq5Q?fs=1&amp;hl=en_US"></param><param name="allowFullScreen" value="true"></param><param name="allowscriptaccess" value="always"></param><embed src="http://www.youtube.com/v/dtknH2ljq5Q?fs=1&amp;hl=en_US" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="640" height="385"></embed></object>
</div>

<?php $rows = 0;?>
<h2><?php echo JText::_('JA_AMAZON_S3').': '.JText::_('INSTALLATION_STATUS'); ?></h2>
<table class="adminlist">
  <thead>
    <tr>
      <th class="title" colspan="2"><?php echo JText::_('EXTENSION'); ?></th>
      <th width="30%"><?php echo JText::_('STATUS'); ?></th>
    </tr>
  </thead>
  <tfoot>
    <tr>
      <td colspan="3"></td>
    </tr>
  </tfoot>
  <tbody>
    <tr class="row0">
      <td class="key" colspan="2"><?php echo $component_name; ?></td>
      <td><strong><?php echo JText::_('INSTALLED'); ?></strong></td>
    </tr>
    <?php if (count($status->modules)) : ?>
    <tr>
      <th><?php echo JText::_('MODULE'); ?></th>
      <th><?php echo JText::_('CLIENT'); ?></th>
      <th></th>
    </tr>
    <?php foreach ($status->modules as $module) : ?>
    <tr class="row<?php echo (++ $rows % 2); ?>">
      <td class="key"><?php echo $module['name']; ?></td>
      <td class="key"><?php echo ucfirst($module['client']); ?></td>
      <td><strong><?php echo ($module['result'])?JText::_('INSTALLED'):JText::_('NOT_INSTALLED'); ?></strong></td>
    </tr>
    <?php endforeach;?>
    <?php endif;?>
    <?php if (count($status->plugins)) : ?>
    <tr>
      <th><?php echo JText::_('PLUGIN'); ?></th>
      <th><?php echo JText::_('GROUP'); ?></th>
      <th></th>
    </tr>
    <?php foreach ($status->plugins as $plugin) : ?>
    <tr class="row<?php echo (++ $rows % 2); ?>">
      <td class="key"><?php echo ucfirst($plugin['name']); ?></td>
      <td class="key"><?php echo ucfirst($plugin['group']); ?></td>
      <td><strong><?php echo ($plugin['result'])?JText::_('INSTALLED'):JText::_('NOT_INSTALLED'); ?></strong></td>
    </tr>
    <?php endforeach; ?>
    <?php endif; ?>
  </tbody>
</table>