<?php
/*
# ------------------------------------------------------------------------
# JA flowlist module for Joomla 1.6.x
# ------------------------------------------------------------------------
# Copyright (C) 2004-2009 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
# @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
# Author: J.O.O.M Solutions Co., Ltd
# Websites: http://www.joomlart.com - http://www.joomlancers.com
# ------------------------------------------------------------------------
*/

if (!defined ('_JEXEC')) {
	define( '_JEXEC', 1 );
	$path = dirname(dirname(dirname(dirname(__FILE__))));
	define('JPATH_BASE', $path );

	if (strpos(php_sapi_name(), 'cgi') !== false && !empty($_SERVER['REQUEST_URI'])) {
		//Apache CGI
		$_SERVER['PHP_SELF'] =  rtrim(dirname(dirname(dirname($_SERVER['PHP_SELF']))), '/\\');
	} else {
		//Others
		$_SERVER['SCRIPT_NAME'] =  rtrim(dirname(dirname(dirname($_SERVER['SCRIPT_NAME']))), '/\\');
	}
	
	define( 'DS', DIRECTORY_SEPARATOR );
	
	require_once JPATH_BASE.DS.'includes'.DS.'defines.php';
	require_once JPATH_BASE.DS.'includes'.DS.'framework.php';
	
	// Mark afterLoad in the profiler.
	JDEBUG ? $_PROFILER->mark('afterLoad') : null;
	
	// Instantiate the application.
	$app = JFactory::getApplication('site');
	
	// Initialise the application.
	$app->initialise();
	
	// Mark afterIntialise in the profiler.
	JDEBUG ? $_PROFILER->mark('afterInitialise') : null;

	// Route the application.
	$app->route();
	
	// Mark afterRoute in the profiler.
	JDEBUG ? $_PROFILER->mark('afterRoute') : null;
	
	// Dispatch the application.
	$app->dispatch();
	
	// Mark afterDispatch in the profiler.
	JDEBUG ? $_PROFILER->mark('afterDispatch') : null;
	
	// Render the application.
	$app->render();
	
	// Mark afterRender in the profiler.
	JDEBUG ? $_PROFILER->mark('afterRender') : null;

}
require_once (dirname(dirname(__FILE__)).'/helper.php');

$helper = modJaFlowListHelper::getInstance();
$params = $helper->getModuleParams( (int)JRequest::getInt('modid') );

if( is_object($params) ) {
	$type = $params->get( 'type', 'content' );
	if ( $type == "content" ){
		$catids = $params->get( 'content-catid', '' );
		if( $catids != "" ){
			if( !is_array($catids) ){
				$catids = array( $catids );
			}
			$catids = implode( ',', $catids );
		}
		$data = $helper->buildXML($catids, $params );
		
	}
	else {
		$data = $helper->buildXMLF( $params );
	}
	echo $data;
}
?>