<?php
/*
# ------------------------------------------------------------------------
# JA Tooltips plugin for joomla j15
# ------------------------------------------------------------------------
# Copyright (C) 2004-2010 JoomlArt.com. All Rights Reserved.
# @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
# Author: JoomlArt.com
# Websites: http://www.joomlart.com - http://www.joomlancers.com.
# ------------------------------------------------------------------------
*/

// Check to ensure this file is included in Joomla!

defined( '_JEXEC' ) or die();	
jimport( 'joomla.plugin.plugin' );
jimport('joomla.application.module.helper');

/**
 * Jatabs Content Plugin
 *
 * @package		Joomla
 * @subpackage	Content
 * @since 		1.5
 */


class plgContentJA_tooltips extends JPlugin
{
  	var $style_default = '';
  	var $width_default = 0;
  	var $stiky_default = 0;
  	var $classname_default = '';
  	
  
	function plgContentJA_tooltips( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		$modules = JModuleHelper::_load();
		$i = 0;
		foreach ($modules as $module) {
			if ($module->module == 'mod_custom') {
				$row = new stdClass();
				$row->text = $module->content;
				$params = null;
				$mod = &$modules[$i];
				$mod->content = $this->onPrepareContent ($row, $params, 0);
			}
			$i++;
		}
	}

	/**
	 * tabs prepare content method
	 *
	 * Method is called by the view
	 *
	 * @param 	object		The article object.  Note $article->text is also available
	 * @param 	object		The article params
	 * @param 	int			The 'page' number
	 */
	function onPrepareContent( &$article, &$params, $limitstart )
	{
		global $mainframe;
		
		$plugin	=& JPluginHelper::getPlugin('content', 'ja_tooltips');
		$this->plgParams = new JParameter( $plugin->params );
		if (JString::strpos( $article->text, '{jatooltips' ) === false){
			$HSmethodDIRECT = false;
		}else{
			$HSmethodDIRECT = true;
		}
		
		if(!defined("JA_PLG_TIPS_HEADTAG")) $this->JATooltips_PrepareSettings();

		if($HSmethodDIRECT){
			require_once('plugins/content/ja_tooltips/parser.php');
			$parser = new ReplaceCallbackParser('jatooltips');
			$article->text =  $parser->parse ($article->text, array(&$this, 'JATooltips_replacer_DIRECT'));			
		}
		return $article->text;
	}

	function JATooltips_PrepareSettings(){
		global $mainframe;
		
		$hs_base    = JURI::base().'plugins/content/ja_tooltips/';
		$headtag    = array();
		$headtag[] = JHTML::_('behavior.mootools');
		$headtag[] = "<script type='text/javascript' src='".$hs_base."ja.tooltips.js' charset=\"utf-8\"></script>";		
		$mainframe->addCustomHeadTag(implode("\n", $headtag));
		define("JA_PLG_TIPS_HEADTAG", TRUE);
	}
	
	function JATooltips_replacer_DIRECT($plgAttr, $plgContent)
	{
		//params of tip		
		$params = '';
		$params = $this->parseParams($plgAttr);				
		
		if (!isset($params['type'])) $params['type'] = 'html';
		//set default value for param:
		if (!isset($params['style'])) $params['style'] = $this->plgParams->get('style', 'default');
		if (!isset($params['showtitle'])) $params['showtitle'] = $this->plgParams->get('showtitle', true);
		if (!isset($params['maxTitleChars'])) $params['maxTitleChars'] = $this->plgParams->get('maxTitleChars', '');
		if (!isset($params['showDelay'])) $params['showDelay'] = $this->plgParams->get('showDelay', '');
		if (!isset($params['hideDelay'])) $params['hideDelay'] = $this->plgParams->get('hideDelay', '');
		if (!isset($params['pos'])) $params['pos'] = $this->plgParams->get('pos', '');
		if (!isset($params['offsetx'])) $params['offsetx'] = (int)$this->plgParams->get('offsetx', '');
		if (!isset($params['offsety'])) $params['offsety'] = (int)$this->plgParams->get('offsety', '');
		if (!isset($params['showwhen'])) $params['showwhen'] = $this->plgParams->get('showwhen', '');
		if (!isset($params['hidewhen'])) $params['hidewhen'] = $this->plgParams->get('hidewhen', '');
		if (!isset($params['width'])) $params['width'] = $this->plgParams->get('width', 0);		
				
		$matches = null;
		switch ($params['type']){
			case 'module':
				$regex = '/\[title\]([^\]]*)\[\/title\]/';
				if (preg_match($regex, $plgContent, $matches)) {
					$title = $matches[1];
				} else
					$title = $plgContent;
				$content = $this->parseTipModule($params);
				break;
			case 'article':	
				$regex = '/\[title\]([^\]]*)\[\/title\]/';
				if (preg_match($regex, $plgContent, $matches)) {
					$title = $matches[1];
				} else
					$title = $plgContent;
				
				$content = $this->parseTipArticle($params);
				break;					
			case 'html':
			default:
				$title = "";
				$content = "";
				$regex = '/\[title\]([^\]]*)\[\/title\]/';
				if (preg_match($regex, $plgContent, $matches)) {
					$title = $matches[1];
				}
				$regex = '/\[content\]([^\]]*)\[\/content\]/';
				if (preg_match($regex, $plgContent, $matches)) {
					$content = $matches[1];
				}
				break;
		}
		
		return $this->wirentTipContent ($title, $content, $params);
	}
	
	function wirentTipContent($title, $content, $params){
		global $mainframe;
		if ($this->plgParams->get('enable') == 'no') return $title;
		
		if(!defined("JA_PLG_TIPS_HEADTAG_".strtoupper($params['style']))){
			$headtag[] = '<link rel="stylesheet" href="'.JURI::base().'plugins/content/ja_tooltips/themes/'.$params['style'].'/style.css" type="text/css" media="screen"/>';
			$mainframe->addCustomHeadTag(implode("\n", $headtag));
			define("JA_PLG_TIPS_HEADTAG_".strtoupper($params['style']), true);
		}
		
		$tipid = 'ja-tip-'.rand(0,9).rand(0,9).rand(0,9);
		
		$html = "<a class=\"ja-tips-title\" id=\"$tipid\">$title</a>";

		$search = 	array("'", "/","\r\n","\n");
		$replace = 	array("\\'", "\\/","\\n","\\n");
		$title = str_replace($search, $replace, $title);
		$content = str_replace($search, $replace, $content);
		$options = '';
		if ($params['showtitle'] && !in_array($params['showtitle'], array(0, '0', 'no', 'No', false, 'false', 'False'))) {
			$options .= ", title: '$title'";
		}
		if ($params['style']) {
			$options .= ", style:'{$params['style']}'";
		}
		if ($params['showDelay']) {
			$options .= ", showDelay: ".intval($params['showDelay']);
		}
		if ($params['hideDelay']) {
			$options .= ", hideDelay: ".intval($params['hideDelay']);
		}
		if ($params['width']) {
			$options .= ", width: ".intval($params['width']);
		}
		if ($params['pos']) {
			$options .= ", pos:'{$params['pos']}'";
		}
		if (($params['showwhen'])) {
			$options .= ", showwhen:'{$params['showwhen']}'";
		}
		if (($params['hidewhen'])) {
			$options .= ", hidewhen:'{$params['hidewhen']}'";
		}
		$offsets = '';
		if (isset($params['offsetx'])) {
			$offsets .= "'x':{$params['offsetx']}";
		}
		if (isset($params['offsety'])) {
			if ($offsets) $offsets .= ',';
			$offsets .= "'y':{$params['offsety']}";
		}
		if ($offsets) {
			$options .= ", offsets: {{$offsets}}";
		}
		
		$html .= "<script type=\"text/javascript\">
		/*<![CDATA[*/
						window.addEvent('domready', function(){
							new JATooltips ([$('$tipid')], {
								content: '$content' 
								$options
							});
						});
		/*]]>*/				
				 </script>";	
		return $html;		
	}
	
	function parseTipModule($params){
		
		$module = null;
		if (isset($params['name'])) {
			$mod_search = 'module';
			$mod_match = trim($params['name']);
			if (substr($mod_match, 0, 4) != 'mod_') $mod_match='mod_'.$mod_match;
		}
		if (isset($params['id'])) {
			$mod_search = 'id';
			$mod_match = $params['id'];
		}
		
		if ($mod_search) {
			$modules = JModuleHelper::_load();
			foreach ($modules as $mod)
			{
				// Match the name of the module
				if ($mod->$mod_search == $mod_match)
				{
					$module = $mod;
					break;
				}
			}
		}
		
		if ($module && $module->module != 'mod_jatooltips') {
			return JModuleHelper::renderModule($module)."<br />";									
		}
		return "";
	}
	
	function parseTipArticle($params){
		if(isset($params['id'])){
			$row = $this->getList($params['id']);
		}					
						
		if($row){
			$contents  .= "<h3><span>".$row->title."</span></h3><br/>";
			if(!isset($params['view']) || $params['view']!='fulltext' || $row->fulltext ==''){
				$contents .= $row->introtext;
			}
			else{
				$contents .= $row->introtext.$row->fulltext;								
			}			
			return $contents;
		}
		
		return '';
	}			
	
	function getList($id=0)
	{
		if(is_numeric($id) && $id>0){
			global $mainframe;
			$db 	=& JFactory::getDBO();
			$user 	=& JFactory::getUser();
			$aid	= $user->get('aid', 0);
	
			$contentConfig	= &JComponentHelper::getParams( 'com_content' );
			$noauth			= !$contentConfig->get('shownoauth');
	
			jimport('joomla.utilities.date');
			$date = new JDate();
			$now = $date->toMySQL();
	
			$nullDate = $db->getNullDate();
	
			// query to determine article count
			$query = 'SELECT a.*' .			
				' FROM #__content AS a' .
				' INNER JOIN #__categories AS cc ON cc.id = a.catid' .
				' INNER JOIN #__sections AS s ON s.id = a.sectionid';
			$query .=	' WHERE a.state = 1 ' .
				($noauth ? ' AND a.access <= ' .(int) $aid. ' AND cc.access <= ' .(int) $aid. ' AND s.access <= ' .(int) $aid : '').
				' AND (a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' ) ' .
				' AND (a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )' .				
				' AND cc.section = s.id' .
				' AND cc.published = 1' .
				' AND s.published = 1'.
				"\n AND a.id = '$id'";
							
			$query .= ' ORDER BY a.ordering ' ;				
	
			$db->setQuery($query);
			$row = $db->loadObject();		
			
			jimport('joomla.plugin.helper');
			JPluginHelper::importPlugin('content');
			
			$app = &JFactory::getApplication();
			$pparams = new JParameter('');
			
			$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');
	  
	  		if ($row) {
	  		 	$row->text = $row->introtext;
		  		$app->triggerEvent('onPrepareContent', array (& $row, & $params, $limitstart));
		   		$row->introtext = $row->text;
	  		}	  		
			return $row;
		}
		return ;
	}
	
	function getPattern ($tag) {
	 $regex = '#{'.$tag.' ([^}]*)}([^{]*){/'.$tag.'}#m';

	  return $regex;
	}
	
	function parseParams($params) {
		$params = html_entity_decode($params, ENT_QUOTES);
		$regex = "/\s*([^=\s]+)\s*=\s*('([^']*)'|\"([^\"]*)\"|([^\s]*))/";
		preg_match_all($regex, $params, $matches);
		
		 $paramarray = null;
		 if(count($matches)){
			$paramarray = array();
				for ($i=0;$i<count($matches[1]);$i++){ 
				  $key = $matches[1][$i];
				  $val = $matches[3][$i]?$matches[3][$i]:($matches[4][$i]?$matches[4][$i]:$matches[5][$i]);
				  $paramarray[$key] = $val;
				}
		  }
		  return $paramarray;
	}
}
?>