<?php
/*
# ------------------------------------------------------------------------
# JA Highslide plugin for Joomla 1.6.x
# ------------------------------------------------------------------------
# Copyright (C) 2004-2009 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
# @license - Copyrighted Commercial Software
# Author: J.O.O.M Solutions Co., Ltd
# Websites:  http://www.joomlart.com -  http://www.joomlancers.com
# This file may not be redistributed in whole or significant part.
# ------------------------------------------------------------------------
*/

// Check to ensure this file is included in Joomla!

defined( '_JEXEC' ) or die();
jimport( 'joomla.plugin.plugin' );
jimport('joomla.application.module.helper');

/**
 * Highslide Sytem Plugin
 *
 * @package		Joomla
 * @subpackage	Sytem
 * @since 		1.6
 */
class plgSystemJAhighslide extends JPlugin
{	
	/**
	 * Highslide prepare content method
	 *
	 * Method is called by the view
	 *
	 * @param 	object		The article object.  Note $article->text is also available
	 * @param 	object		The article params
	 * @param 	int			The 'page' number
	 */
	 function plgSystemJAhighslide( &$subject ){
		parent::__construct( $subject );

		// load plugin parameters
		$this->_plugin = JPluginHelper::getPlugin( 'system', 'jahighslide' );
		$this->_params = new JRegistry;
		$this->_params->loadJSON($this->_plugin->params);
	 }
	 
	public function onAfterRender()
	{	
		$mainframe = JFactory::getApplication();
		
		if ( $mainframe->isAdmin() ) { return; }
		
		if (!isset($this->_plugin)) return;
		
		$_body = JResponse::getBody();
		
		if (JString::strpos( $_body , '{highslide' ) === false){
			$HSmethodDIRECT = false;
		}else{
			$HSmethodDIRECT = true;
		}
		
		if(!defined("HSLPLUGIN_HEADTAG")) $this->loadSkin();
		
		
		if($HSmethodDIRECT){
			
			//$_SESSION['width'] = $pluginParams->get('width');
			$_body = $this->stylesheet ( $this->_plugin, $_body );
			
			require_once dirname(__FILE__).DS.'highslide'.DS.'parser.php';
			require_once dirname(__FILE__).DS.'highslide'.DS.'jaimage.php';
			
			$parser = new ReplaceCallbackParser('highslide');
			$_body =  $parser->parse ($_body , array(&$this, 'highslide_replacer_DIRECT'));								
		}

		if ( $_body ) {
			JResponse::setBody( $_body );
		}
		return true;
	}

	function loadSkin(){
		
		define("HSLPLUGIN_HEADTAG", TRUE);
	}
	
	function stylesheet($plugin, $bodyString) {		
		$mainframe = JFactory::getApplication();
		$params = new JRegistry;
		$params->loadJSON($this->_plugin->params);
		$hs_base    = JURI::base().'plugins/system/jahighslide/highslide';
		$assets_url = JURI::base().'plugins/system/jahighslide/highslide/';
		$headtag = array ();
		
		$headtag [] = '<link href="' . $assets_url . 'highslide-styles.css" type="text/css" rel="stylesheet" />';
		$headtag [] = '<script src="' . $assets_url . 'highslide-full.packed.js" type="text/javascript" ></script>';
		$headtag [] = '<script src="' . $assets_url . 'swfobject.js" type="text/javascript" ></script>';
		$headtag [] = '<script src="' . $assets_url . 'do_cookie.js" type="text/javascript" ></script>';
		$include = "hs.graphicsDir = '$hs_base/graphics/'; ".
					"hs.showCredits = {$this->_params->set('showHSCredits', 1)};".
					"hs.outlineType = '{$this->_params->set('outlineType', 'outer-glow')}';".
					"hs.loadingText = '{$this->_params->set('loadingText', 'Loading...')}';";
		$headtag [] = '<script type="text/javascript">'.$include.'</script>';
		
		$bodyString = str_replace ( '</head>', "\t" . implode ( "\n", $headtag ) . "\n</head>", $bodyString );
		return $bodyString;
	}
	
	function highslide_replacer_DIRECT($plgAttr, $plgContent)
	{
		//global $_paththumb;
		$arr_override = array();
		$paras = ''; 
		$override ='';
		$paras = $this->parseParams($plgAttr);
	
		foreach($paras as $k=>$value){
			$arr_type = array('type','event', 'contentid', 'url', 'src', 'position', 'positions', 'hideOnMouseOut', 'dismissbuton', 'modulename', 'itemid', "notshowagain", 'notshowagaintime', 'loaddelay', 'dismissbutton', 'desciption', 'class', 'height', 'thumbnail_mode','thumbnail_mode_use_ratio', 'width');
			if(!in_array(trim($k), $arr_type)){
				if(is_numeric($value)){
					$arr_override[] = $k.":".$value;
				}
				else	$arr_override[] = $k.":'".$value."'";
			}
		}
		
		if($arr_override){
			$override = implode(',', $arr_override);
		}
		
		$paras['override'] = $override;
		
		if(!isset($paras['url'])) $paras['url'] = '';
		
		if(isset($paras['src']) && $paras['src']!='') $paras['url'] = $paras['src'];
		
		if(isset($paras['event']) && $paras['event']=='loadbody') $paras['event'] = true;
		else $paras['event'] = false;
		
		if (!isset($paras['notshowagain']) || (isset($paras['notshowagain']) && ($paras['notshowagain']<=0 || !is_numeric($paras['notshowagain'])))){
			$paras['notshowagain'] = 0;
		}
		
		if (!isset($paras['notshowagaintime']) || (isset($paras['notshowagaintime']) && ($paras['notshowagaintime']<=0 || !is_numeric($paras['notshowagain'])))){
			$paras['notshowagaintime'] = 0;
		}
		
		if (!isset($paras['dismissbuton']) || !in_array($paras['dismissbuton'], array('true', 'false'))) {
			$paras['dismissbuton'] = 'false';
		}
		
		if (!isset($paras['loaddelay']) || (isset($paras['loaddelay']) && (!$paras['loaddelay']>0 || !is_numeric($paras['loaddelay'])))) {
			$paras['loaddelay'] = 3;
		}
				
		//$id_link = 'href_'.time();
		$id_link = 'href_'.time();
		
		$id = "'highslide-html-".$id_link."'";
		$id_li = "'li_".$id_link."'";				
		
		if (!isset($paras['type'])) {
			$paras['type'] = '';
		}
		switch($paras['type']){
			case "img":			
				return $this->highslide_img($paras, $plgContent, $id_link, $id, $id_li);
				
			case "html":
				return $this->highslide_html($paras, $plgContent, $id_link, $id, $id_li);
				
			case "slideshow-caption":
				return $this->highslide_slideshowcaption($paras, $plgContent, $id_link);
				
			case "slideshow-controlbar":				
				return $this->highslide_slideshowcontrolbar($paras, $plgContent, $id_link);				
				
			case "flash":				
				return $this->highslide_flash($paras, $plgContent, $id_link, $id);
				
			case "iframe":
				return $this->highslide_iframe($paras, $plgContent, $id_link, $id);
				
			case "module":				
				return $this->highslide_module($paras, $plgContent, $id_link, $id, $id_li);
				
			case "modules":				
				return $this->highslide_modules($paras, $plgContent, $id_link, $id, $id_li);
				
			case "item":
				return $this->highslide_item($paras, $plgContent, $id_link, $id);
				
			case "ajax":				
				return $this->highslide_ajax($paras, $plgContent, $id_link, $id);
		}
	
	}
	
	function highslide_img($paras, $content, $id_link, $id, $id_li){	

		$sPhysicPath = $this->PhysicPath();
		$ip = md5('ip_user_client_img');
		
		$path_img = $paras['url'];
		$limage = '';
		$thumb_img = $path_img;
		
		$paras['url'] = trim($paras['url']);
		if(substr($path_img, 0, 4)!='http'){		
			$path_img = JURI::base().$paras['url'];	
			$path = $sPhysicPath.$paras['url'];
			if (file_exists( $path ) && $this->params->get('thumbnail_mode', 'crop')!='none') {
				$obj = new JAImage();
				$crop = $paras['thumbnail_mode']=='crop'?1:0;
				$aspect = $paras['thumbnail_mode_use_ratio'];
				$thumb_img = $obj->resize($path_img, $paras['width'], $paras['height'], $crop, $aspect);
			}	
			else{
				$thumb_img = $path_img;
			}		
		}
		
		$width = $height = '';
		if($this->_params->get('thumbnail_mode', 'crop')=='none' || !function_exists('gd_info') || substr( $path_img, 0, 4 )=='http'){
			if($paras['width']>0){
				$width = 'width="'.$paras['width'].'"';
			}
			if($paras['height']>0){
				$height = 'height="'.$paras['height'].'"';
			}
		}
		
		if(substr($paras['url'], 0, 4)!='http' && !is_file($sPhysicPath.$paras['url'])){			
			$id = "'highslide-html-".$id_link."'";
			$limage .='<a id="'.$id_link.'" class="highslide" href="#"  onclick="return hs.htmlExpand(this, {contentId: '.$id.'}); return false;">';
			$limage .= $content;
			if(!isset($paras['display']) || $paras['display']!='none'){
				
				$class = isset($paras['class'])?$paras['class']:'';
				$limage .= '<img '.$width.' '.$height.'  alt="'.$paras['url'].'" src="'.$path_img.'"  class="'.$class.'" />';
			}
			$limage .= '</a>';
			$limage .= $this->highslide_img_not_found($id_link);
		}
		else{
			
			$limage ='<div>
						<a id="'.$id_link.'" class="highslide" href="'.$path_img.'" 
							onclick="return hs.expand(this, {'.$paras['override'].'});">';

			if(!isset($paras['display']) || (isset($paras['display']) && $paras['display']!='none')){
				$class = isset($paras['class'])?$paras['class']:'';
				$limage .= '<img  alt="'.$paras['url'].'" src="'.$thumb_img.'"  class="'.$class.'" '.$width.'  />';
			}
			
			$limage .= $content.'</a>';			
			
			$limage .= '</div>';
			
			
			if($paras['event']){			
				$limage .= "<script type='text/javascript'>
								function load_img_cookie(){																
									window.load = hs.expand(document.getElementById('".$id_link."'), {".$paras['override']."});																						
								}		
								if(!Get_Cookie('".$ip."') ){
									setTimeout(load_img_cookie, ".($paras['loaddelay']*1000).");	
								}	 
							</script>";						
			}
		}
		return $limage;
	
	}

	function highslide_html_type($paras, $content, $id_link, $id, $id_li, $maincontentid, $ip){	
							
		if($paras['override']!=''){ $paras['override']=",".$paras['override']; }
		$html = '<a href="#anco" id="'.$id_link.'" onclick="if(!hs.htmlExpand(this, { contentId: '.$id.$paras['override'].'})) display_none('.$id_li.'); return false;">'.$content.'</a>';

		$html .='<div class="highslide-html-content" id='.$id.'>';
		
		if(!isset($paras['notshowagaintime']) || ( isset($paras['notshowagaintime']) && !$paras['notshowagaintime']>0)) $paras['notshowagaintime'] = 7;
		
		if($paras['event'] && (!isset($paras['dismissbutton']) || $paras['dismissbutton']=="Yes")){			
			$paras['dismissbutton'] = true;							
		}
		else{
			$paras['dismissbutton']= false;
		}
		//first, load header of popup
		$html .= $this->caption_move();
		
		//load content of popup
		$html .= '<div class="highslide-body" id="'.$maincontentid.'">';
	
		$html .= $paras['content'];
		//load footer of popup		
		$html .= $this->caption_close($id_link, $id_li, $ip, $paras['event'], $paras['dismissbuton'], $paras['notshowagaintime']);
		
		//event onload popup
		if($paras['event']){	
			$html .= "<script type='text/javascript'>			
								function load_html_cookie(){									
									window.load = hs.htmlExpand($('".$id_link."'), {contentId: ".$id.$paras['override']."});
									if(".$paras['notshowagain'].">0){
										Cookie.write( '".$ip."', true, ".$paras['notshowagain'].", '/', '', '' );		
									}													
								}		
								if(!Cookie.read('".$ip."')){
									setTimeout(load_html_cookie, ".($paras['loaddelay']*1000).");	
								}	 
					</script>";									
		}
		return $html;
	}
	
	function highslide_html($paras, $content, $id_link, $id, $id_li){
		$paras['content'] = '';
		$maincontentid = rand(); 
		$ip = md5('ip_user_client_html_content');
		
		if(isset($paras['contentid'])&& $paras['contentid']!=''){
			$paras['content'] = "<script type='text/javascript'>						
						if(document.getElementById('".$paras['contentid']."')!=null){
						 	hs.outlineWhileAnimating = true;
							document.getElementById('".$maincontentid."').innerHTML = document.getElementById('".$paras['contentid']."').innerHTML;
							document.getElementById('".$paras['contentid']."').innerHTML ='';
						}
					  </script>";
		}
		//echo $id_link.'-'.$id.'-'.$id_li.'-'.$maincontentid.'-'.$ip;exit;
		return $this->highslide_html_type($paras, $content, $id_link, $id, $id_li, $maincontentid, $ip);
	}
	
	function isImage( $ext ){
		$exts =  array(1 => "gif", "jpeg", "png", "jpg" ); 
		return in_array( $ext, $exts );
	}
	
	function highslide_slideshowcaption($paras, $content, $id_link){
		
		$sPhysicPath = '';
		$sPhysicPath = $this->PhysicPath();		
				
		if (strpos($paras['url'], ",")===false) {
			$list_img = preg_split ('/\n/', $paras['url']);
		}
		else{
			$list_img = preg_split ('/,/', $paras['url']);
		}
		
		$id = "'highslide-html-".$id_link."'";
		
		$html = '<div>';

		if ($paras['override']=='') {
			$paras['override'] = "outlineType:'rounded-white'";
		}
		$obj = new JAImage();	
						
		for($i=0; $i<count($list_img); $i++){
			
		
			$path_img  = trim($list_img[$i]);
			$thumb_img = trim($list_img[$i]);
			
			$ext = strtolower(substr(strrchr($path_img, '.'), 1)); // get the file extension 
			// check this file is image file
			if( !$this->isImage(strtolower($ext)) ){ continue; }
			
			$width = $height = '';
			if($this->_params->get('thumbnail_mode', 'crop')=='none' || !function_exists('gd_info') || substr( $path_img, 0, 4 )=='http'){
				if($paras['width']>0){
					$width = 'width="'.$paras['width'].'"';
				}
				if($paras['height']>0){
					$height = 'height="'.$paras['height'].'"';
				}
			}
			
			$img_root = $sPhysicPath.$path_img;
			$img_root = JPath::clean($img_root);
			
			
			if( substr($path_img, 0, 4)!='http' && !is_file($img_root) ){
				$html .='<a  class="highslide" href="#"  onclick="return hs.htmlExpand(this, {contentId: '.$id.'}); return false;">';
				$html .= 	'<img src="'.JURI::base().$path_img.'" alt="'.$path_img.'" title="Click to enlarge"    '.$width .' '.$height.' />';			
				$html .= '</a>';
				echo $this->highslide_img_not_found($id_link);
			}
			else{
				if( substr( $path_img, 0, 4 )!='http' ){		
					
					$path_img = JURI::base().$path_img;	
										
					if (file_exists( $img_root ) && $this->params->get('thumbnail_mode', 'crop')!='none') {
						$crop = $paras['thumbnail_mode']=='crop'?true:false;
						$aspect = $paras['thumbnail_mode_use_ratio'];
						$thumb_img = $obj->resize($path_img, $paras['width'], $paras['height'], $crop, $aspect );	
					}
					else{
						$thumb_img = $path_img;
					}	
					
					
				}												
				
				$html .= '<a  id="thumb'.$i.'" href="'.$path_img.'" style="padding-right:7px;"	
								class="highslide" onclick="return hs.expand(this,{'.$paras['override'].',captionId:\''.$id_link.'\', slideshowGroup:\''.$id_link.'\'});">';
				$html .= 	'<img src="'.$thumb_img.'" alt="'.$thumb_img.'" title="Click to enlarge"   '.$width.' '.$height.'/>';
				$html .= '</a>';
			}
		}
		
		
		$html .= '<div class="highslide-caption" id="'.$id_link.'">
						<a href="#" onclick="return hs.previous(this); return false;" class="control" style="float:left; display: block">
							'.JText::_('PREVIOUS').'
							<br/>
							<small style="font-weight: normal; text-transform: none">'.JText::_('LEFT ARROW KEY').'</small>
	    				</a>
						<a href="#" onclick="return hs.next(this); return false;" class="control" 
								style="float:left; display: block; text-align: right; margin-left: 50px">
							'.JText::_('NEXT').'
							<br/>
							<small style="font-weight: normal; text-transform: none">'.JText::_('RIGHT ARROW KEY').'</small>
						</a>
						<a href="#" onclick="return hs.close(this); return false;" class="control">'.JText::_('CLOSE').'</a>
						<a href="#" onclick="return false" class="highslide-move control">'.JText::_('MOVE').'</a>
						<div style="clear:both">  </div>
					</div>';
		
		$html .= 	'</div>';		
		$html .= $content;
		return $html;
	}

	function highslide_slideshowcontrolbar($paras, $content, $id_link){
		$sPhysicPath = '';
		$sPhysicPath = $this->PhysicPath();
		
		$id = "'highslide-html-".$id_link."'";	
		$list_position = 'top left';
		if(isset($paras['positions']) && $paras['positions']!='')	$list_position = str_replace(',', ' ', $paras['positions']);

		if (!isset($paras['hideOnMouseOut'])|| $paras['hideOnMouseOut']!=1) $paras['hideOnMouseOut'] = 0;
		
		if (strpos($paras['url'], ",")===false) {
			$list_img = preg_split ('/\n/', $paras['url']);
		}
		else{
			$list_img = preg_split ('/,/', $paras['url']);
		}
		
		$html = "<script type='text/javascript'>	
					if (hs.registerOverlay) {				
						hs.registerOverlay(
	    				{
								slideshowGroup: 'minigallery',
								overlayId: '$id_link',
								position: '".$list_position."',								
								hideOnMouseOut: true
							}
						);
						hs.outlineType = 'rounded-white';
						hs.captionEval = 'this.thumb.title';
	    			}
				</script>";
	
		$html.= '<div class="thumbwrapper clearfix">';
			
		$obj = new JAImage();
		
		for($i=0; $i<count($list_img); $i++){
			
		$path_img  = trim($list_img[$i]);
			$thumb_img = trim($list_img[$i]);
			
			$ext = strtolower(substr(strrchr($path_img, '.'), 1)); // get the file extension 
			// check this file is image file
			if( !$this->isImage(strtolower($ext)) ){ continue; }
			
			$width = $height = '';
			if($paras['thumbnail_mode']=='none' || !function_exists('gd_info') || substr( $path_img, 0, 4 )=='http'){
				if($paras['width']>0){
					$width = 'width="'.$paras['width'].'"';
				}
				if($paras['height']>0){
					$height = 'height="'.$paras['height'].'"';
				}
			}
			
			$img_root = $sPhysicPath.$path_img;
			$img_root = JPath::clean($img_root);
			
			
			if( substr($path_img, 0, 4)!='http' && !is_file($img_root) ){
				$html .='<a class="highslide" href="#"  onclick="return hs.htmlExpand(this, {contentId: '.$id.'}); return false;">';
				$html .= 	'<img src="'.JURI::base().$path_img.'" alt="'.$path_img.'" title="Click to enlarge"    '.$width .' '.$height.' />';			
				$html .= '</a>';
				echo $this->highslide_img_not_found($id_link);
			}
			else{
				if( substr( $path_img, 0, 4 )!='http' ){		
					
					$path_img = JURI::base().$path_img;	
										
					if (file_exists( $img_root ) && $paras['thumbnail_mode']!='none') {
						$crop = $paras['thumbnail_mode']=='crop'?true:false;
						$aspect = $paras['thumbnail_mode_use_ratio'];
						$thumb_img = $obj->resize($path_img, $paras['width'], $paras['height'], $crop, $aspect );	
					}
					else{
						$thumb_img = $path_img;
					}	
					
					
				}												
				
				$html .= '<a  id="thumb'.$i.'" href="'.$path_img.'" style="padding-right:7px;"	
								class="highslide" onclick="return hs.expand(this,{'.$paras['override'].', slideshowGroup:\'minigallery\'});">';
				$html .= 	'<img src="'.$thumb_img.'" alt="'.$thumb_img.'" title="Click to enlarge"   '.$width.' '.$height.'/>';
				$html .= '</a>';
			}			
		}		

		$html .= $content;
		
		$html .= '<div id="'.$id_link.'" class="highslide-overlay controlbar">
						<a href="#" class="previous" onclick="return hs.previous(this)" title="'.JText::_('PRE_TEXT').'"></a>
						<a href="#" class="next" onclick="return hs.next(this)" title="'.JText::_('NEXT_TEXT').'"></a>
					    <a href="#" class="highslide-move" onclick="return false" title="'.JText::_('MOVE_TEXT').'"></a>
					    <a href="#" class="close" onclick="return hs.close(this)" title="'.JText::_('CLOSE').'"></a>
					</div>';
		$html .= '</div>';	
		
		return $html;
	}
	
	function highslide_flash($paras, $content, $id_link, $id){
		$sPhysicPath = $this->PhysicPath();
		$name_flash = $paras['url'];
		if(substr($name_flash,0,4)!='http'){
			$name_flash_1 = JURI::base().$name_flash;
		} else {
			$name_flash_1=$name_flash;
		}
		$html = '';
		$id = "so_".rand();
		
		if($paras['override']!='') $paras['override'] = ','.$paras['override'];
		
		if(substr($name_flash,0,4)!='http' && !is_file($sPhysicPath.$name_flash)){			
			$id = "'highslide-html-".$id_link."'";
			$html .='<a id="'.$id_link.'" class="highslide" href="#"  onclick="return hs.htmlExpand(this, {contentId: '.$id.'}); return false;">';
			$html .= $content;			
			$html .= '</a>';
			$html .= $this->highslide_img_not_found($id_link);
		}
		else{
			$ip = md5('ip_user_client_flash_file');
			$swfObjectOptions = '{ objectType: \'swf\',
								   allowSizeReduction: false,
								   outlineType: \'rounded-white\',
								   wmode:\'transparent\',
								   preserveContent: false, objectWidth: '.$paras['width'].', objectHeight: '.$paras['height'].',
								   maincontentText: \''.JTEXT::_('YOUTUBE NOT INSTALL').'\' '.$paras['override'].' } ';
			$html= '<div>
					    <a href="'.$name_flash_1.'" id="'.$id_link.'" onclick="return hs.htmlExpand(this, '.$swfObjectOptions.')" class="highslide ">
						'.$content.'
					    </a>
				    </div>';
			if($paras['event']){
				
				$html .= "<script type='text/javascript'>
								function load_flash_cookie(){									
									window.load = hs.htmlExpand($('".$id_link."'), ".$swfObjectOptions." );	
									if(".$paras['notshowagain'].">0){
										Cookie.write( '".$ip."', '".date("Ymd")."', ".$paras['notshowagain'].", '/', '', '' );
									}														
								}		
								if(!Get_Cookie('".$ip."')){									
									setTimeout(load_flash_cookie, ".($paras['loaddelay']*1000).");	
								}	 
						</script>";	
			}
		}
		return $html;
	}
	
	function highslide_iframe($paras, $content, $id_link, $id){
		$ip = md5('ip_user_client_iframe');
		if($paras['override']!='') $paras['override'] = ','.$paras['override'];
		
		$html  = '<div>';
		$html .= '<a id="'.$id_link.'" href="'.$paras['url'].'" onclick="return hs.htmlExpand(this, { objectType: \'iframe\''.$paras['override'].'  } )">
						'.$content.'
				  </a>';
		
		$html .= '</div>';	
		if($paras['event']){
			$html .= "<script type='text/javascript'>
								function load_iframe_cookie(){									
									window.load = hs.htmlExpand(document.getElementById('".$id_link."'), {objectType: 'iframe'".$paras['override']."});	
									if(".$paras['notshowagain'].">0){
										Cookie.write( '".$ip."', '".date("Ymd")."', ".$paras['notshowagain'].", '/', '', '' );
									}															
								}		
								if(!Get_Cookie('".$ip."')){									
									setTimeout(load_iframe_cookie, ".($paras['loaddelay']*1000).");	
								}	 
					</script>";				
		}
		return $html;
	}
	
	function highslide_module($paras, $content, $id_link, $id, $id_li){
		$paras['content'] = '';
		$maincontentid = rand();
		$ip = md5('ip_user_client_module_content');
		
		$a = ''; $module_content = '';
		$list_module = '';
		if(isset($paras['modulename'])) $list_module = preg_split ('/,/', $paras['modulename']);
		else return;
		
		for($i=0; $i<count($list_module); $i++){
			if ($list_module[$i]!='mod_jahighslide') {
				$module =  JModuleHelper::getModule(substr(trim($list_module[$i]), 4 ));
				
				if($module && $module->id){
					$module_content  .= "<h3><span>".$module->title."</span></h3>";
					$module_content .= "<div  class=\"ja-module-content\")>";
					$module_content	.=	JModuleHelper::renderModule($module);									
					$module_content .= 	'</div>';		
				}			
			}
				
		}		
		
		if($module_content==''){
			$paras['content'] .= '<div class="highslide-body" style="text-align:center;width:90%;">
								<br/>
								'.JText::_('MODULE NOT EXIST').'
								<br/>
								<br/><br/>
						</div>';
		}
		else{
			$paras['content'] .= $module_content;
		}
		return $this->highslide_html_type($paras, $content, $id_link, $id, $id_li, $maincontentid, $ip);		
	}
	
	function highslide_modules($paras, $content, $id_link, $id, $id_li){	
		$paras['content'] = '';
		$maincontentid = rand();
		$ip = md5('ip_user_client_modules_content');
		
		$a = ''; $module_content = '';
		$list_postion = array();
		if(isset($paras['position'])) $list_postion =  preg_split ('/,/', $paras['position']);
		
		$module_content = '';
		for($i=0; $i<count($list_postion); $i++){
			$list =  JModuleHelper::getModules(trim($list_postion[$i]));
			for($j=0; $j<count($list); $j++){
				if($list[$j]->module!='mod_jahighslide'){
					$module_content .= "<div class=\"modules-title\"><h3>".$list[$j]->title."</h3></div>";
					$module_content .= "<div style=\"position:relative\">";	
					$module_content .= JModuleHelper::renderModule($list[$j], array());
					$module_content .= "</div>";	
					$module_content .= "<br/>";
				}
			}
		}
					
		if($module_content==''){
			$paras['content'] .= '<div class="highslide-body" style="text-align:center;width:90%;">
								<br/>
								'.JText::_('MODULE NOT EXIST').'								
								<br/>
								<br/><br/>
						</div>';
		}
		else{
			$paras['content'] .= $module_content;
		}
		return $this->highslide_html_type($paras, $content, $id_link, $id, $id_li, $maincontentid, $ip);					
	}

	function highslide_item($paras, $content, $id_link, $id){
		$ip = md5('ip_user_client_item_content');	
		$id = "'highslide-html-".$id_link."'";
		$html  = '<div>';
		if($paras['override']!='') $paras['override'] = ','.$paras['override'];
		
		$link = JRoute::_(ContentHelperRoute::getArticleRoute($paras['itemid']));
		if(strpos('?', $link)===TRUE) $link .= '&tmpl=component';
		else $link .= '?tmpl=component';
		$html .= '<a id="'.$id_link.'" href="'.$link.'" 
						onclick="if(!hs.htmlExpand(this, { objectType:\'iframe\''.$paras['override'].'  } )) return false;">
						'.$content.'
				  </a>';
		
		$html .= '</div>';	
		if($paras['event']){
			
			$html .= "<script type='text/javascript'>
								function load_content_cookie(){									
									window.load = hs.htmlExpand(document.getElementById('".$id_link."'), {objectType:'iframe'".$paras['override']."});	
									if(".$paras['notshowagain'].">0){
										Cookie.write( '".$ip."', '".date("Ymd")."', ".$paras['notshowagain'].", '/', '', '' );
									}														
								}		
								if(!Get_Cookie('".$ip."')){									
									setTimeout(load_content_cookie, ".($paras['loaddelay']*1000).");	
								}	 
					</script>";	

				//hs.addEventListener(window, 'load', function(){hs.htmlExpand(document.getElementById('".$id_link."'), {objectType: ".$type.",".$paras['override']."});});

		}
		return $html;
	}
	
	function highslide_ajax($paras, $content, $id_link, $id){
		//set name for cookie
		$ip = md5('ip_user_client_ajaxcontent');	
		$url = '';
		$url .= $paras['url'];
		if(isset($paras['contentid'])&& $paras['contentid']!='') $url.="#".$paras['contentid'];
		$id = "'highslide-html-".$id_link."'";		
		$html = '<a href="'.$url.'" id="'.$id_link.'"
						onclick="return hs.htmlExpand(this, { objectType:\'ajax\', preserveContent: true, '.$paras['override'].'} );">
					'.$content.'
				</a>';
		
		if($paras['event']){
			$html .= "<script type='text/javascript'>
								function load_content_cookie(){									
									window.load = hs.htmlExpand(document.getElementById('".$id_link."'), {objectType: 'ajax', preserveContent: true,".$paras['override']."});	
									if(".$paras['notshowagain'].">0){
										Cookie.write( '".$ip."', '".date("Ymd")."', ".$paras['notshowagain'].", '/', '', '' );
									}
								}		
								if(!Get_Cookie('".$ip."')){									
									setTimeout(load_content_cookie, ".($paras['loaddelay']*1000).");	
								}	 
					</script>";				
		}
		return $html;
	}
	function highslide_img_not_found($id_link){		
			$limage = '<div class="highslide-html-content" id="highslide-html-'.$id_link.'">
							<div class="highslide-header">
								<ul>
									<li class="highslide-move">
										<a href="#" onclick="return false">'.JText::_('MOVE').'</a>
									</li>
									<li class="highslide-close">
										<a href="#" onclick="return hs.close(this)">'.JText::_('CLOSE').'</a>
									</li>
								</ul>	    
							</div>
							<div class="highslide-body" style="text-align:center;width:90%;">
								<br/>
								'.JText::_('WRONG IMAGE LOCATION').'
								<a href=" httt://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'].'"> httt://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'].'</a>
								<br/>								
							</div>
							<div class="highslide-footer">
								<div>
									<span class="highslide-resize" title="Resize">
										<span></span>
									</span>
								</div>
							</div>
						</div>';
			return $limage;
	}
	function PhysicPath(){		
		return JPATH_SITE.DS;
	}
	function close_endless($notshowagaintime, $ip){
		$limage = '<script type="text/javascript">	
								function close_endless(obj){
									Cookie.write( "'.$ip.'","'.date("Ymd").'", '.$notshowagaintime.', "/", "", "" );
									return hs.close(obj);															
								}									
					</script>';
		return $limage;
	}
	function caption_move(){
		
		$limage = '									    
									<div class="highslide-header" >										
										<ul >
											<li class="highslide-move">
												<a href="#" onclick="return false">'.JText::_('Move').'</a>
											</li>											
										</ul>	    
									</div>';
		return $limage;
	}
	function caption_close($id_link, $id_li, $ip, $load, $dismissbutton, $notshowagaintime){
		$html = '</div>
					<hr/>
					<div class="highslide-footer">
						<div>
							<span class="" title="Resize" >
								<span>
									<ul id="ul_footer">';
		if($load && $dismissbutton=='true'){															
				$html .='					<li class="highslide-close" id='.$id_li.' style="height:10px">
												<input type="checkbox" id="check_'.$id_link.'" /><label for="check_'.$id_link.'" style="font-size:12px;height:16px; cursor:pointer;color: gray;">'.JText::_('DO NOT SHOW AGAIN').'</label>												
											</li>																						
											';
		}
		$id_link = "'".$id_link."'";
		$ip =  "'".$ip."'";
		$html .= '							<li class="highslide-close" style="top:3px; float:right" >
												<a href="#" onclick="check_close('.$id_link.','.$notshowagaintime.', '.$ip.');return hs.close(this)">'.JText::_('Close').'</a>
											</li>';
		$html .='
										</ul>	    
								</span>
							</span>
						</div>
					</div>
				</div>';	
		return $html;
	}
	
	function getPattern ($tag) {
	  $regex = '#{'.$tag.' ([^}]*)}([^{]*){/'.$tag.'}#m';
	  return $regex;
	}
	
	function parseParams($params) {
		$params = html_entity_decode ($params,ENT_QUOTES);
		$regex = "/\s*([^=\s]+)\s*=\s*('([^']*)'|\"([^\"]*)\"|([^\s]*))/";
		preg_match_all($regex, $params, $matches);
		
		 $paramarray = null;
		 if(count($matches)){
			$paramarray = array();
				for ($i=0;$i<count($matches[1]);$i++){ 
				  $key = $matches[1][$i];
				  $val = $matches[3][$i]?$matches[3][$i]:($matches[4][$i]?$matches[4][$i]:$matches[5][$i]);
				  $paramarray[$key] = $val;
				}
		  }
		  
		  
		  if(!isset($paramarray['outlineType']) || !$paramarray['outlineType']) $paramarray['outlineType'] = $this->_params->set('outlineType', 'outer-glow');
		  if(!isset($paramarray['showHSCredits'])) $paramarray['showHSCredits'] = $this->_params->set('showHSCredits', '1');
		  if(!isset($paramarray['width']) ||  $paramarray['width']<=0 || !is_numeric($paramarray['width'])) $paramarray['width'] = $this->_params->set('width', '100');
		  if(!isset($paramarray['height']) ||  $paramarray['height']<=0 || !is_numeric($paramarray['height'])) $paramarray['height'] = $this->_params->set('height', '100');
		  if(!isset($paramarray['loadingText'])) $paramarray['loadingText'] = $this->_params->set('loadingText', 'Loading...');
		  if(!isset($paramarray['thumbnail_mode'])) $paramarray['thumbnail_mode'] = $this->_params->set('thumbnail_mode', 'crop');
		  if(!isset($paramarray['thumbnail_mode_use_ratio'])) $paramarray['thumbnail_mode_use_ratio'] = $this->_params->set('thumbnail_mode_use_ratio', '1');
		  if(!isset($paramarray['paththumb'])) $paramarray['paththumb'] = $this->_params->set('paththumb', 'images/');
		  
		  return $paramarray;
	}
}
?>