<?php
/*
# ------------------------------------------------------------------------
# JA Newsmoo module for Joomla 1.5
# ------------------------------------------------------------------------
# Copyright (C) 2004-2010 JoomlArt.com. All Rights Reserved.
# @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
# Author: JoomlArt.com
# Websites: http://www.joomlart.com - http://www.joomlancers.com.
# ------------------------------------------------------------------------
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

$database 					=& JFactory::getDBO();
$user 						=& JFactory::getUser();
$aid = $user->get('aid', 0);
$catid 			= 	$params->get('catid','');
$direction 		= 	$params->get('direction','vir');
$animAttr 		= 	$params->get('animAttr','top');
$number 		= 	$params->get('number',5);
$openWidth		= 	$params->get('openWidth',200);
$openHeight		= 	$params->get('openHeight',200);
$smallSize 		= 	$params->get('smallSize',100);
$open 			= 	$params->get('open',0);
$link_titles	= 	$params->get( 'link_titles', 0 );
$readmore		= 	$params->get( 'readmore', 0 );
$numofchars		= 	$params->get( 'numofchars', 0 );
$duration		= 	$params->get( 'duration', 400 );

$noauth 			= !$mainframe->getCfg( 'shownoauth' );
$nullDate 			= $database->getNullDate();
$params->set( 'intro_only' , 1);

if( $catid != "" ){
	if( !is_array($catid ) ){
		$catid  = array( $catid  );
	}
}
// query to determine article count
$query = 'SELECT a.*,cc.description as catdesc, cc.title as cattitle,s.description as secdesc, s.title as sectitle,' .
			' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
			' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":",cc.id,cc.alias) ELSE cc.id END as catslug,'.
			' CASE WHEN CHAR_LENGTH(s.alias) THEN CONCAT_WS(":", s.id, s.alias) ELSE s.id END as secslug'.
			' FROM #__content AS a' .
			' INNER JOIN #__categories AS cc ON cc.id = a.catid' .
			' INNER JOIN #__sections AS s ON s.id = a.sectionid';
			$query .=	' WHERE a.state = 1 ' 
			. ( $noauth ? "\n AND a.access <= " . (int) $aid . " AND cc.access <= " . (int) $aid . " AND s.access <= " . (int) $aid : '' )
			."\n AND (a.publish_up = " . $database->Quote( $nullDate ) . " OR a.publish_up <= NOW() ) "
			."\n AND (a.publish_down = " . $database->Quote( $nullDate ) . " OR a.publish_down >= NOW() )";

if( $catid != "" ){			
	$query .= "\n AND a.catid IN ('" . implode( "','",  $catid ) . "')";
}		
$query .= "\n AND cc.published = 1"
			."\n AND s.published = 1"
			."\n ORDER BY a.ordering LIMIT ".$number;

$database->setQuery($query);
$rows = $database->loadObjectList();
?>


<?php

function contentText($string) {
global $current_charset;
	if ($current_charset == "UTF-8") return $string;
	
	else if ($current_charset) {
		$trans_tbl = array("&lt;" => "<", "&gt;" => ">", "&amp;" => "&");
		return strtr(htmlentities($string, ENT_NOQUOTES, $current_charset), $trans_tbl);
	} else return $string;
}

function cutText($string,$numofchars){
	if($numofchars && strlen($string) > $numofchars){
		$string = substr($string,0,$numofchars);
		$endpos = strrpos ($string,' ');
		$string = substr($string,0,$endpos);
	}
	return $string;
}
function contentlinkInfo( &$row, $readmore, $link_titles ) {
	require_once (JPATH_SITE . '/components/com_content/helpers/route.php');
	$user 	=& JFactory::getUser();
	$row->link_on 	= '';
	$row->link_text	= '';
	if ($readmore || $link_titles) {
		if ( $row->access <= $user->get('aid',0) ) {
			$row->link_on =		JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
			if ( $readmore) {
				//$row->link_text = 'readmore';
				$row->link_text = str_replace(': %s','',JText::_('READ MORE'));
			}
		} else {
			$row->link_on = JRoute::_( 'index.php?option=com_user&amp;task=register' );
			if ( $readmore ) {
				$row->link_text	= str_replace(': %s','',JText::_('READ MORE REGISTER'));
			}
		}
	}
}

	$filename = JPATH_SITE.DS.'templates/'.$mainframe->getTemplate().'/css/ja-newsmoo.css';
	$css_path = JURI::base().'templates/'.$mainframe->getTemplate().'/css/';
	if(!file_exists($filename)){
		$css_path = JURI::base().'modules/ja_newsmoo/';
	}
	JHTML::stylesheet('ja-newsmoo.css', $css_path);
	JHTML::script('ja-newsmoo.js', $css_path, true);
?>
<div id="ja-newsmoo-container">
	  <ul id="ja-newsmoo-wrap">
		<?php 
		//foreach ( $contents as $content ){
		for($i=0;$i<count($rows);$i++){
			$row = $rows[$i];
			$row->text 		= contentText($row->introtext);
			//$row->images 	= $row->images;
			$row->groups 	= '';
			$row->readmore 	= $readmore;
			$row->metadesc 	= '';
			$row->metakey 	= '';
			$row->access 	= '';
			$row->created 	= '';
			$row->modified 	= '';
			
			$params->set('image', 1);
			JPluginHelper::importPlugin( 'content' );
			$results = $mainframe->triggerEvent( 'onPrepareContent', array( &$row, &$params, null ), true );
		
			$row->introtext 		= $row->text;
			contentlinkInfo ($row, $readmore, $link_titles);
			$regex = "/\<img.*\/\>/";			
			preg_match ($regex, $row->introtext, $matches);
			$row->text = preg_replace ($regex, '', $row->introtext);
			$row->text = cutText($row->text,$numofchars);
			$img = count($matches)?$matches[0]:"";
			
			if ($link_titles) $title = "<a href=\"".$row->link_on."\" title=\"".$row->title."\">".$row->title."</a>";
			else $title = $row->title;
			echo '<li class="ja-newsmoo">';
			echo $img;
			echo '<span class="ja-newsmoo-title">'.$title.'</span>';
			echo '<span class="ja-newsmoo-desc">'.$row->text.'</span>';
			if ($readmore) {
			echo '<a class="readon" href="'.$row->link_on.'" title="'.$row->link_text.'">'.$row->link_text.'</a>';
			}
			echo '</li>';			
		}
		?>

</ul></div>
<script type="text/javascript">
	function janewsmooInit() {
	var newsmoo = new JANewsMoo($ES('#ja-newsmoo-wrap .ja-newsmoo'),{<?php echo "openWidth:$openWidth,openHeight:$openHeight,smallSize:$smallSize,open:$open,direction:'$direction',durationtime:$duration,animAttr:'$animAttr'"; ?>});
	}
	//window.addEvent('domready',janewsmooInit);
	janewsmooInit();
</script>
