<?php
/*
 * ------------------------------------------------------------------------
 * JA Retweet plugin for Joomla 1.5
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * ------------------------------------------------------------------------
*/ 

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );


class plgContentPlg_Jaretweet extends JPlugin
{
	var $plugin;
	var $plgParams;
	var $_plgCode;
	var $position;
	var $source;
	
	function plgContentPlg_Jaretweet( &$subject, $config )
	{
		parent::__construct( $subject, $config );

		$this->plugin = &JPluginHelper::getPlugin('content', 'plg_jaretweet');
		$this->plgParams = new JParameter($this->plugin->params);
		$this->position   = $this->plgParams->get('position', 'onBeforeDisplayContent');
		if(strpos($this->position, 'on') !== 0) {
			//right event?
			$this->position = 'onBeforeDisplayContent';
		}
		$this->source   = $this->plgParams->get('source', 'both');
		
		$this->stylesheet ($this->plugin);
	}
	
	function onBeforeDisplay( &$article, &$params, $limitstart ){ return $this->_displayButton( __FUNCTION__, $article, $params, $limitstart ); }
	function onAfterDisplayTitle( &$article, &$params, $limitstart ){ return $this->_displayButton( __FUNCTION__, $article, $params, $limitstart ); }
	function onBeforeDisplayContent( &$article, &$params, $limitstart ){ return $this->_displayButton( __FUNCTION__, $article, $params, $limitstart ); }
	function onAfterDisplayContent( &$article, &$params, $limitstart ){ return $this->_displayButton( __FUNCTION__, $article, $params, $limitstart ); }
	function onAfterDisplay( &$article, &$params, $limitstart ){ return $this->_displayButton( __FUNCTION__, $article, $params, $limitstart ); }
	
	function onK2BeforeDisplay( &$article, &$params, $limitstart ){ return $this->_displayButton( __FUNCTION__, $article, $params, $limitstart ); }
	function onK2AfterDisplayTitle( &$article, &$params, $limitstart ){ return $this->_displayButton( __FUNCTION__, $article, $params, $limitstart ); }
	function onK2BeforeDisplayContent( &$article, &$params, $limitstart ){ return $this->_displayButton( __FUNCTION__, $article, $params, $limitstart ); }
	function onK2AfterDisplayContent( &$article, &$params, $limitstart ){ return $this->_displayButton( __FUNCTION__, $article, $params, $limitstart ); }
	function onK2AfterDisplay( &$article, &$params, $limitstart ){ return $this->_displayButton( __FUNCTION__, $article, $params, $limitstart ); }
	
	function _displayButton( $position, &$article, &$params, $limitstart ) {
		global $mainframe;
		if ($mainframe->isAdmin()) {
			return '';
		}
		
		if($this->position != $position) {
			return '';
		}
		
		$catid = $article->catid;
		$option = JRequest::getVar('option');
		$view = JRequest::getVar('view');
		$id			= JRequest::getInt('id');
		$plgParams = $this->plgParams;
		
		
		if(!$article->id) {
			return '';
		}
		
		if ($this->source != 'both' && $this->source != $option) 
			return '';
		
		$display_on_home = (int) $plgParams->get('display_on_home', 1);
		if($view == 'frontpage' && $display_on_home != 1)
			return '';
			
		$display_on_list = (int) $plgParams->get('display_on_list', 1);
		if((($option == 'com_k2' && $view != 'item') || ($option == 'com_content' && $view != 'article' && $view != 'frontpage')) && $display_on_list != 1)
			return '';
		
		if($this->isDetailPage()) {
			//it is not called from detail view
			if($id && $id != $article->id) {
				return '';
			}
		}
		
		
		if($this->isContentItem($article)) {
			$catids         = $plgParams->get('catsid','');
		} else {
			$catids         = $plgParams->get('k2catsid','');
		}
		if (is_array($catids)){
			$categories = $catids;
		} elseif ($catids==''){
			$categories[] = $catid;
		} else {
			$categories[] = $catids;
		}
		
		if( !in_array($catid,$categories)) {
			return '';
		}
		
		//
		
		/**
		 * @link : http://dev.twitter.com/pages/tweet_button
		 * 
		 * Data Source  					Share query string  	data- attribute of anchor tag  	rel= attribute of a link tag  	Default
		 * Priority 						1 						2 								3 								4
		 * URL to Tweet 					url 					data-url 						rel="canonical" 				HTTP Referrer
		 * via user 						via 					data-via 						rel="me" 	 
		 * Tweet text 						text 					data-text 	  					Content of the <title> tag
		 * Recommended accounts 			related 				data-related 	  	 
		 * Count box position 				count 					data-count 	  					horizontal
		 * Language 						lang 					data-lang 	  					en
		 * URL to which  					counturl 				data-counturl 	  				the url being shared
		 *  your shared URL resolves to
		 * 
		 */
		if($this->isDetailPage()) {
			$style         	= $plgParams->get('data-count', 'vertical');
		} else {
			$style         	= $plgParams->get('data-count-list', 'horizontal');
		}
		
		$lang         	= $plgParams->get('lang', 'en');
		$data_via		= $plgParams->get('data-via', '');
		
		$shareUrl = "http://twitter.com/share";
		$shareUrl .= "?text=" . rawurlencode($article->title);
		$shareUrl .= "&amp;count=" . rawurlencode($style);
		$shareUrl .= "&amp;lang=" . rawurlencode($lang);
		if (!empty($data_via)) $shareUrl .= "&amp;via=" . rawurlencode($data_via);

		$data_related	= $plgParams->get('data-related', '');
		if(!empty($data_related)) {
			$desc = $plgParams->get('data-related-desc', '');
			if(!empty($desc)) {
				$shareUrl .= "&amp;related=" . rawurlencode($data_related.':'.$desc);
			} else {
				$shareUrl .= "&amp;related=" . rawurlencode($data_related);
			}
		}
		
		$classCss		= ($view == 'frontpage') ? 'ja-retweet-'.$style.'-home' : 'ja-retweet-'.$style.'';
		
		//get article's url
		if($this->isContentItem($article)){
			if(!isset($article->readmore_link) || empty($article->readmore_link)){
				$article->readmore_link = JRoute::_(ContentHelperRoute::getArticleRoute($article->slug, $article->catslug, $article->sectionid));
			}
			$path = $article->readmore_link;
		} else {
			$path = $article->link;
		}
		if(!preg_match("/^\//", $path)) {
			//convert to relative url
			$path = JURI::root(true).'/'.$path;
		}
		//convert to absolute url
		$url = $this->getRootUrl().$path;
		
		//
		$url = str_replace('&amp;', '&', $url);
		
		$shareUrl .= "&amp;url=" . rawurlencode($url);
		//$shareUrl .= "&amp;counturl=" . rawurlencode($sefurl);
		$shareUrl .= "&amp;counturl=" . rawurlencode($url);
		
		$html = '
			<div class="'.$classCss.'">
			<a href="'.$shareUrl.'" class="twitter-share-button">Tweet</a>
			';
		if(!defined('JA_USE_TWITTER_WIDGET')) {
			define('JA_USE_TWITTER_WIDGET', 1);
			$html .= '<script type="text/javascript" src="http://platform.twitter.com/widgets.js"></script>';
		}
		$html .='
			</div>
			';
	
		return $html;
	}

	function onAfterRender(){
		global $mainframe;
		if ($mainframe->isAdmin()) {
			return '';
		}
		
		$body = JResponse::getBody();
		//add script at the bottom of page
		/*
		$script = "
		<script type=\"text/javascript\">
		//<![CDATA[ 
		window.addEvent('load', function(){
			(function () {
			  var s = document.createElement('script'); s.async = true;
			  s.src = 'http://platform.twitter.com/widgets.js';
			  (document.getElementsByTagName('head')[0] || document.getElementsByTagName('body')[0]).appendChild(s);
			}());
		});
		//]]> 
		</script>
		";*/
		//$body = str_replace('</body>', $script.'</body>'."\r\n", $body);
		//if its a detail page
		if ($this->isDetailPage()) {
			$document = JFactory::getDocument();
	
			$tags = '<meta name="tweetmeme-title" content="' . $document->getTitle() . '" />'."\r\n";
			
			$body = str_replace('<head>', '<head>'."\r\n".$tags, $body);
			
		}
		JResponse::setBody($body);
	}
	
	function parseImages($text) {
		global $mainframe;  
         
        
		$regex = "/\<img.+?src\s*=\s*[\"|\']([^\"\']*)[\"|\'][^\>]*\>/i";
		preg_match ($regex, $text, $matches);
		$images = (count($matches)) ? $matches : array();
		if (count($images)){
			$src = $images[1];
			
			if(strpos($src, '/') === 0) {
				$src = $this->getRootUrl().$src;
			} elseif (!preg_match("/^\w+\:\/\//i", $src)) {
				$src = JURI::root().'/'.$src;
			}
			
			//fix link
        	$force_ssl = $mainframe->getCfg( 'force_ssl' );
			
	        if($force_ssl != 2) { 
	            $src = preg_replace("/^https\:/i", 'http:', $src); 
	        } 
	        
			return $src;
		}
		
		return false;
	}
	
	function cleanDesc($article) {
		
		if(!empty($article->introtext)) {
			$metadesc = stripslashes($article->introtext);
			$metadesc = strip_tags($metadesc);
			
		} else {
			$metadesc = stripslashes($article->fulltext);
			
			//get 5 first sentences.
			$metadesc = strip_tags($metadesc);
			$parts = explode('.', $metadesc);
			$metadesc = implode('.', array_slice($parts, 0, 5));
			
		}
		$metadesc = preg_replace("/[\r\n\t]+/", " ", $metadesc);
		return $metadesc;
	}
	
	
	/**
	 *
	 * @return (string) - root url without last slashes
	 */
	function getRootUrl() {
		global $mainframe; 
        $force_ssl = $mainframe->getCfg( 'force_ssl' ); 
         
        $url = str_replace(JURI::root(true), '', JURI::root()); 
        $url = preg_replace("/\/+$/", '', $url); 
        
        if($force_ssl != 2) { 
            //not use ssl for entire site 
            $url = preg_replace("/^https\:/i", 'http:', $url); 
        } 
        return $url;
	}
	
	function isDetailPage() {
		$option 	= JRequest::getVar('option');
		$view 		= JRequest::getVar('view');
		//if its a detail page
		if (($option == 'com_k2' && $view == 'item') || ($option == 'com_content' && $view == 'article')) {
			return true;
		}
		return false;
	}
	
	function isContentItem($article) {
		return (isset($article->sectionid)) ? true : false;
	}
	
	function isK2Item($article) {
		return ($this->isContentItem($article)) ? false : true;
	}
	
	function removeCode($content)
	{
		//return preg_replace( $this->_plgCode, '', $content );
		return str_replace( $this->_plgCode, '', $content );
	}
	
	function getUrlBase()
	{
		$baseurl = (!empty($_SERVER['HTTPS'])) ? "https://".$_SERVER['HTTP_HOST'] : "http://".$_SERVER['HTTP_HOST'];
		if ($_SERVER['SERVER_PORT']!="80") 
			$baseurl .= ":".$_SERVER['SERVER_PORT'];
		
		return $baseurl;
	}
	
	function getLayoutPath($plugin, $layout = 'default')
	{
		global $mainframe;

		// Build the template and base path for the layout
		$tPath = JPATH_BASE.DS.'templates'.DS.$mainframe->getTemplate().DS.'html'.DS.$plugin->name.DS.$layout.'.php';
		$bPath = JPATH_BASE.DS.'plugins'.DS.$plugin->type.DS.$plugin->name.DS.'tmpl'.DS.$layout.'.php';
		// If the template has a layout override use it
		if (file_exists($tPath)) {
			return $tPath;
		} elseif (file_exists($bPath)) {
			return $bPath;
		}
		return '';
	}

	function loadLayout ($plugin, $layout = 'default') {
		$layout_path = $this->getLayoutPath ($plugin, $layout);
		if ($layout_path) {
			ob_start();
			require $layout_path;
			$content = ob_get_contents();
			ob_end_clean();
			return $content;
		}
		return '';
	}

	function stylesheet ($plugin) {
		global $mainframe;
		JHTML::stylesheet('style.css','plugins/'.$plugin->type.'/'.$plugin->name.'/assets/css/');
		if (is_file(JPATH_SITE.DS.'templates'.DS.$mainframe->getTemplate().DS.'css'.DS.$plugin->name.".css")) {
			//overwrite with template stylesheet
			JHTML::stylesheet($plugin->name.".css",'templates/'.$mainframe->getTemplate().'/css/');
		}
	} 
}
?>