<?php
/*
# ------------------------------------------------------------------------
# JA Tooltips plugin for Joomla 1.6.x
# ------------------------------------------------------------------------
# Copyright (C) 2004-2009 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
# @license - Copyrighted Commercial Software
# Author: J.O.O.M Solutions Co., Ltd
# Websites:  http://www.joomlart.com -  http://www.joomlancers.com
# This file may not be redistributed in whole or significant part.
# ------------------------------------------------------------------------
*/

// Check to ensure this file is included in Joomla!

defined( '_JEXEC' ) or die();	
jimport( 'joomla.plugin.plugin' );
jimport('joomla.application.module.helper');
jimport('joomla.html.parameter');

/**
 * Jatabs Content Plugin
 *
 * @package		Joomla
 * @subpackage	Content
 * @since 		1.5
 */


class plgContentPlg_JATooltips extends JPlugin
{
	var $plugin = null;
	var $pluginParams = null;
  	var $style_default = '';
  	var $width_default = 0;
  	var $stiky_default = 0;
  	var $classname_default = '';
  	
  
	function plgContentPlg_JATooltips( &$subject, $params )
	{
		$mainframe = JFactory::getApplication();
		parent::__construct( $subject, $params );
		$modules = JAModuleHelper::load();
		$this->plugin = JPluginHelper::getPlugin( 'content', 'plg_jatooltips' );
		$this->plgParams = new JRegistry;
		$this->plgParams->loadJSON($this->plugin->params);
		$i = 0;
		foreach ($modules as $module) {
			if ($module->module == 'mod_custom') {
				$row = new stdClass();
				$row->text = $module->content;
				$params = null;
				$mod = &$modules[$i];
				$this->onContentBeforeDisplay (null,$row, $params, 0);
				$mod->content = $row->text;
			}
			$i++;
		}
	}

	/**
	 * tabs prepare content method
	 *
	 * Method is called by the view
	 *
	 * @param 	object		The article object.  Note $article->text is also available
	 * @param 	object		The article params
	 * @param 	int			The 'page' number
	 */
	function onContentBeforeDisplay($context, &$article, &$params, $limitstart)
	{
		$mainframe = JFactory::getApplication();
		$view =  JRequest::getVar('view');
		if(isset($article->introtext) && !empty($article->introtext))
		{
			$type_text = "introtext";
			if($view == 'article') {
				if(!isset($article->text) || empty($article->text))
				{
					$article->text = $article->introtext;
				}
				$type_text = "text";
			}
			if (JString::strpos( $article->$type_text, '{jatooltips' ) === false){
				$HSmethodDIRECT = false;
			}else{
				$HSmethodDIRECT = true;
			}
			if(!defined("JA_PLG_TIPS_HEADTAG")) $this->JATooltips_PrepareSettings();
			if($HSmethodDIRECT){
				require_once('plugins/content/plg_jatooltips/parser.php');
				$parser = new ReplaceCallbackParser('jatooltips');
				$content =  $parser->parse ($article->$type_text, array(&$this, 'JATooltips_replacer_DIRECT'));	
				if(is_array($content))
				{
					$content = implode(" ",$content);
				}
				$article->$type_text = $content;				 
			}
		}		
		//return $article->text;
	}

	function JATooltips_PrepareSettings(){
		$mainframe = JFactory::getDocument();
		
		$hs_base    = JURI::base().'plugins/content/plg_jatooltips/assets/';
		$headtag    = array();
		$headtag[] = JHTML::_('behavior.mootools');
		$headtag[] = "<script type='text/javascript' src='".$hs_base."ja.tooltips.js' charset=\"utf-8\"></script>";		
		$mainframe->addCustomTag(implode("\n", $headtag));
		define("JA_PLG_TIPS_HEADTAG", TRUE);
	}
	
	function JATooltips_replacer_DIRECT($plgAttr, $plgContent)
	{
		//params of tip		
		$params = '';
		$params = $this->parseParams($plgAttr);				
		
		if (!isset($params['type'])) $params['type'] = 'html';
		//set default value for param:
		if (!isset($params['style'])) $params['style'] = $this->plgParams->get('style', 'default');
		if (!isset($params['showtitle'])) $params['showtitle'] = $this->plgParams->get('showtitle', true);
		if (!isset($params['maxTitleChars'])) $params['maxTitleChars'] = $this->plgParams->get('maxTitleChars', '30');
		if (!isset($params['showDelay'])) $params['showDelay'] = $this->plgParams->get('showDelay', '100');
		if (!isset($params['hideDelay'])) $params['hideDelay'] = $this->plgParams->get('hideDelay', '400');
		if (!isset($params['pos'])) $params['pos'] = $this->plgParams->get('pos', 'center-bottom');
		if (!isset($params['offsetx'])) $params['offsetx'] = (int)$this->plgParams->get('offsetx', '');
		if (!isset($params['offsety'])) $params['offsety'] = (int)$this->plgParams->get('offsety', '');
		if (!isset($params['showwhen'])) $params['showwhen'] = $this->plgParams->get('showwhen', 'mouseenter');
		if (!isset($params['hidewhen'])) $params['hidewhen'] = $this->plgParams->get('hidewhen', '');
		if (!isset($params['width'])) $params['width'] = $this->plgParams->get('width', 0);
				
		$matches = null;
		switch ($params['type']){
			case 'module':
				$regex = '/\[title\]([^\]]*)\[\/title\]/';
				if (preg_match($regex, $plgContent, $matches)) {
					$title = $matches[1];
				} else
					$title = $plgContent;
				$content = $this->parseTipModule($params);
				break;
			case 'article':	
				$regex = '/\[title\]([^\]]*)\[\/title\]/';
				if (preg_match($regex, $plgContent, $matches)) {
					$title = $matches[1];
				} else
					$title = $plgContent;
				$content = $this->parseTipArticle($params);
						
				break;					
			case 'html':
			default:
				$title = "";
				$content = "";
				$regex = '/\[title\]([^\]]*)\[\/title\]/';
				if (preg_match($regex, $plgContent, $matches)) {
					$title = $matches[1];
				}
				$regex = '/\[content\]([^\]]*)\[\/content\]/';
				if (preg_match($regex, $plgContent, $matches)) {
					$content = $matches[1];
				}
				break;
		}
		return $this->wirentTipContent ($title, $content, $params);
	}
	
	function wirentTipContent($title, $content, $params){
		//$mainframe = JFactory::getApplication();
		$mainframe = JFactory::getDocument();
		if ($this->plgParams->get('enable') == 'no') return $title;
		$style = $params["style"];
		if(empty($params["style"]) || $params["style"] == -1)
			$style = "default";
		if(!defined("JA_PLG_TIPS_HEADTAG_".strtoupper($params['style']))){
			$headtag[] = '<link rel="stylesheet" href="'.JURI::base().'plugins/content/plg_jatooltips/assets/themes/'.$style.'/style.css" type="text/css" media="screen"/>';
			$mainframe->addCustomTag(implode("\n", $headtag));
			define("JA_PLG_TIPS_HEADTAG_".strtoupper($params['style']), true);
		}
		
		$tipid = 'ja-tip-'.rand(0,9).rand(0,9).rand(0,9);
		
		$html = "<a class=\"ja-tips-title\" id=\"$tipid\">$title</a>";
		$search = 	array("'", "/","\r\n","\n");
		$replace = 	array("\\'", "\\/","\\n","\\n");
		$title = str_replace($search, $replace, $title);
		if((int)$params['maxTitleChars']) $title = substr($title, 0, (int)$params['maxTitleChars']);
		$content = str_replace($search, $replace, $content);
		$options = '';
		if ($params['showtitle'] && !in_array(1, array(0, '0', 'no', 'No', false, 'false', 'False'))) {
			$options .= ", title: '$title'";
		}
		if ($params['style']) {
			$options .= ", style:'{$params['style']}'";
		}
		if ($params['showDelay']) {
			$options .= ", showDelay: ".intval($params['showDelay']);
		}
		if ($params['hideDelay']) {
			$options .= ", hideDelay: ".intval($params['hideDelay']);
		}
		if ($params['width']) {
			$options .= ", width: ".intval($params['width']);
		}
		if ($params['pos']) {
			$options .= ", pos:'{$params['pos']}'";
		}
		if (($params['showwhen'])) {
			$options .= ", showwhen:'{$params['showwhen']}'";
		}
		if (($params['hidewhen'])) {
			$options .= ", hidewhen:'{$params['hidewhen']}'";
		}
		else
		{
			$options .= ", hidewhen:'mouseout'";
		}
		$offsets = '';
		if (isset($params['offsetx'])) {
			$offsets .= "'x':{$params['offsetx']}";
		}
		if (isset($params['offsety'])) {
			if ($offsets) $offsets .= ',';
			$offsets .= "'y':{$params['offsety']}";
		}
		if ($offsets) {
			$options .= ", offsets: {{$offsets}}";
		}
		
		$html .= "<script type=\"text/javascript\">
		/*<![CDATA[*/
						$(window).addEvent( 'domready', function(){
					
							new JATooltips ([$('$tipid')],new Class({
								initialize: function(){
								},
								content: '$content' 
								$options
								}));
						
						});
		/*]]>*/				
				 </script>";	
		return $html;		
	}
	/**
	*Get module by id
	*@param module id
	*@return moduleObj
	*
	*/
	function getModuleById($id = 0)
	{
		$clean = null;
		if(empty($id))
			return null;
		$Itemid = JRequest::getInt('Itemid');
		$app	= JFactory::getApplication();
		$user	= JFactory::getUser();
		$groups	= implode(',', $user->getAuthorisedViewLevels());
		$db		= JFactory::getDbo();

		$query = new JDatabaseQuery;
		$query->select('id, title, module, position, content, showtitle, params, mm.menuid');
		$query->from('#__modules AS m');
		$query->join('LEFT','#__modules_menu AS mm ON mm.moduleid = m.id');
		$query->where('m.published = 1');
		$query->where('m.id = '.$id);

		$date = JFactory::getDate();
		$now = $date->toMySQL();
		$nullDate = $db->getNullDate();
		$query->where('(m.publish_up = '.$db->Quote($nullDate).' OR m.publish_up <= '.$db->Quote($now).')');
		$query->where('(m.publish_down = '.$db->Quote($nullDate).' OR m.publish_down >= '.$db->Quote($now).')');

		$clientid = (int) $app->getClientId();

		if (!$user->authorise('core.admin',1)) {
			$query->where('m.access IN ('.$groups.')');
		}
		$query->where('m.client_id = '. $clientid);
		
		$query->order('position, ordering');

		// Filter by language
		if ($app->isSite() && $app->getLanguageFilter()) {
			$query->where('m.language in (' . $db->Quote(JFactory::getLanguage()->getTag()) . ',' . $db->Quote('*') . ')');
		}
		// Set the query
		$db->setQuery($query);

		$cache 		= JFactory::getCache ('com_modules', 'callback');
		$cacheid 	= md5(serialize(array($Itemid, $groups, $clientid, JFactory::getLanguage()->getTag())));

		$modules = $cache->get(array($db, 'loadObjectList'), null, $cacheid, false);
		if (null === $modules)
		{
			JError::raiseWarning('SOME_ERROR_CODE', JText::sprintf('JLIB_APPLICATION_ERROR_MODULE_LOAD', $db->getErrorMsg()));
			$return = false;
			return $return;
		}

		// Apply negative selections and eliminate duplicates
		$negId	= $Itemid ? -(int)$Itemid : false;
		$module = &$modules[0];
		// The module is excluded if there is an explicit prohibition, or if
		// the Itemid is missing or zero and the module is in exclude mode.
		$negHit	= ($negId === (int) $module->menuid)
				|| (!$negId && (int)$module->menuid < 0);

		// Only accept modules without explicit exclusions.
		if (!$negHit)
		{
			//determine if this is a custom module
			$file				= $module->module;
			$custom				= substr($file, 0, 4) == 'mod_' ?  0 : 1;
			$module->user		= $custom;
			// Custom module name is given by the title field, otherwise strip off "com_"
			$module->name		= $custom ? $module->title : substr($file, 4);
			$module->style		= null;
			$module->position	= strtolower($module->position);
			$clean	= $module;
		}
		// Return to simple indexing that matches the query order.
		//$clean = array_values($clean);

		return $clean;
	}
	function parseTipModule($params){
		
		$module = null;
		if (isset($params['name'])) {
			$mod_match = trim($params['name']);
			if (substr($mod_match, 0, 4) != 'mod_') $mod_match='mod_'.$mod_match;
			$module = JModuleHelper::getModule($mod_match);
		}
		elseif (isset($params['id'])) {
			$mod_match = $params['id'];
			$module = $this->getModuleById($mod_match);
		}
		
		if ($module && $module->module != 'mod_jatooltips') {
			return JModuleHelper::renderModule($module)."<br />";								
		}
		return "";
	}
	
	function parseTipArticle($params){
		$contents = "";
		if(isset($params['id'])){
			$row = $this->getList($params['id']);
		}					
						
		if($row){
			$contents  .= "<h3><span>".$row->title."</span></h3><br/>";
			if(!isset($params['view']) || $params['view']!='fulltext' || $row->text ==''){
				$contents .= $row->introtext;
			}
			else{
				$contents .= $row->introtext.$row->text;								
			}			
			return $contents;
		}
		
		return '';
	}			
	
	function getList($id=0)
	{
		if(is_numeric($id) && $id>0){
			$mainframe = JFactory::getApplication();
			$db 	=& JFactory::getDBO();
			$user = & JFactory::getUser ();
			$access = JComponentHelper::getParams('com_content')->get('show_noauth');
	
			$contentConfig	= &JComponentHelper::getParams( 'com_content' );
	
			jimport('joomla.utilities.date');
			$date = new JDate();
			$now = $date->toMySQL();
	
			$nullDate = $db->getNullDate();
	
			// query to determine article count
			$query = 'SELECT a.*' .			
				' FROM #__content AS a' .
				' INNER JOIN #__categories AS cc ON cc.id = a.catid';
			$query .=	' WHERE a.state = 1 ' .
				($access ? ' AND a.access IN ('.implode(',',$user->authorisedLevels()).')' . ' AND cc.access IN ('.implode(',',$user->authorisedLevels()).')':'').
				' AND (a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' ) ' .
				' AND (a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )' .
				' AND cc.published = 1' .
				"\n AND a.id = '$id'";
							
			$query .= ' ORDER BY a.ordering ' ;				
	
			$db->setQuery($query);
			$row = $db->loadObject();		
			
			jimport('joomla.plugin.helper');
			JPluginHelper::importPlugin('content');
			
			$app = &JFactory::getApplication();
			$pparams = new JParameter('');
			
			$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');
	  
	  		if ($row) {
	  		 	$row->text = $row->introtext;
		  		$app->triggerEvent('onPrepareContent', array (& $row, & $params, $limitstart));
		   		$row->introtext = $row->text;
	  		}	  		
			return $row;
		}
		return ;
	}
	
	function getPattern ($tag) {
	 $regex = '#{'.$tag.' ([^}]*)}([^{]*){/'.$tag.'}#m';

	  return $regex;
	}
	
	function parseParams($params) {
		$params = html_entity_decode($params, ENT_QUOTES);
		$regex = "/\s*([^=\s]+)\s*=\s*('([^']*)'|\"([^\"]*)\"|([^\s]*))/";
		preg_match_all($regex, $params, $matches);
		
		 $paramarray = null;
		 if(count($matches)){
			$paramarray = array();
				for ($i=0;$i<count($matches[1]);$i++){ 
				  $key = $matches[1][$i];
				  $val = $matches[3][$i]?$matches[3][$i]:($matches[4][$i]?$matches[4][$i]:$matches[5][$i]);
				  $paramarray[$key] = $val;
				}
		  }
		  return $paramarray;
	}
}
/**
 * extends class module helper core of joomla
 * Enter description here ...
 * @author thanhnv
 *
 */
class JAModuleHelper extends JModuleHelper
{
   public static function &load()
   {
   	 return parent::_load();
   }	
}

?>