/**
 * # ------------------------------------------------------------------------
# JA News Flash module for Joomla 1.5
# ------------------------------------------------------------------------
# Copyright (C) 2004-2009 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
# @license - Copyrighted Commercial Software
# Author: J.O.O.M Solutions Co., Ltd
# Websites:  http://www.joomlart.com -  http://www.joomlancers.com
# This file may not be redistributed in whole or significant part.
# ------------------------------------------------------------------------
 */
  Element.Events.extend({
	'wheelup': {
		type: Element.Events.mousewheel.type,
		map: function(event){
			event = new Event(event);
			if (event.wheel >= 0) this.fireEvent('wheelup', event)
		}
	},
	'wheeldown': {
		type: Element.Events.mousewheel.type,
		map: function(event){
			event = new Event(event);
			if (event.wheel <= 0) this.fireEvent('wheeldown', event)
		}
	}
});
 ////

JANewsFlash = new Class( {
						
	/**
	 * constructor.
	 */
	initialize: function( options ){
		// options setting.
		this.options = Object.extend({
			mode	  : 'scroll_left',
			direction : 'right',
			wrapper	  : null,
			duration  : 1000,
			interval  : 3000,
			delayTime : 10,		
			auto	  : false,
			itemClass : '.ja-newsflash-items',
			startItem : 0
		}, options || {} );

		this.modes 			= {             scroll_left:['left','width', 'scroll_left', 'scroll_right'],
								scroll_right:['left','width', 'scroll_left', 'scroll_right'], 
								scroll_up:['top','height'], 
								scroll_down:['top','height'] };
		this.currentIndex 	= 0;
		this.previousIndex 	= null;
		this.nextIndex 		= null;
		this.fx 			= new Array();
		this.runner 		= false;
		this.maxHeight 		= this.options.wrapper.offsetHeight; 
		this.maxWidth 		= this.options.wrapper.offsetWidth ; 
		// if the wrapper is  defined in the layout, and looking for items, re-set css style for each item.
		if( $defined(this.options.wrapper) ){
			switch( this.options.mode ){
				case "effect_fade":		
					this._setFXOpacity();
					break;
				case "effect_replace":
					this._setReplaceSlide();
					break;
				default:
					this._setFXSlide();
					break;
			}
		}
		this.itemsNavigation =  this.options.wrapper.getElements("ul.btn-navigation li") ;
		
		if( $defined(this.itemsNavigation) &&  $defined(this.itemsNavigation[0])  ){
			this.itemsNavigation[0].addClass('active');
			this.itemsNavigation.each( function(item, index) { 
				item.addEvent( 'click', function(e){
					e = new Event(e);
					e.stop();
					if( this.currentIndex != index ) {
						// check image loaded:
						if( index  > this.currentIndex  ){
							if( $defined(this.modes[this.options.mode][3]) ){
								 this.options.mode = this.modes[this.options.mode][3];
							}
						} else {
							if( $defined(this.modes[this.options.mode][2]) ){
								 this.options.mode = this.modes[this.options.mode][2];
							}	
		
						}
						this.previousIndex = this.currentIndex;
						this.currentIndex=index;
						this.run( true );	
					}
					
				}.bind(this) );
			}.bind(this) );
		}
		if( $defined(this.options.buttons) ){
			this.registerButtons( 'click', this.options.buttons , this.options.buttonShow );
		}
		
		///
		/*
		this.options.wrapper.addEvents({
				'wheelup': function(e) {
					
					e = new Event(e).stop(); 
						this.previous(true);
				}.bind(this),
			 
				'wheeldown': function(e) {
					e = new Event(e).stop();
				
					this.next(true);
				}.bind(this)
			} );

		/// */
		if( this.options.auto ) {
			this.play( this.options.delayTime, 'next', true );
		}
	},

	registerButtons:function( eventHandler, objects, isHover ){
		if( $defined(objects)  ){
			for( var action in objects ){
				if( $defined(this[action.toString()])  && $defined(objects[action]) ){ 
					objects[action].addEvent( eventHandler, this[action.toString()].bind(this, [true]) );
				}
		
			}
		
		}
	},	
	/**
	 * Using for effect face mode.
	 * find items in the wrapper and reset css style them if they were found.
	 */
	_setFXOpacity:function(){
		this.options.wrapper.getElements( this.options.itemClass ).each( function(item, index){
			item.setStyles( {"z-index" : index+1,  
						   	 "width"   : this.maxWidth,
							 "display" : "block" } );
			this.fx[index] = new Fx.Style( item, 'opacity', this.options.fxOptions||{duration:500,wait:false} );		
			if( index != 0 ) {
				this.fx[index].hide();
			}
			
			
		}.bind(this) );		
	},
	
	/**
	 * Using for Sider UP|DOWN and RIGHT|LEFT
	 * find items in the wrapper and reset css style them if they were found.
	 */
	_setFXSlide:function(){ 
		var mode = this.modes[this.options.mode][0]; 
		this.items = this.options.wrapper.getElements( this.options.itemClass );
		this.items.each( function(item, index){
			if( mode == 'left' ){																	  
				item.setStyles( { "z-index" : index+1, 
							   	  "left"	: index * this.maxWidth, 
								  "width"	: this.maxWidth,
								  "display" : "block"} );
			} else { 
				item.setStyles( { "z-index" : index+1, 
							   	  "top"		: index * this.maxHeight, 
								  "width"	: this.maxWidth,
								  "display" : "block"} );
			}
			this.fx[index] = new Fx.Style( item, mode, this.options.fxOptions || {duration:500,wait:false} );	
			item.addEvent('click', function(e){
				e = new Event(e);
				e.stop();
				
				if( e.page.x  - (this.options.wrapper.getPosition().x + this.maxWidth/2 ) > 30  ) {
					this.next( true );
				}	
				else if( e.page.x  - (this.options.wrapper.getPosition().x + this.maxWidth/2 ) < -30  ) {
					this.previous(true);
				}
	
			}.bind(this) );	  											 
		}.bind(this) );	
	},
	/**
	 * Using for Replace slide mode
	 * find items in the wrapper and reset css style them if they were found.
	 */
	_setReplaceSlide:function(){
		this.options.wrapper.getElements( this.options.itemClass ).each( function(item, index){
			item.setStyles( {"z-index" : index+1, 
						   	 "width"   : this.maxWidth,
							 "display" : "block"} );
			if( index !=0 ){
				item.setStyle( "display", "none" );
			}
			this.fx[index] = item;		  											 
		}.bind(this) );	
	},
	
	/**
	 * next direction
	 */
	next:function( manual ){
		if( $defined(this.modes[this.options.mode][3]) ){
			 this.options.mode = this.modes[this.options.mode][3];
		}
		this.currentIndex += (this.currentIndex < this.fx.length-1) ? 1 : (1 - this.fx.length);	
		this.previousIndex = this.currentIndex + ( this.currentIndex>0 ? -1 : this.fx.length - 1 );
		this.nextIndex = this.currentIndex + ( this.currentIndex < this.fx.length-1 ? 1 : 1 - this.fx.length );	
		this.run(manual);
	},
	
	/**
	 * previous direction
	 */
	previous:function( manual ){	
		if( $defined(this.modes[this.options.mode][2]) ){
			 this.options.mode = this.modes[this.options.mode][2];
		}
		this.previousIndex = this.currentIndex;
		this.currentIndex += this.currentIndex > 0 ? -1 : this.fx.length - 1;	
		this.nextIndex = this.currentIndex + ( this.currentIndex < this.fx.length-1 ? 1 : 1 - this.fx.length );	
		this.run( manual );
	},
	
	/**
	 * whether to play automatic.
	 */
	play: function( delay, direction, wait ){
		this.stop(); 
		if(!wait){
			this[direction](false);
		}
		this.runner = this[direction].periodical( delay, this, false );
	},
	
	/**
	 * stop direction.
	 */
	stop:function(){
		$clear( this.runner );			
	},
	
	/**
	 * run direction
	 */
	run:function( manual ){
		//if( manual ) {
		//	this.stop();	
	//	}
		//alert("d")
		// re set index of previous item and next item.
		// this.previousIndex = this.currentIndex + ( this.currentIndex>0 ? -1 : this.fx.length - 1 );
	
		
		if( $defined(this.itemsNavigation) ){ 
			this.itemsNavigation[this.previousIndex].removeClass('active'); 
			this.itemsNavigation[this.currentIndex].addClass('active');
		}
		if( $defined(this.items[this.currentIndex].getElement('.preload')) ){
			
			this.items.each( function(item, index){
				if(image = item.getElement('.preload') ){
					item.setHTML('<img title="'+image.title+'" src="'+image.href+'">');	
				}
			} );
		}
		// run direction bacse on mode.
		switch( this.options.mode ){
			case "effect_fade":		
				// change display item with other by using opacity effect.
				this.fx[this.previousIndex].start( 1, 0 );			
				this.fx[this.currentIndex].start( 0, 1 );	
				break;
			case "effect_replace":
				// replace previour item by current item.
				this.fx[this.previousIndex].setStyle( "display", "none" );
				this.fx[this.currentIndex].setStyle( "display", "block" );
				break;
			case "scroll_up":
				this.fx[this.previousIndex].start( 0, -this.maxHeight );			
				this.fx[this.currentIndex].start( this.maxHeight, 0 );
				// from down to up
				break;	
			case "scroll_down":
				this.fx[this.previousIndex].start( 0, this.maxHeight );			
				this.fx[this.currentIndex].start( -this.maxHeight, 0 );
				// from up to down
				break;
			case "scroll_right":
				this.fx[this.previousIndex].start( 0, -this.maxWidth );			
				this.fx[this.currentIndex].start( this.maxWidth, 0 );
				// from left to right
				break;		
			default:
				// from right to left.
				this.fx[this.previousIndex].start( 0, this.maxWidth );			
				this.fx[this.currentIndex].start( -this.maxWidth, 0 );
				break;
		}
	}
} );

