<?php 
/**
 * ------------------------------------------------------------------------
 * JA Showcase component for Joomla 1.7
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - Copyrighted Commercial Software
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites:  http://www.joomlart.com -  http://www.joomlancers.com
 * This file may not be redistributed in whole or significant part.
 * ------------------------------------------------------------------------
 */

require_once( JPATH_COMPONENT_ADMINISTRATOR."/libs/jaimage.php" );	

class JascHelper{
	
	function populateDB($sqlfile, &$db, &$error) {
		$change_md_sqls = JascHelper::splitSql ( $sqlfile );
		foreach ( $change_md_sqls as $query ) {
			$query = trim ( $query );
			if ($query != '') {
				$db->setQuery ( $query );
				if (! $db->query ()) {
					$error [] = " Not run " . $query;
				}
			}
		}
		return $error;
	}
	
	function splitSql($sqlfile) {
		$sql = file_get_contents ( $sqlfile );
		$sql = trim ( $sql );
		$sql = preg_replace ( "/\n\#[^\n]*/", '', "\n" . $sql );
		$buffer = array ();
		$ret = array ();
		$in_string = false;
		
		for($i = 0; $i < strlen ( $sql ) - 1; $i ++) {
			if ($sql [$i] == ";" && ! $in_string) {
				$ret [] = substr ( $sql, 0, $i );
				$sql = substr ( $sql, $i + 1 );
				$i = 0;
			}
			
			if ($in_string && ($sql [$i] == $in_string) && $buffer [1] != "\\") {
				$in_string = false;
			} elseif (! $in_string && ($sql [$i] == '"' || $sql [$i] == "'") && (! isset ( $buffer [0] ) || $buffer [0] != "\\")) {
				$in_string = $sql [$i];
			}
			if (isset ( $buffer [1] )) {
				$buffer [0] = $buffer [1];
			}
			$buffer [1] = $sql [$i];
		}
		
		if (! empty ( $sql )) {
			$ret [] = $sql;
		}
		return ($ret);
	}
	
	function Install_Db() {						
		$path = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_jashowcase' . DS . 'installer' . DS . 'sql' . DS . 'install.configData.sql';
		
		$error = null;
		if (file_exists ( $path )) {
			JascHelper::populateDB ( $path, $db, $error );
			if ($error) {
				$error = implode ( "<br/>", $error );
				return JError::raiseError ( 1, $error );
			}
		} else {
			JError::raiseWarning ( 1, JText::_ ( 'SQL FILE NOT FOUND ERROR' ) . '<br /><br />' );				
		}		
}
	
	/*
	 * 
	 */
	function mergerParam_old($paramsSetting, $params){		
		$paramsOld = $params->toObject();	
		$array = array();						
		foreach ($paramsOld as $key=>$val){
			if($val == "global"){
				foreach ($paramsOld as $pakey=>$paval){
					if(strpos($pakey, $key) !== false){
						$params->set($pakey, "global");								
					}	
				}		
			}	
		}
		foreach ($paramsOld as $key=>$val){
			if($val != "global"){
				if($key == "use_path_thumb-input-general_path_thumb" && $val != "global"){
					$paramsSetting->set("general_path_thumb", $val);						
				}else{									
					$paramsSetting->set($key, $val);
				}	
			}
		}
		return $paramsSetting;						
	}
	/*
	 * 
	 */
	function mergerParam($paramsSetting, $params){		
		$paramsOld = $params->toObject();	
		$array = array();						
		foreach ($paramsOld as $key=>$val){
			if($val == "global"){
				foreach ($paramsOld as $pakey=>$paval){
					if(strpos($pakey, $key) !== false){
						$params->set($pakey, "global");								
					}	
				}		
			}	
		}
		foreach ($paramsOld as $key=>$val){
			if($val != "global"){
				if ($key == "use_path_thumb") {
					$use_path_thumb_input = $params->get("use_path_thumb-input-general_path_thumb", "");
					$paramsSetting->set("use_path_thumb-input-general_path_thumb", $use_path_thumb_input);
					$paramsSetting->set("general_path_thumb", $val);						
				}
				else if ($key != "use_path_thumb-input-general_path_thumb") {
					$paramsSetting->set($key, $val);
				}	
			}
		}
		return $paramsSetting;
	}
	
	/**
	 * get url of image category
	 */
	function renderCategoryThumb( $thumbURL, $width, $height, $crop, $aspect, $thumbnailMode='crop' ){
		$jaimage = JAImage::getInstance();
		if( !$jaimage->sourceExited( $thumbURL ) ){
			 $imageURL = "";
		} else { 
			if( $thumbnailMode != 'none' ) {
				$imageURL = $jaimage->resize( $thumbURL, $width, $height, $crop, $aspect ); 		
			} else {
				$imageURL = $thumbURL;	
			}
		}
		return $imageURL;
	}
	
	/**
	 *
	 */
	function findChidrentIDs( &$data, $output=array(), $root=0, $isOpt=false){
		$out = array();
		$sizeOf = sizeof($data);
		
		for ($ii = 0; $ii < $sizeOf; $ii++) {
			if (($data[$ii]->parent_id == $root) 
					   || (($root === null) && ($data[$ii]->parent_id == '0'))) {
					
				if (isset($data[$ii]->id)) { 
					$output[] = $data[$ii]->id;
						$output  =	JascHelper::findChidrentIDs( $data, $output, $data[$ii]->id, $isOpt );
				 }
			}
		}
		return $output;
	}
	
	/**
	 *
	 */
	function countItems( $ids ){
		$db		=& JFactory::getDBO();
		$query = "SELECT count(id) as total FROM #__jashowcase ";
		$query .= " WHERE catid IN('".implode("','", $ids)."') ";
		$db->setQuery($query);
		$data  = $db->loadObject();
		return $data->total;
	}
	
	/**
	 * render link to browse categories
	 */
	function getBrowseCategoryLink( $item ){
		$itemid = JRequest::getInt('Itemid', 0);
		return 	JRoute::_( 'index.php?option=com_jashowcase&view=jacategories&catid='
						  	.$item->id.'&Itemid='.$itemid );	
	}
	
	/**
	 * get link of the cateogry using for transfer to the showcase page.
	 */
	function getCategoryLink(  $item ){
		$itemid = JRequest::getInt('Itemid', 0);
		return 	JRoute::_( 'index.php?option=com_jashowcase&view=jashowcase&catid='
						  .$item->id.'&Itemid='.$itemid );
	}
	
	/**
	 * trim string with the length expected
	 */
	function trimString( $desc ='', $begin=0, $maxChars=250 ){
		
		if (function_exists ( 'mb_substr' )) {
			$doc = JDocument::getInstance ();	
			$desc = SmartTrim::mb_trim ( $desc, $begin, $maxChars, $doc->_charset );
		} else {
			$desc = SmartTrim::trim ( $desc, begin, $maxChars );
		}
				
		return $desc;		
	}
	
	/**
	 * render tree menu
	 */
	function renderTreeCategoriesById( $data, $output='', $root=null, $extra='', $level=0, $target='' ){
		$out = array();
		$sizeOf = sizeof($data);
		$output .= '<ul '.$extra.' >';
	
		for ($ii = 0; $ii < $sizeOf; $ii++) {
			if (($data[$ii]->parent_id == $root) 
					   || (($root === null) && ($data[$ii]->parent_id == '0'))) {

				$text = '<a '.$target.' href="'.JascHelper::getCategoryLink( $data[$ii] ).'">';		
				$text .= $data[$ii]->title .'</a>';
				$output .= '<li>' . $text;
				
				if (isset($data[$ii]->id)) { 
					$extra = 'class="parent'. ($level).'"';
					$output  =	JascHelper::renderTreeCategoriesById( $data, $output, $data[$ii]->id, $extra, $level+1, $target );
				}
				else {
					$output .= '</li>';
						
				}
			}
		}
		$output .= '</ul>';
		
		return $output;
	}
	/**
	 * render categories
	 */
	function renderCategories( $data, $level, $extra = '', $url = '', $params ) {		
		$option	= JRequest::getCmd('option');
		$tabs = "\n" . str_repeat(" ", $level * 2);
		
		$li_tabs = $tabs . " ";
	
		$output = $tabs. '<ul ' . $extra . ' >';
		foreach ($data as $key=>$val) {
			if(empty($url)) {
				$text = $val->title;
			} else { 
				$text = JascHelper::getCategoryLink( $val, $url, $params );
			}
			$output .= $li_tabs . '<li>' . $text;
			if(isset($val->children[0]) ) {
				$extra = 'class="parent'. ($level).'"';  
				$output .= JascHelper::renderCategories($val->children, $level+1, $extra, $url , $params );
				$output .= $li_tabs . '</li>';
			} else {
				$output .= '</li>';
			}

		}
		$output .= $tabs . '</ul>';
		
		return $output;
	}

	function parse_JSON($objects) {
		if (! $objects)
			return;
		$db = JFactory::getDBO ();
		
		$html = '';
		$item_tem = array ();
		foreach ( $objects as $i => $row ) {
			$tem = array ();
			$item_tem [$i] = '{';
			foreach ( $row as $k => $value ) {
				//$value = $db->Quote($value);
				$tem [$i] [] = "'$k' : " . $db->Quote ( $value ) . "";
			}
			$item_tem [$i] .= implode ( ',', $tem [$i] );
			$item_tem [$i] .= '}';
		}
		
		if ($item_tem)
			$html = implode ( ',', $item_tem );
		
		return $html;
	}
	/*
	 * load blog for overide template
	 */	
	function jaLoadBlock($fileName ,$templateJaName='') {
		$mainframe = JFactory::getApplication();
		$templateDirectory = JPATH_BASE . DS . 'templates' . DS . $mainframe->getTemplate () . DS . 'html' . DS . "com_jashowcase" . DS . "themes";
		if (file_exists ( $templateDirectory . DS . $templateJaName . DS . "html" . $fileName )) {
			return $templateDirectory . DS . $templateJaName . DS . "html" . $fileName;
		} else {
			if (file_exists ( 'components/com_jashowcase/themes/' . $templateJaName . '/html/' . $fileName )) {
				return 'components/com_jashowcase/themes/' . $templateJaName . '/html/' . $fileName;
			} else {
				if (file_exists ( $templateDirectory . DS . "default" . DS . "html" . $fileName )) {
					return $templateDirectory . DS . "default" . DS . "html" . $fileName;
				}else{
					return 'components/com_jashowcase/themes/default/html/' . $fileName;	
				}
			}
		}
	}
	/* Enter description here...
	 *
	 * @param unknown_type $timeStamp
	 * @param unknown_type $mid
	 * @return unknown
	 */
	function generatTimeStamp($timeStamp, $mid = 0) {
		$ago = 0;
		if ($mid == 0) {
			$cal = (time () - $timeStamp);
		} else {
			$cal = ($timeStamp - time ());
			if ($cal < 0) {
				$cal = 0 - $cal;
				$ago = 1;
			}
		}
		$d = floor ( $cal / 24 / 60 / 60 );
		$h = floor ( ($cal / 60 / 60 - $d * 24) );
		$m = floor ( ($cal / 60 - $d * 24 * 60 - $h * 60) );
		
		if ($mid == 0) {
			if ($d < 3) {
				$str = "<span class=\"small\">" . ($h+$d*24) . "h ago</span>";
			} /*elseif ($d == 1) {
				$str = "<span class=\"class_yesterday\">" . JText::_ ( 'Yesterday' ) . " " . "</span><span class=\"small\"> +" . $h . "h</span>";
			} elseif ($d == 2) {
				$str = "<span class=\"class_2dayago\">2 " . JText::_ ( 'days' ) . " " . JText::_ ( 'ago' ) . "</span>";
			} else {
				//$str = generatDate($timeStamp,1);
				$str = "<span class=\"time_show\">" . $d . "d," . $h . "h " . JText::_ ( 'ago' ) . ".</span>";
			}*/
			elseif($d<120){
				$str = "<span class=\"class_2dayago\"> ". $d. JText::_ ( 'DAYS' ) . " " . JText::_ ( 'AGO' ) . "</span>";
			}
			else{
				$str = "<span class=\"time_show\"> ". $m. JText::_ ( 'MONTHS' ) . " " . JText::_ ( 'AGO' ) . "</span>";
			}
			return $str;
		} else {
			if ($d == 0) {
				$str = "<span class=\"class_today\">" . JText::_ ( 'TODAY' ) . "</span>";
			} else {
				if ($ago == 1) {
					if ($d == 1) {
						$str = "<span class=\"class_yesterday\">" . JText::_ ( 'YESTERDAY' ) . "<span class=\"small\"> +" . $h . "h</span>";
					
					} else {
						//$str = generatDate($timeStamp,1);
						$str = "<span class=\"time_show\">" . $d . "d," . $h . "h " . JText::_ ( 'AGO' ) . ".</span>";
					}
				} else {
					if ($d == 1) {
						$str = "<span class=\"class_tomorrow\">" . JText::_ ( 'TOMORROW' ) . "</span>";
					} else {
						//$str = generatDate($timeStamp,1);
						$str = "<span class=\"time_show\">" . $d . "d," . $h . "h.</span>";
					}
				}
			}
			return $str;
		}
	}
	
	function getAllItems(){
		$db		=& JFactory::getDBO();
		$arrayTags = JRequest::getVar("jasctags", array());		
		//first delete all
		$query = 'SELECT * FROM #__jashowcase';		
		$db->setQuery( $query );
		return $db->loadObjectList();		
	}

	function isSpecialUser($userID = 0, $action = '') {
		if ($userID == 0) {
			if ($action) {
				return false;
			}
			$user = & JFactory::getUser ();
		} else {
			$user = & JFactory::getUser ( $userID );
		}				
		
		$result	= new JObject;

		$actions = array(
			'core.admin', 'core.manage'
		);

		foreach ($actions as $action) {
			$result->set($action, $user->authorise($action, 'com_users'));
		}
		if($result->get("core.admin") == 1 || $result->get("core.manage") == 1){
			return true;
		}
		
		return false;
	}
	
	function savedlinfo ($data) {																							
		$listKey = array();
		$allTempName = '';
		$listItem = JAShowcaseHelpers::getAllItems();
		foreach ($listItem as $item) {
			$templateName = strtoupper(str_replace(" ", "", $item->name));
			$listKey[$templateName] = $item->id;			
			
			if(count($listKey) >1)
				$allTempName .= ",".$templateName;
			else
				$allTempName .= $templateName;	
		}
						
		require_once JPATH_BASE.DS.'modules'.DS."mod_jastatistics".DS."db_adapter.php";					
		$allTempName = explode("," , $allTempName);	
		$results = DB_Adapter::getInfoProducts($allTempName);
		
		$listResult = array();
		$query = '';
		$i= 0;		
		$db		=& JFactory::getDBO();
				
		foreach ($results as $temName=>$result){
			$totalDL 	 = 0;
			$dateRelease = date("d M Y",time());				 				
			if($result){
				if(isset($result->totaldownloads)){
					$totalDL 		= $result->totaldownloads;
					$dateRelease 	= $result->dateadded; 
				}else{				
					foreach ($result as $key=>$val){	
						if(isset($val->totaldownloads)){																			
							$totalDL 		= $val->totaldownloads;
							$dateRelease 	= $val->dateadded; 
						} 
					}				
				}						
			}
			$listResult[$temName] = array("date_released"=>date("d M Y",$dateRelease), "total_download"=>$totalDL);			
			$dateRelease = date("Y-m-d",$dateRelease);			
			$query = "UPDATE #__jashowcase SET `date_released` = '".$dateRelease."',`total_download` = '".$totalDL."' WHERE `id` =".$listKey[$temName].";";
			$db->setQuery( $query );
			//echo $db->getQuery()."<br/>";
			$db->Query( $query );				
		}
																		
		if($params->get("latest_time_reload", 0)){
			$params->set("latest_time_reload", time());
			$data = $params->toString();		
		}else{
			$data .= "\nlatest_time_reload=".time();	
		}						
		$data .= "\nlatest_time_reload=".time();				
		jimport('joomla.filesystem.file');
		$file 	= JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jashowcase'.DS.'views'.DS.'jaconfig'.DS.'settings.ini';
		JFile::write($file, $data);
		
		$object = array ();
		$k = 0;	
		
		$jascTempNames = JRequest::getVar ( 'jasctempname','');		
		$jascArrayTem  = explode(',',$jascTempNames); 
		foreach ($jascArrayTem as $temName){
			if(isset($listResult[$temName])){
				$object [$k] = new stdClass ( );
				$object [$k]->id      = 'jasc-totaldownload-'.$temName;
				$object [$k]->type    = 'innerHTML';							
				$object [$k]->content = $listResult[$temName]["total_download"];
				$k++;

				$object [$k] = new stdClass ( );
				$object [$k]->id      = 'jasc-date-release-'.$temName;
				$object [$k]->type    = 'innerHTML';							
				$object [$k]->content = $listResult[$temName]["date_released"];
				$k++;
			}	
		}
		return $object; 			
	}
	/**
	 * Enter description here...
	 *
	 * @param unknown_type $URL
	 * @param unknown_type $req
	 * @return unknown
	 */
	function curl_getdata($URL, $req) {		
		$ch = curl_init ();
		curl_setopt ( $ch, CURLOPT_SSL_VERIFYPEER, FALSE );
		curl_setopt ( $ch, CURLOPT_URL, $URL );
		curl_setopt ( $ch, CURLOPT_TIMEOUT, 10 );
		curl_setopt ( $ch, CURLOPT_POST, TRUE );
		curl_setopt ( $ch, CURLOPT_POSTFIELDS, $req );
		curl_setopt ( $ch, CURLOPT_RETURNTRANSFER, 1 );
		$result = curl_exec ( $ch );
		curl_close ( $ch );
		
		return $result;
	
	}
	
	/**
	 * Enter description here...
	 *
	 * @param unknown_type $host
	 * @param unknown_type $path
	 * @param unknown_type $req
	 * @return unknown
	 */
	function socket_getdata($host, $path, $req) {
		$header = "POST $path HTTP/1.0\r\n";
		$header .= "Host: " . $host . "\r\n";
		$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$header .= "User-Agent:      Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1) Gecko/20061010 Firefox/2.0\r\n";
		$header .= "Content-Length: " . strlen ( $req ) . "\r\n\r\n";
		$header .= $req;
		$fp = @fsockopen ( $host, 80, $errno, $errstr, 60 );
		if (! $fp)
			return;
		@fwrite ( $fp, $header );
		$data = '';
		$i = 0;
		do {
			$header .= @fread ( $fp, 1 );
		} while ( ! preg_match ( '/\\r\\n\\r\\n$/', $header ) );
		
		while ( ! @feof ( $fp ) ) {
			$data .= @fgets ( $fp, 128 );
		}
		fclose ( $fp );
		return $data;
	}
	
}
?>

<?php 
if (! class_exists ( 'SmartTrim' )) {
	class SmartTrim {
		/*
      $hiddenClasses: Class that have property display: none or invisible.
    */
		function mb_trim($strin, $pos = 0, $len = 10000, $hiddenClasses = '', $encoding = 'utf-8') {
			mb_internal_encoding ( $encoding );
			$strout = trim ( $strin );
			
			$pattern = '/(<[^>]*>)/';
			$arr = preg_split ( $pattern, $strout, - 1, PREG_SPLIT_DELIM_CAPTURE );
			$left = $pos;
			$length = $len;
			$strout = '';
			for($i = 0; $i < count ( $arr ); $i ++) {
				$arr [$i] = trim ( $arr [$i] );
				if ($arr [$i] == '')
					continue;
				if ($i % 2 == 0) {
					if ($left > 0) {
						$t = $arr [$i];
						$arr [$i] = mb_substr ( $t, $left );
						$left -= (mb_strlen ( $t ) - mb_strlen ( $arr [$i] ));
					}
					
					if ($left <= 0) {
						if ($length > 0) {
							$t = $arr [$i];
							$arr [$i] = mb_substr ( $t, 0, $length );
							$length -= mb_strlen ( $arr [$i] );
							if ($length <= 0) {
								$arr [$i] .= '...';
							}
						
						} else {
							$arr [$i] = '';
						}
					}
				} else {
					if (SmartTrim::isHiddenTag ( $arr [$i], $hiddenClasses )) {
						if ($endTag = SmartTrim::getCloseTag ( $arr, $i )) {
							while ( $i < $endTag )
								$strout .= $arr [$i ++] . "\n";
						}
					}
				}
				$strout .= $arr [$i] . "\n";
			}
			//echo $strout;  
			return SmartTrim::toString ( $arr, $len );
		}
		
		function trim($strin, $pos = 0, $len = 10000, $hiddenClasses = '') {
			$strout = trim ( $strin );
			
			$pattern = '/(<[^>]*>)/';
			$arr = preg_split ( $pattern, $strout, - 1, PREG_SPLIT_DELIM_CAPTURE );
			$left = $pos;
			$length = $len;
			$strout = '';
			for($i = 0; $i < count ( $arr ); $i ++) {
				$arr [$i] = trim ( $arr [$i] );
				if ($arr [$i] == '')
					continue;
				if ($i % 2 == 0) {
					if ($left > 0) {
						$t = $arr [$i];
						$arr [$i] = substr ( $t, $left );
						$left -= (strlen ( $t ) - strlen ( $arr [$i] ));
					}
					
					if ($left <= 0) {
						if ($length > 0) {
							$t = $arr [$i];
							$arr [$i] = substr ( $t, 0, $length );
							$length -= strlen ( $arr [$i] );
							if ($length <= 0) {
								$arr [$i] .= '...';
							}
						
						} else {
							$arr [$i] = '';
						}
					}
				} else {
					if (SmartTrim::isHiddenTag ( $arr [$i], $hiddenClasses )) {
						if ($endTag = SmartTrim::getCloseTag ( $arr, $i )) {
							while ( $i < $endTag )
								$strout .= $arr [$i ++] . "\n";
						}
					}
				}
				$strout .= $arr [$i] . "\n";
			}
			//echo $strout;  
			return SmartTrim::toString ( $arr, $len );
		}
		
		function isHiddenTag($tag, $hiddenClasses = '') {
			//By pass full tag like img
			if (substr ( $tag, - 2 ) == '/>')
				return false;
			if (in_array ( SmartTrim::getTag ( $tag ), array ('script', 'style' ) ))
				return true;
			if (preg_match ( '/display\s*:\s*none/', $tag ))
				return true;
			if ($hiddenClasses && preg_match ( '/class\s*=[\s"\']*(' . $hiddenClasses . ')[\s"\']*/', $tag ))
				return true;
		}
		
		function getCloseTag($arr, $openidx) {
			$tag = trim ( $arr [$openidx] );
			if (! $openTag = SmartTrim::getTag ( $tag ))
				return 0;
			
			$endTag = "<$openTag>";
			$endidx = $openidx + 1;
			$i = 1;
			while ( $endidx < count ( $arr ) ) {
				if (trim ( $arr [$endidx] ) == $endTag)
					$i --;
				if (SmartTrim::getTag ( $arr [$endidx] ) == $openTag)
					$i ++;
				if ($i == 0)
					return $endidx;
				$endidx ++;
			}
			return 0;
		}
		
		function getTag($tag) {
			if (preg_match ( '/\A<([^\/>]*)\/>\Z/', trim ( $tag ), $matches ))
				return ''; //full tag
			if (preg_match ( '/\A<([^ \/>]*)([^>]*)>\Z/', trim ( $tag ), $matches )) {
				//echo "[".strtolower($matches[1])."]";
				return strtolower ( $matches [1] );
			}
			//if (preg_match ('/<([^ \/>]*)([^\/>]*)>/', trim($tag), $matches)) return strtolower($matches[1]);
			return '';
		}
		
		function toString($arr, $len) {
			$i = 0;
			$stack = new JAStack ( );
			$length = 0;
			while ( $i < count ( $arr ) ) {
				$tag = trim ( $arr [$i ++] );
				if ($tag == '')
					continue;
				if (SmartTrim::isCloseTag ( $tag )) {
					if ($ltag = $stack->getLast ()) {
						if ('</' . SmartTrim::getTag ( $ltag ) . '>' == $tag)
							$stack->pop ();
						else
							$stack->push ( $tag );
					}
				} else if (SmartTrim::isOpenTag ( $tag )) {
					$stack->push ( $tag );
				} else if (SmartTrim::isFullTag ( $tag )) {
					//echo "[TAG: $tag, $length, $len]\n";
					if ($length < $len)
						$stack->push ( $tag );
				} else {
					$length += strlen ( $tag );
					$stack->push ( $tag );
				}
			}
			
			return $stack->toString ();
		}
		
		function isOpenTag($tag) {
			if (preg_match ( '/\A<([^\/>]+)\/>\Z/', trim ( $tag ), $matches ))
				return false; //full tag
			if (preg_match ( '/\A<([^ \/>]+)([^>]*)>\Z/', trim ( $tag ), $matches ))
				return true;
			return false;
		}
		
		function isFullTag($tag) {
			//echo "[Check full: $tag]\n";
			if (preg_match ( '/\A<([^\/>]*)\/>\Z/', trim ( $tag ), $matches ))
				return true; //full tag
			return false;
		}
		
		function isCloseTag($tag) {
			if (preg_match ( '/<\/(.*)>/', $tag ))
				return true;
			return false;
		}
	}
	
	class JAStack {
		var $_arr = null;
		function JAStack() {
			$this->_arr = array ();
		}
		
		function push($item) {
			$this->_arr [count ( $this->_arr )] = $item;
		}
		function pop() {
			if (! $c = count ( $this->_arr ))
				return null;
			$ret = $this->_arr [$c - 1];
			unset ( $this->_arr [$c - 1] );
			return $ret;
		}
		function getLast() {
			if (! $c = count ( $this->_arr ))
				return null;
			return $this->_arr [$c - 1];
		}
		function toString() {
			$output = '';
			foreach ( $this->_arr as $item ) {
				$output .= $item . "\n";
			}
			return $output;
		}
	}
}

?>