<?php
/*
# ------------------------------------------------------------------------
# JA Showcase component for Joomla 1.5
# ------------------------------------------------------------------------
# Copyright (C) 2004-2010 JoomlArt.com. All Rights Reserved.
# @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
# Author: JoomlArt.com
# Websites: http://www.joomlart.com - http://www.joomlancers.com.
# ------------------------------------------------------------------------
*/

defined ( '_JEXEC' ) or die ( 'Restricted access' );
?>
<div class="ja-showcase module clearfix">	
	<div class="jasc-item-header">
		<div class="jasc-tools-wrap clearfix">
			<h3 class="<?php echo $this->item->params->get('suffix_class');?>"><span><?php echo $this->item->name; ?></span></h3>    	
		</div>
		
		<!-- check for show description -->
		<?php if($this->paramsSetting->get('general_show_description') && $this->item->description!='') :?>
		
	  	<div class="jasc-item-desc"><?php echo $this->item->description;?></div>
		<?php endif;?>
	
	</div>
	
	<?php if($this->paramsSetting->get("general_is_show_legend", 1)):?>	
	<div class="ja-showcase-legend clearfix">	
		<?php
		if ($this->item->params->get('ext_type_com')) :?>
			<img src="<?php echo JURI::base();?>components/<?php echo $option;?>/assets/icons/ext_com.png" alt="Component" />
		<?php endif;

		if ($this->item->params->get('ext_type_mod')) :?>
			<img src="<?php echo JURI::base();?>components/<?php echo $option;?>/assets/icons/ext_mod.png" alt="Module" />
		<?php endif;

		if ($this->item->params->get('ext_type_plg')) :?>
			<img src="<?php echo JURI::base();?>components/<?php echo $option;?>/assets/icons/ext_plugin.png" alt="Plugin" />
		<?php endif;

		if ($this->item->params->get('joomla_version_15')==1) :?>
			<img src="<?php echo JURI::base();?>components/<?php echo $option;?>/assets/icons/compat_15_native.png" alt="Joomla 1.5 Native" />
		<?php endif;

		if ($this->item->params->get('joomla_version_15')==2) :?>
			<img src="<?php echo JURI::base();?>components/<?php echo $option;?>/assets/icons/compat_15_legacy.png" alt="Joomla 1.5 Legacy" />
		<?php endif;

		if ($this->item->params->get('joomla_version_10')==1) :?>
			<img src="<?php echo JURI::base();?>components/<?php echo $option;?>/assets/icons/compat_10.png" alt="Joomla 1.0" />
		<?php endif;

		if ($this->item->params->get('joomla_ext_lang')==1) :?>
			<img src="<?php echo JURI::base();?>components/<?php echo $option;?>/assets/icons/ext_lang.png" alt="Multilanguage" />
		<?php endif;	?>
	</div>	
	<?php endif;?>
	
	<div class='ja-showcase-thumb'>
		<?php  echo $this->item->imageThumb;?>
	</div>
	
	<?php if(isset($this->item->rating)):?>
	<div class="jasc-item-rating clearfix">
		<strong><?php echo JText::_("Rating");?>:</strong>
		<div class="jasc-item-rating-list">
			<div class="jasc-current-rating" style="width: <?php 				
				if( $this->item->rating ) {					
					echo number_format(intval($this->item->rating[1])/intval($this->item->rating[2]), 2)*20;
				} else echo "0"; ?>%;"> </div>
		</div>
	</div>
	<?php endif;?>
	
	<div class="jasc-tools clearfix"> 		
	  	<?php if ($this->paramsSetting->get('general_show_more_info') && $this->item->info_url ) :?>
			<span class="jasc-more-info">
				<a href="<?php echo $this->item->info_url; ?>" title="<?php echo JText::_('MORE INFO');?>" target="_<?php echo $this->paramsSetting->get('general_show_more_info-1-general_open_more');?>" class="more_info">
					<?php echo JText::_('MORE INFO');?>
				</a>
			</span>
		<?php endif;?>
		
		<?php if($this->paramsSetting->get('general_show_live_demo') && $this->item->demo_url) :?>					
			<span class="jasc-demo">
				<a href="<?php echo $this->item->demo_url;?>" title="<?php echo JText::_('LIVE DEMO');?>" target="_<?php echo $this->paramsSetting->get('general_show_live_demo-1-general_open_live');?>" class="live_demo">
					<?php echo JText::_('LIVE DEMO');?>
				</a>
			</span>
	  <?php endif; ?>
	  
	  
	  <?php if($this->paramsSetting->get('general_allow_add_favorites')) :?>	
	  <span id="jasc-action-favorites-<?php echo $this->item->id;?>" class="jasc-action-favorites">
			<?php 
			 $styleAdd    = '';
			 $styleRemove = '';
			 if(isset($this->jascFavoritesTemplate) && in_array($this->item->id, $this->jascFavoritesTemplate)):
				$styleAdd       = 'style="display:none;"';				
			 else:
			    $styleRemove    = 'style="display:none;"';
			 endif;			 	
			?>		
			<a href="javascript:void(0)" <?php echo $styleRemove;?> class="jasc-favorites-active" onclick="saveToFavorites('remove',<?php echo $this->item->id;?>);return false;" title="<?php echo JText::_("Remove from my favorites");?>"><?php echo JText::_("Remove from my favorites");?></a>
			<a href="javascript:void(0)" <?php echo $styleAdd;?> class="jasc-favorites-unactive" onclick="saveToFavorites('save',<?php echo $this->item->id;?>);return false;" title="<?php echo JText::_("Add to favorites");?>"><?php echo JText::_("Add to favorites");?></a>			
  		</span> 
  		<?php endif;?>
  		
  		<?php if($this->item->params->get('download')) :?>	
  		<span class="jasc-download">			
			<a target="_blank" href="http://www.joomlart.com/forums/downloads.php?do=cat&id=<?php echo $this->item->params->get('download')?>" title="<?php echo JText::_("Download");?>"><?php echo JText::_("Download");?></a>			
  		</span> 
  		<?php endif;?>
    </div>	
</div>