<?php
/**
 * ------------------------------------------------------------------------
 * JA Showcase component for Joomla 1.7
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - Copyrighted Commercial Software
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites:  http://www.joomlart.com -  http://www.joomlancers.com
 * This file may not be redistributed in whole or significant part.
 * ------------------------------------------------------------------------
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );

jimport ( 'joomla.application.component.view' );

/**
 * HTML View class for the jashowcase Component
 *
 * @package		Joomla
 * @subpackage	Components
 */
class JashowcaseViewJashowcase extends JView {
	/**
	 * display jashowcase
	 */	
	function display($tpl = null) {
		$option	= JRequest::getCmd('option');
		$itemid = JRequest::getInt('Itemid', 0);
		$mainframe = JFactory::getApplication();
		$layout = $this->getLayout ();
		$helper = new JascHelper ( );
		
		// Get cat first value from config file
		$this->paramsSetting = JashowcaseHelper::_getSetting (); // global config
		$params = & $mainframe->getParams ( 'com_jashowcase' );	// menu config
		$this->paramsSetting = $helper->mergerParam($this->paramsSetting, $params);
		//$this->paramsSetting->merge ( $params );
		if($this->paramsSetting->get("general_paging", "normal") != "normal"){						
			$this->paramsSetting->set("general_paging-normal-is_allow_display_by_page_link", 0);
		}
		
		$model = $this->getModel ();		
				
		$menus = &JSite::getMenu ();
		$menu = $menus->getActive ();
		
		$cols   = JRequest::getVar ( 'cols', $this->paramsSetting->get ( 'cols' , 2) );
		$rows   = JRequest::getVar ( 'rows', $this->paramsSetting->get ( 'rows' , 4) );
		
		$this->assignRef ( 'cols', $cols );
		$this->assignRef ( 'rows', $rows );
			 
		$limit = $cols * $rows;				
		
		// Avoid $limit set for zero or less than zero
		$limit = $limit <= 0 ? 6 : $limit;
		$limitstart = JRequest::getVar ( 'limitstart', 0 );
		
		if(JRequest::getInt("pagenumber", 0)>1){			
			$limitstart = (JRequest::getInt("pagenumber", 0)-1) * $limit;			
		}
		
		if(JRequest::getInt("numberPage", 0)){
			$limitstart = $limitstart + JRequest::getInt("numberPage", 0) * $limit;  
		}
		if(JRequest::getVar("subaction", '') == "showfavorites"){
			JRequest::setVar ( 'catid', 0 );	
		}
		
		$catid = JRequest::getVar ( 'catid', $this->paramsSetting->get('catid', 0) );
		
		$where = "";		
		if ($catid || $this->paramsSetting->get ( 'catid' )) {			
			if (! $catid && $catid!=0  && $this->paramsSetting->get ( 'catid' )) {							
				$catid = $this->paramsSetting->get ( 'catid' );
			} else {			
				if($catid != 0){
					$categoryIds = $model->getFindCategoryIDs ( $catid );
					if($categoryIds && count($categoryIds)){								
						array_push ( $categoryIds, $catid );
						$catid = $categoryIds;
					}
				}
			}
			
			if(JRequest::getVar("subaction", '') != "showfavorites"){
				if (is_array ( $catid )) {				
					if($catid[0]){
						$where .= " AND s.catid IN ( '" . implode ( "','", $catid ) . "') ";
					}
				} else {
					if($catid){
						$where .= " AND s.catid=" . intval ( $catid );
					}
				}
			}
		}
		//check access			
		if(!JascHelper::isSpecialUser()){
			$user = & JFactory::getUser ();
			if($user->id){
				$where .= " AND(c.access=1 || c.access=2)";
			}else{
				$where .= " AND c.access=1";
			}
		}				
		
		if($this->paramsSetting->get('general_allow_add_favorites')){		
			if(JRequest::getVar("subaction", '') == "showfavorites" && JRequest::getVar("jaShowcaseFavorites", '') && JRequest::getVar("jascaction", '') == "scroll"){		
				$arrayCokie = explode(",",JRequest::getVar("jaShowcaseFavorites", ''));
			}else{
				$arrayCokie = $this->getFavorites();
			}
			$this->assignRef ( 'jascFavoritesTemplate', $arrayCokie );
			
			if(JRequest::getVar("subaction", '') == "showfavorites"){
				if($arrayCokie){
					if(count($arrayCokie) > 1){
						$where .= " AND s.id in (" . implode(",",$arrayCokie) . ")";	
					}else{
						$where .= " AND s.id=" . intval ( $arrayCokie[0] );
					}
				}else{
					$where .= " AND s.id=0";
				}	
			}
		}		
		$total = $model->getTotalItem ( $where );
		if ($limit > $total) {
			$limitstart = 0;
		}
		$totalPage = $total/$limit; 
		$this->assignRef ( 'totalPage', $totalPage);
		if(!$this->paramsSetting->get("general_paging-normal-is_allow_display_by_page_link", 0) || $layout == "nextpage"){					
			$orderBy = "ORDER BY s.".$this->paramsSetting->get("general_order_by", "ordering")." ASC";		
			$themes = $model->getItems ( "$where $orderBy, s.id DESC LIMIT $limitstart,$limit" );
									
			if( !is_array($themes) ) $themes = array();
					
			foreach ( $themes as $k => $item ) {
				$item->live_title = str_replace ( "[SHOWCASENAME]", $item->name, JText::_ ( 'TITLE_LIVE' ) );
				
				$item->info_url_title = '';
				$item->demo_url_title = '';
				
				if ($item->info_url != '') {				
					if ($item->info_component == 'com_content'){
						$item->rating = $model->getContentRating($item->info_url);
						$item->info_url_title = $this->getPageTitle ( $item->info_component,$item->info_url );
						$item->info_url = $this->sefRelToAbs ( "index.php?option=com_content&view=article&id=" . $item->info_url );
					}else if($item->info_component == 'com_k2'){
						$item->rating = $model->getRating($item->info_url);
						$result = $this->getInfoFromK2($item->info_url);
						if($result){							
							if(isset($result->title)){
								$item->info_url_title = $result->title;
								$item->info_url = $result->link;
								$item->extra_fields = array();								
								if(is_array($result->extra_fields)){									
									$item->extra_fields = $result->extra_fields;
								}								
																							 												
								if(isset($item->extra_fields["Live Demo"])){																		
									$item->demo_url_title = $this->paramsSetting->get ( 'open_live' );
									$item->demo_url = $this->sefRelToAbs ( $item->extra_fields["Live Demo"] );
								}							
							}else{
								$item->info_url_title = "";
								$item->info_url = "";
							}							
						}
					}
					
				} elseif ($item->other_info_url != '') {
					$item->info_url = $item->other_info_url;
				}
				if (substr ( $item->demo_url, 0, 4 ) != 'http' && $item->demo_url != '') {
					$item->demo_url = JURI::base() . $item->demo_url;
				}
				if ($item->demo_url != '') {
					$item->demo_url_title = $this->paramsSetting->get ( 'open_live' );
					$item->demo_url = $this->sefRelToAbs ( $item->demo_url );
				}
				
				// if JAPopup was turned on
				//thumb detail
				require_once (JPATH_COMPONENT_ADMINISTRATOR . "/libs/jaimage.php");		
				$path_thumbview = JashowcaseHelper::_getPathTthumbview ($this->paramsSetting);
				
				if($this->paramsSetting->get("thumbnail_mode", "none") == "resize"){
					$height = $this->paramsSetting->get("thumbnail_mode-resize-general_thumb_height", "415");
					$width = $this->paramsSetting->get("thumbnail_mode-resize-general_thumb_width", "420");
				}else{
					$height = $this->paramsSetting->get("thumbnail_mode-crop-general_thumb_height", "415");
					$width = $this->paramsSetting->get("thumbnail_mode-crop-general_thumb_width", "420");
				}
	
				if($this->paramsSetting->get ( 'slideshow_type', 'slider' ) == "popup"){
					$enableJAPopup = $this->isJAPopupPluginEnable ();
					if ($enableJAPopup && $this->paramsSetting->get ( 'slideshow_type-popup-integrate_japopup', 1 )) {						
						$item->imageThumb = $this->buildThumbWithJAPopup ( $item, $path_thumbview, $height, $width);	
					}else{								
						$item->imageThumb = $this->buildThumbPopup ( $item, $path_thumbview,$height, $width);
					}	
				}else{
					if($this->paramsSetting->get ( 'slideshow_type', 'slider' ) == "slider"){					
						$item->imageThumb = $this->buildThumbSlider ( $item, $path_thumbview, $height, $width);
					}else{					
						$item->imageThumb = $this->buildThumbPopup ( $item, $path_thumbview, $height, $width);
					}
				}						
				
				//params of custom fields
				$item->params = new JRegistry;
				$item->params->loadJSON($item->datas);				
				
				$themes [$k] = $item;
			}
			
			if($this->paramsSetting->get("general_paging") == "normal"){			
				$this->getPaging($limitstart, $limit, $totalPage);								
			}
		}		
		
		define ( 'SHOWCASED', true );
		
		$list = $this->buildCategoryList ();
		
		$this->assignRef ( 'limit', $limit );
		$this->assignRef ( 'totalAll', $total );
		
		$this->assignRef ( 'catlist', $list );
		$this->assignRef ( 'Itemid', $itemid );		
		$this->assignRef ( 'themes', $themes );		
		$this->assignRef ( 'params', $this->paramsSetting );
		$this->assignRef ( 'path_thumbview', $path_thumbview );
		$this->assignRef ( 'paramsSetting', $this->paramsSetting );
				
		//Look for template files in component folders
        $this->_addPath('template', JPATH_COMPONENT.DS.'themes');
        $this->_addPath('template', JPATH_COMPONENT.DS.'themes'.DS.'default'.DS.'html'.DS.'jashowcase');
        
        //Look for overrides in template folder (K2 template structure)
        $this->_addPath('template', JPATH_SITE.DS.'templates'.DS.$mainframe->getTemplate().DS.'html'.DS.'com_jashowcase'.DS.'themes'.DS.'html'.DS.'jashowcase');        
        $this->_addPath('template', JPATH_SITE.DS.'templates'.DS.$mainframe->getTemplate().DS.'html'.DS.'com_jashowcase'.DS.'themes'.DS.'default'.DS.'html'.DS.'jashowcase');
        
        //Look for overrides in template folder (Joomla! template structure)
        $this->_addPath('template', JPATH_SITE.DS.'templates'.DS.$mainframe->getTemplate().DS.'html'.DS.'com_jashowcase'.DS.'default'.DS.'html'.DS.'jashowcase');
        $this->_addPath('template', JPATH_SITE.DS.'templates'.DS.$mainframe->getTemplate().DS.'html'.DS.'com_jashowcase'.DS.'html'.DS.'jashowcase');
        
        //Look for specific K2 theme files 
        if ($this->paramsSetting->get('theme')) {
            $this->_addPath('template', JPATH_COMPONENT.DS.'themes'.DS.$this->paramsSetting->get('theme').DS.'html'.DS.'jashowcase');
            $this->_addPath('template', JPATH_SITE.DS.'templates'.DS.$mainframe->getTemplate().DS.'html'.DS.'com_jashowcase'.DS.'themes'.DS.$this->paramsSetting->get('theme').DS.'html'.DS.'jashowcase');                                        
            $this->_addPath('template', JPATH_SITE.DS.'templates'.DS.$mainframe->getTemplate().DS.'html'.DS.'com_jashowcase'.DS.$this->paramsSetting->get('theme'));
        }
        
        //////////----------process ajax ------------------///////////                
		if($layout == "nextpage"){
			$this->setLayout("default");
			$object = array ();
			$k = 0;
			$jascaction = JRequest::getVar("jascaction", "");
			if($this->paramsSetting->get("general_paging") == "normal"){	
				$limit = count($themes);
			}else{
				$limit = $limit + $limitstart;	
			}
			//scroll page
			if($jascaction == "scroll" || $jascaction == "moreinfo"){		
				$object [$k] = new stdClass ( );
				$object [$k]->id = 'jashowcase-items';
				$object [$k]->type = 'addinnerHTML';							
				$object [$k]->content = $this->loadTemplate('main_items');
				$k++;
				
				$object [$k] = new stdClass ( );
				$object [$k]->id = 'jaShowcaseNumPage';
				$object [$k]->type = 'addValue';							
				$object [$k]->content = '1';
				$k++;
				
			}else if($jascaction == "paging"){
				$pageNumber = JRequest::getVar("pagenumber", 2);				
				
				$object [$k] = new stdClass ( );
				$object [$k]->id = 'jashowcase-items-'.$pageNumber;
				$object [$k]->type = 'innerHTML';							
				$object [$k]->content = $this->loadTemplate('main_items');
				$k++;
				
				$object [$k] = new stdClass ( );
				$object [$k]->id = 'jashowcase-items-'.$pageNumber;
				$object [$k]->type = 'addClass';							
				$object [$k]->content = "loaded";
				$k++;
				
				$object [$k] = new stdClass ( );
				$object [$k]->id = 'jasc-pagination-'.$pageNumber;
				$object [$k]->type = 'innerHTML';							
				$object [$k]->content = $this->pagination->getPagesLinks();
				$k++;

				$object [$k] = new stdClass ( );
				$object [$k]->id = 'jasc-pagination-'.$pageNumber;
				$object [$k]->type = 'addClass';							
				$object [$k]->content = "loaded";
				$k++;
			}
			//filter page
			else{
				$object [$k] = new stdClass ( );
				if($this->paramsSetting->get("general_paging", "normal") == "normal"){
					$object [$k]->id = 'jashowcase-items-1';
				}else{
					$object [$k]->id = 'jashowcase-items';
				}
				$object [$k]->type = '';				
				$object [$k]->content = $this->loadTemplate('main_items');
				$k++;
																		
				if(JRequest::getVar("subaction", '') == "changecat"){
					$object [$k] = new stdClass ( );
					$object [$k]->id = 'jasc-action-search-cat';
					$object [$k]->type = 'innerHTML';				
					$object [$k]->content = $this->loadTemplate('categories');
					$k++;										
				}								
										
				if(JRequest::getVar("subaction", '') == "backtolisting"){
					$object [$k] 			= new stdClass ( );
					$object [$k]->id 		= 'jasc-faback-container';
					$object [$k]->type 		= 'changedisplay';																
					$object [$k]->content 	= 'none';
					$k++;							
					//jasc-container-cat
					$object [$k] 			= new stdClass ( );
					$object [$k]->id 		= 'jasc-container-cat';
					$object [$k]->type 		= 'changedisplay';																
					$object [$k]->content 	= 'block';
					$k++;
					
					$object [$k] 			= new stdClass ( );
					$object [$k]->id 		= 'jasc-isshow-favorite';
					$object [$k]->type 		= 'value';																
					$object [$k]->content 	= '0';
					$k++;
										
					$object [$k] 			= new stdClass ( );
					$object [$k]->id 		= 'jaShowcaseFavorites';
					$object [$k]->type 		= 'value';																
					$object [$k]->content 	= '';
					$k++;					
				}
				
				if(JRequest::getVar("subaction", '') == "showfavorites"){					
					$object [$k] 			= new stdClass ( );
					$object [$k]->id 		= 'jasc-faback-container';
					$object [$k]->type 		= 'changedisplay';																
					$object [$k]->content 	= 'block';
					$k++;							
					//jasc-container-cat
					$object [$k] 			= new stdClass ( );
					$object [$k]->id 		= 'jasc-container-cat';
					$object [$k]->type 		= 'changedisplay';																
					$object [$k]->content 	= 'none';
					$k++;							

					$object [$k] 			= new stdClass ( );
					$object [$k]->id 		= 'jasc-isshow-favorite';
					$object [$k]->type 		= 'value';																
					$object [$k]->content 	= '1';
					$k++;
					
					$fvCokie = implode(",", $arrayCokie);
					$object [$k] 			= new stdClass ( );
					$object [$k]->id 		= 'jaShowcaseFavorites';
					$object [$k]->type 		= 'value';																
					$object [$k]->content 	= $fvCokie;
					$k++;					
				}	
				
				if($this->paramsSetting->get("general_paging") == "normal"){
					$object [$k] = new stdClass ( );
					$object [$k]->id = 'jasc-pagination';
					$object [$k]->type = 'innerHTML';							
					$object [$k]->content = $this->pagination->getPagesLinks();
					$k++;
				}
				
				$object [$k] = new stdClass ( );
				$object [$k]->id = 'jaShowcaseNumPage';
				$object [$k]->type = 'value';				
				$object [$k]->content = 1;
				$k++;
				
				$object [$k] = new stdClass ( );
				$object [$k]->id = 'jaShowcasetotalPage';
				$object [$k]->type = 'value';				
				$object [$k]->content = ceil($totalPage);
				$k++;
			}
			
			
			if($limit > $total) $limit = $total;						
			$object [$k] = new stdClass ( );
			$object [$k]->id = 'jacs-action-tags';
			$object [$k]->type = 'innerHTML';			
			$textCount = "{$limit} ";			
			
			if($limit>1){
				$textCount .= JText::_("ITEMS");
			}else{
				$textCount .= JText::_("ITEM");
			}
			$textCount .= " / ".$total." ";
			if($total >1){				
				$textCount .= JText::_("ITEMS");
			}else{
				$textCount .= JText::_("ITEM");
			}
			$object [$k]->content = $textCount;
			
			$k++;
			if($this->paramsSetting->get("general_paging") == "button"){
				if($limit < $total){					
					$object [$k] = new stdClass ( );
					$object [$k]->id = 'ja-showcase-nav';
					$object [$k]->type = 'changedisplay';											
					$object [$k]->content 	= '';
					$k++;
				}else{
					$object [$k] = new stdClass ( );
					$object [$k]->id = 'ja-showcase-nav';
					$object [$k]->type = 'changedisplay';											
					$object [$k]->content 	= 'none';
					$k++;
				}	
				$object [$k] = new stdClass ( );
				$object [$k]->id = 'jasc_get_more_count';
				$object [$k]->type = 'innerHTML';											
				$object [$k]->content = JText::_("SHOWING")." ".$textCount;
				$k++;
				
				$object [$k] = new stdClass ( );
				$object [$k]->id = 'jasc-get-more';
				if($limit >= $total){
					$object [$k]->type = 'addClass';
				}else{
					$object [$k]->type = 'removeClass';
				}											
				$object [$k]->content = 'jasc-disable';
				$k++;
			}
																		
			
			$data = "({'data':[";
			$data .= $helper->parse_JSON ( $object );
			$data .= "]})";
			echo $data;
			if (!class_exists ('T3Common')){
				exit ();
			}else{
				if(T3Common::detect ()){
					exit ();
				}
			}			
		}else{
			parent::display($tpl);
		}		                                               
	}
	
	function getInfoFromK2($pid){
		include_once JPATH_SITE.DS."components".DS."com_k2".DS."models".DS."item.php";								
		include_once JPATH_SITE.DS."administrator".DS."components".DS."com_k2".DS."tables".DS."k2item.php";								
		$modelK2 = new K2ModelItem();			
		$oldcid = JRequest::getVar('id');			
		JRequest::setVar('id', $pid);				
		$row = $modelK2->getData();										
		JRequest::setVar('id', $oldcid);		
		$row->extra_fields=K2ModelItem::getItemExtraFields($row->extra_fields);
		$tmpExtra = $row->extra_fields; 				
		if($tmpExtra){								
			$row->extra_fields = array();
			foreach ($tmpExtra as $key=>$extraField){
				$row->extra_fields[str_replace(' ','_',trim(strtolower($extraField->name)))] = $extraField->value; 
			}		
		}	
		include_once JPATH_SITE.DS."components".DS."com_k2".DS."helpers".DS."route.php";
		$link = '';				
		$link = K2HelperRoute::getItemRoute($row->id.':'.urlencode($row->alias));
		$row->link = JRoute::_($link);
		//print_r($row->link);die();
		return $row;
	}
	
	function getPageTitle( $info_component, $pid ) {
		$db = & JFactory::getDBO ();
		if($info_component == "com_content"){
			$db->setQuery ( "SELECT `title` from #__content where id = '$pid'" );
		}else{
			$query  = 'SELECT c.*, cc.alias as categoryalias, cc.id as catID, cc.title as catTitle' .
				' FROM #__k2_items AS c' .
				' LEFT JOIN #__categories AS cc ON cc.id = c.catid' .
				' WHERE c.id = "'.$pid.'"';
							
			$db->setQuery($query);	
		}	
		$html = $db->loadObject ();		
		//if (! $html)
			//echo $db->getErrorMsg () . "<br />" . $db->_sql;
		return $html;
	}
	
	function getPaging($limitstart, $limit, $totalPage) {
		$model = $this->getModel ();		
		if(JRequest::getVar("jascaction") == "filter"){							
			$model->_pagination = null;				
		}
		$pagination = &$model->getPagination ($limitstart, $limit, 'jasc-pagination');		
		$this->assignRef ( 'pagination', $pagination );				
	}
	
	/*
	 * get array cookies favorites
	 */
	function getFavorites(){
		$mainframe = JFactory::getApplication();	
		$arrayCokie = array();		
		$cookieName = 'jascFavoritesTemplate';		
		if($cookieName){
			$jascCookie = JRequest::getVar ( $cookieName, '', 'COOKIE');			
			if($jascCookie)
				$arrayCokie = explode(",", $jascCookie);
		}
		$arrayCokie = array_diff($arrayCokie, array("", " ", 0));		
		return $arrayCokie;
	}
	
	/**
	 * display subcategories.
	 */
	function buildCategoryList() {
		$isShowed = $this->paramsSetting->get ( 'general_is_show_cat_filter', 0 );
		if ($isShowed == 0) {
			return '';
		}
		$parentId = ( int ) $this->paramsSetting->get ( 'catid', 0 );		
		
		$categories = $this->getModel ()->getAllCat (0);		
		$categories = $this->builtTreeCategories($categories);		
		$this->assignRef ( 'params', $this->paramsSetting );
		$this->assignRef ( 'categories', $categories );
	}
	
	/**
	 * Built tree
	 * */	
	function builtTreeCategories($items){  				       	       	
        $children = array();
		// first pass - collect children
		$list 		= array();
		$listSearch = array(); 
		$arraydemo = array();
		
		if($items){			
			foreach ($items as $v )
			{
				$pt = $v->parent_id;			
				$list = @$children[$pt] ? $children[$pt] : array();
				array_push( $list, $v );
				$children[$pt] = $list;			
			}	
									
			$list = $this->treerecurse(0, '', array(), $children );									
			if($list){
				foreach ($list as $i => $item) {
					$treename 		= $item->treename;			
					$treename 		= JFilterOutput::ampReplace($treename);
					$treename 		= str_replace('"', '&quot;', $treename);									
					$list[$i]->treename = $treename;
					$arraydemo[] 	= $list[$i]; 					
				}
			}
		}
							
		return $arraydemo;
  	}  
		
	
	//Get all image in the folder which have same name with image.
	function buildThumbSlider($item, $path_thumbview, $height, $width) {
		$option	= JRequest::getCmd('option');
		$ret = '';
		$image =  "<img src=\"%s\" title=\"%\" alt=\"%\"/>";
		
		require_once (JPATH_COMPONENT_ADMINISTRATOR . "/libs/jaimage.php");
		$jaimage = JAImage::getInstance ();
		
		$fulldir = JPATH_SITE . DS . $path_thumbview . DS . $item->directory;		

		if (is_dir ( $fulldir ) && $item->directory != '') {
			$dh = opendir ( $fulldir );
			$regex = '/(\.gif)|(.jpg)|(.png)|(.bmp)$/i';
			$thumb_title = str_replace ( "[SHOWCASENAME]", $item->name, JText::_ ( 'TITLE_SHOWCASE' ) );
			
			$fulldir = JPATH_SITE . DS . $path_thumbview . DS . $item->directory;
			$thumbnailMode = $this->paramsSetting->get ( 'thumbnail_mode', 'crop' );			
			$aspect = $this->paramsSetting->get ( 'thumbnail_mode-resize-use_ratio', '1' );
			$crop = $thumbnailMode == 'crop' ? true : false;			
			
			if ($item->thumbnail != '') {										
				// render image thumbnail.
				if (! $jaimage->sourceExited ( $path_thumbview . "/$item->directory/$item->thumbnail" )) {
					$imageURL = "components/$option/assets/images/default.jpg";
				} else {					
					if ($thumbnailMode != 'none') {
						$imageURL = $jaimage->resize ( $path_thumbview . "/$item->directory/$item->thumbnail", $width, $height, $crop, $aspect );
					} else {
						$imageURL = $path_thumbview . "/$item->directory/$item->thumbnail";
					}					
				}
				$imageURL = $this->removeBlast($imageURL);				
				$count = 0;
				$dk =  opendir ( $fulldir );
				while ( false !== ($filename = readdir ( $dk )) ) {
					if (preg_match ( $regex, $filename )) {
						$count++;
					}
				}							
				if($count <= 1){
					$ret = "<img src='" . JURI::base () . $imageURL . "' border='0'  alt='" . $item->name . "' title=\"" . $item->name . "\" />";	
				}else{
					$ret = "<div style=\"overflow: hidden; height:".$height."px; position:absolute; display:none;\" class='ja-newsflash-items'><img src='" . JURI::base () . $imageURL . "' border='0'  alt='" . $thumb_title . "' title=\"" . $thumb_title . "\" /></div>";
					$i = 0;
					$nav = array();
					$nav[] = "<li><a href=\"#\" class='jasc-navigate-".($i+1)."' onclick=\"return false;\">".($i+1)."</a></li>";				
					$i = 1; 
					while ( false !== ($filename = readdir ( $dh )) ) {						
						if($item->thumbnail != $filename){
							$title = $filename;
							if (preg_match ( $regex, $filename )) {
								if ($thumbnailMode != 'none') {
									$imageURL = $jaimage->resize ( $path_thumbview . "/$item->directory/$filename", $width, $height, $crop, $aspect );
								} else {
									$imageURL = $path_thumbview . "/$item->directory/$filename";
								}					
								
								//only load the first image
								
								$ret .= "<div style=\"overflow: hidden; height:".$height."px; position:absolute; display:none;\" class='ja-newsflash-items'><a href='" . JURI::base () . $imageURL . "' class=\"preload\" title=\"" . $thumb_title . "\" ></a></div>";							 
								$nav[] = "<li><a href=\"#\" class='jasc-navigate-".($i+1)."' onclick=\"return false;\">".($i+1)."</a></li>";
							$i++;
							}
						}				
					}
					if ($i == 0) {
						$ret .= "<div class='ja-newsflash-items'><img src='" . JURI::base () . "components/$option/assets/images/default.jpg' border='0' alt='" . $item->name . "' style=\"padding-bottom:10px\"/></div>";
					}
				}
			} else {				
				$nav = array();
				 $i = 0;
				while ( false !== ($filename = readdir ( $dh )) ) {
					$title = $filename;
					if (preg_match ( $regex, $filename )) {
						if ($thumbnailMode != 'none') {
							$imageURL = $jaimage->resize ( $path_thumbview . "/$item->directory/$filename", $width, $height, $crop, $aspect );
						} else {
							$imageURL = $path_thumbview . "/$item->directory/$filename";
						}					
						
						//only load the first image
						if($i == 0):						
							$ret .= "<div style=\"overflow: hidden; height:".$height."px; position:absolute; display:none;\" class='ja-newsflash-items'><img src='" . JURI::base () . $imageURL . "' border='0'  alt='" . $thumb_title . "' title=\"" . $thumb_title . "\" /></div>";							
						else:
							$ret .= "<div style=\"overflow: hidden; height:".$height."px; position:absolute; display:none;\" class='ja-newsflash-items'><a href='" . JURI::base () . $imageURL . "' class=\"preload\" title=\"" . $thumb_title . "\" ></a></div>";
						endif;	 
						$nav[] = "<li><a href=\"#\" class='jasc-navigate-".($i+1)."' onclick=\"return false;\">".($i+1)."</a></li>";
					$i++;
					}
					
				}
				if ($i == 0) {
					$ret .= "<div class='ja-newsflash-items'><img src='" . JURI::base () . "components/$option/assets/images/default.jpg' border='0' alt='" . $item->name . "' style=\"padding-bottom:10px\"/></div>";
				}
			}
		} else {
			$ret .= "<img src='" . JURI::base () . "components/$option/assets/images/default.jpg' border='0' alt='" . $item->name . "' style=\"padding-bottom:10px\"/>";
		}
		
		$button = '';
		if( isset($nav) ) {
			$button = '<div class="jasc-btn-control">';
			if($this->paramsSetting->get("slideshow_type-slider-general_show_button_navigate", 1) == 1){
				$button .= '<a href="#" class="jasc-btn-next" onclick="return false;">'.JText::_("NEXT").'</a>	
						<a href="#" class="jasc-btn-previous" onclick="return false;">'.JText::_("PREVIOUS").'</a>';	
			} 					
			$button .='<ul class="btn-navigation clearfix">'.implode( " ", $nav ).'</ul>';
			$button .= '</div>';
		}
		//$width = $width + 3;
		return   '<div class="ja-showcase-block" id="ja-showcase-block'.$item->id.'">'
				.  $button.'<div class="ja-showcase-img" style="position: relative; width:'.$width.'px; height:'. $height.'px; overflow: hidden;">'.$ret.'</div>'
			 .'</div>';
	}	
	
	function removeBlast($url){
		$url = str_replace("//","/", $url);		
		return $url;
	}
	
	//Get all image in the folder which have same name with image.
	function buildThumbPopup($item, $path_thumbview,$height,$width) {
		$option	= JRequest::getCmd('option');
		$ret = '';
		require_once (JPATH_COMPONENT_ADMINISTRATOR . "/libs/jaimage.php");
		$jaimage = JAImage::getInstance ();
		
		$fulldir = JPATH_SITE . DS . $path_thumbview . DS . $item->directory;
		
		$thumbnailMode = $this->paramsSetting->get ( 'thumbnail_mode', 'crop' );
		$aspect = $this->paramsSetting->get ( 'thumbnail_mode-resize-use_ratio', '1' );
		$crop = $thumbnailMode == 'crop' ? true : false;		
		
		if (is_dir ( $fulldir ) && $item->directory != '') {
			$dh = opendir ( $fulldir );
			$regex = '/(\.gif)|(.jpg)|(.png)|(.bmp)$/i';
			$thumb_title = str_replace ( "[SHOWCASENAME]", $item->name, JText::_ ( 'TITLE_SHOWCASE' ) );
			
			if ($item->thumbnail != '') {
				// render image thumbnail.
				if (! $jaimage->sourceExited ( $path_thumbview . "/$item->directory/$item->thumbnail" )) {
					$imageURL = "components/$option/assets/images/default.jpg";
				} else {
					if ($thumbnailMode != 'none') {
						$imageURL = $jaimage->resize ( $path_thumbview . "/$item->directory/$item->thumbnail", $width, $height, $crop, $aspect );
					} else {
						$imageURL = $path_thumbview . "/$item->directory/$item->thumbnail";
					}
				}
				
				$imageURL = $this->removeBlast($imageURL);
				
				$img = "<img src='" . JURI::base () . $imageURL . "' border='0'  alt='" . $item->name . "' title=\"" . $item->name . "\" />";
				
				while ( false !== ($filename = readdir ( $dh )) ) {
					if (preg_match ( $regex, $filename )) {
						if($this->paramsSetting->get ( 'slideshow_type', 'slider' ) == "noslide"){
							//$ret .= "<a href=\"" . JURI::base () . $imageURL . "\">$img</a>\n";
							$ret .= $img;
							$img = ""; 
						}else{							
							$ret .= "<a href=\"" .JURI::base () . $path_thumbview . "/$item->directory/$filename\" rel=\"lightbox-{$item->id}-{$item->thumbnail}\">$img</a>\n";
							$img = "";	
						}					
					}
				}
			} else {
				$i = 0;
				while ( false !== ($filename = readdir ( $dh )) ) {
					if ($i == 0) {
						$title = $filename;
						if ($thumbnailMode != 'none') {
							$imageURL = $jaimage->resize ( $path_thumbview . "/$item->directory/$filename", $width, $height, $crop, $aspect );
						} else {
							$imageURL = $path_thumbview . "/$item->directory/$filename";
						}
						
						$imageURL = $this->removeBlast($imageURL);
						
						$img = "<img src='" . JURI::base () . $imageURL . "' border='0'  alt='" . $thumb_title . "' title=\"" . $thumb_title . "\" />";
					}
					if (preg_match ( $regex, $filename )) {
						if($this->paramsSetting->get ( 'slideshow_type', 'slider' ) == "noslide"){
							//$ret .= "<a href=\"" . JURI::base () . $imageURL . "\">$img</a>\n";
							$ret .= $img;
							$i ++;
							break;		
						}else{
							$ret .= "<a href=\"" .JURI::base () . $path_thumbview . "/$item->directory/$filename\" rel=\"lightbox-{$item->id}-$title\">$img</a>\n";
						}					
						$img = "";
						$i ++;
					}
				}
				if ($i == 0) {
					$ret .= "<img src='" . JURI::base () . "components/$option/assets/images/default.jpg' border='0' alt='" . $item->name . "' style=\"padding-bottom:10px\"/><BR/>";
				}
			}
		} else {
			$ret .= "<img src='" . JURI::base () . "components/$option/assets/images/default.jpg' border='0' alt='" . $item->name . "' style=\"padding-bottom:10px\"/><BR/>";
		}
		return $ret;
	}
	
	/**
	 * build thumnails using for japopup
	 */
	function buildThumbWithJAPopup($item, $path_thumbview,$height,$width) {
		$images = array ();
		$fulldir = JPATH_SITE . DS . $path_thumbview . DS . $item->directory;
		$dh = opendir ( $fulldir );
		$regex = '/(\.gif)|(.jpg)|(.png)|(.bmp)$/i';
		while ( false !== ($filename = readdir ( $dh )) ) {
			if (preg_match ( $regex, $filename )) {
				$images [] = $path_thumbview . "/$item->directory/$filename";
			}
		}
		if ($item->thumbnail != '') {
			$imageURL = $path_thumbview . "/$item->directory/$item->thumbnail";
		} else {
			$imageURL = current ( $images );
		}
		
		$jaimage = JAImage::getInstance ();
		$thumbnailMode = $this->paramsSetting->get ( 'thumbnail_mode', 'crop' );
		$aspect = $this->paramsSetting->get ( 'thumbnail_mode-resize-use_ratio', '1' );
		$crop = $thumbnailMode == 'crop' ? true : false;		
		
		if ($thumbnailMode != 'none' && $imageURL != '') {
			$imageURL = $jaimage->resize ( $imageURL, $width, $height, $crop, $aspect );
		}
		if ($imageURL == '') {
			$img = "<img src='" . JURI::base () . "components/com_jashowcase/assets/images/default.jpg' border='0' alt='" . $item->name . "' style=\"padding-bottom:10px\"/><BR/>";
			$images = array(JURI::base () . "components/com_jashowcase/assets/images/default.jpg");
		} else {
			$imageURL = $this->removeBlast($imageURL);
			$img = "<img src='" . JURI::base () . $imageURL . "' border='0'   alt='" . $item->name . "' title=\"" . $item->name . "\" />";
		}
		
		return $this->renderJAPopupCustomTag ( implode ( ", ", $images ), $img, '', $item, $this->paramsSetting->get ( 'slideshow_type-popup-popup_type', '' ) );
	}
	
	/**
	 * custom tag is used for slideshow of ja popoup
	 */
	function renderJAPopupCustomTag($colection, $text, $group = '', $item, $modal = '') {
		$out = $modal ? 'modal="' . $modal . '"' : "";
		$string = '{japopup show="one" type="slideshow" ' . $out . ' group="' . $group . '" content="' . $colection . '" title="' . $item->name . '" } ' . $text . ' {/japopup}'; // echo $string;die;
		if(JRequest::getVar("layout") == "nextpage"){
			$dispatcher =& JDispatcher::getInstance();											
			JPluginHelper::importPlugin( 'plg_japopup');		
			$text = $dispatcher->trigger( 'onAfterRoute');		
			$text = $dispatcher->trigger( 'replaceContent',  array( $string ));						
			return $text[0];	
		}
		return $string;
	}
	
	/**
	 * check plugin ja popup was enabled ?
	 */
	function isJAPopupPluginEnable() {
		$filePath = JPATH_SITE.DS."plugins".DS."system".DS."japopup".DS."japopup.php";		
		if(file_exists($filePath)){
			return true;
		}
		return false;
	}
	
	/**
	 * return path base
	 */
	function getLinkFromK2($result) {		
		include_once JPATH_SITE.DS."components".DS."com_k2".DS."helpers".DS."route.php";
		$link = K2HelperRoute::getItemRoute($result->id.':'.urlencode($result->alias),$result->catID.':'.urlencode($result->categoryalias));
		return $link;
	}
	
	/**
	 * return path base
	 */
	function sefRelToAbs($value) {
		jimport ( 'joomla.application.router' );
		// Replace all &amp; with & as the router doesn't understand &amp;
		$url = str_replace ( '&amp;', '&', $value );
		if (substr ( strtolower ( $url ), 0, 9 ) != "index.php")
			return str_replace ( '&', '&amp;', $url );
		$uri = JURI::getInstance ();
		$prefix = $uri->toString ( array ('scheme', 'host', 'port' ) );
		return $prefix . JRoute::_ ( $url );
	}
	
	function treerecurse( $id, $indent, $list, &$children, $maxlevel=9999, $level=0, $type=1 )
	{
		if (@$children[$id] && $level <= $maxlevel)
		{
			foreach ($children[$id] as $v)
			{
				$id = $v->id;
				$txt = "";
				if ( $type ) {				
					$pre 	= '|_&nbsp;';
					$spacer = '';
					if($level >0)					
						$spacer = '.';
				} else {					
					$pre 	= '- ';
					$spacer = '&nbsp;&nbsp;';
				}

				if ( $v->parent_id != 0 ) {
					$txt 	= $pre;					
				}
											
				$pt = $v->parent_id;
				$list[$id] = $v;
				
				$list[$id]->treename = "$indent$txt";				
				$list[$id]->children = count( @$children[$id] );
				$list[$id]->level 	 = $level + 1;
				$list = $this->treeRecurse( $id, $indent . $spacer, $list, $children, $maxlevel, $level+1, $type );
			}
		}			
		return $list;
	}
}
?>