<?php
/*
# ------------------------------------------------------------------------
# JA Amazon S3 installation Package (component & Plugin)
# ------------------------------------------------------------------------
# Copyright (C) 2004-2010 JoomlArt.com. All Rights Reserved.
# @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
# Author: JoomlArt.com
# Websites: http://www.joomlart.com - http://www.joomlancers.com.
# ------------------------------------------------------------------------
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.installer.installer');

// Load Component JA Amazon S3 language file
$lang = &JFactory::getLanguage();
$lang->load('com_jaamazons3');
$component_name = JText::_('COMPONENT_JA_AMAZON_S3');

$status = new JObject();
$status->modules = array ();
$status->plugins = array ();

$modules = & $this->manifest->getElementByPath('package_elements/modules');
$plugins = & $this->manifest->getElementByPath('package_elements/plugins');
//other extensions type..

//uninstall modules
if (is_a($modules, 'JSimpleXMLElement') && count($modules->children())) {

	foreach ($modules->children() as $module) {

		$mname = $module->attributes('module');
		$db = & JFactory::getDBO();
		$query = "SELECT `id` FROM `#__modules` WHERE module = ".$db->Quote($mname)."";
		$db->setQuery($query);
		$modules = $db->loadResultArray();
		if (count($modules)) {
			foreach ($modules as $module) {
				$installer = new JInstaller;
				$result = $installer->uninstall('module', $module, 0);
			}
		}
		$status->modules[] = array ('name'=>$mname, 'client'=>'Site', 'result'=>$result);
	}
}

//uninstall plugins
if (is_a($plugins, 'JSimpleXMLElement') && count($plugins->children())) {

	foreach ($plugins->children() as $plugin) {

		$pname = $plugin->attributes('plugin');
		$pgroup = $plugin->attributes('group');
		$db = & JFactory::getDBO();
		$query = 'SELECT `id` FROM #__plugins WHERE element = '.$db->Quote($pname).' AND folder = '.$db->Quote($pgroup);
		$db->setQuery($query);
		$plugins = $db->loadResultArray();
		if (count($plugins)) {
			foreach ($plugins as $plugin) {
				$installer = new JInstaller;
				$result = $installer->uninstall('plugin', $plugin, 0);
			}
		}
		$status->plugins[] = array ('name'=>$pname, 'group'=>$pgroup, 'result'=>$result);
	}
}

?>

<?php $rows = 0;?>
<h2><?php echo JText::_('JA_AMAZON_S3_REMOVAL_STATUS'); ?></h2>
<table class="adminlist">
  <thead>
    <tr>
      <th class="title" colspan="2"><?php echo JText::_('EXTENSION'); ?></th>
      <th width="30%"><?php echo JText::_('STATUS'); ?></th>
    </tr>
  </thead>
  <tfoot>
    <tr>
      <td colspan="3"></td>
    </tr>
  </tfoot>
  <tbody>
    <tr class="row0">
      <td class="key" colspan="2"><?php echo $component_name; ?></td>
      <td><strong><?php echo JText::_('REMOVED'); ?></strong></td>
    </tr>
    <?php if (count($status->modules)) : ?>
    <tr>
      <th><?php echo JText::_('MODULE'); ?></th>
      <th><?php echo JText::_('CLIENT'); ?></th>
      <th></th>
    </tr>
    <?php foreach ($status->modules as $module) : ?>
    <tr class="row<?php echo (++ $rows % 2); ?>">
      <td class="key"><?php echo $module['name']; ?></td>
      <td class="key"><?php echo ucfirst($module['client']); ?></td>
      <td><strong><?php echo ($module['result'])?JText::_('REMOVED'):JText::_('NOT_REMOVED'); ?></strong></td>
    </tr>
    <?php endforeach;?>
    <?php endif; ?>
    <?php if (count($status->plugins)) : ?>
    <tr>
      <th><?php echo JText::_('PLUGIN'); ?></th>
      <th><?php echo JText::_('GROUP'); ?></th>
      <th></th>
    </tr>
    <?php foreach ($status->plugins as $plugin) : ?>
    <tr class="row<?php echo (++ $rows % 2); ?>">
      <td class="key"><?php echo ucfirst($plugin['name']); ?></td>
      <td class="key"><?php echo ucfirst($plugin['group']); ?></td>
      <td><strong><?php echo ($plugin['result'])?JText::_('REMOVED'):JText::_('NOT_REMOVED'); ?></strong></td>
    </tr>
    <?php endforeach; ?>
    <?php endif; ?>
  </tbody>
</table>

<!-- End -->