<?php
/*
# ------------------------------------------------------------------------
# JA Amazon S3 for joomla 16
# ------------------------------------------------------------------------
# Copyright (C) 2004-2009 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
# @license - Copyrighted Commercial Software
# Author: J.O.O.M Solutions Co., Ltd
# Websites:  http://www.joomlart.com -  http://www.joomlancers.com
# This file may not be redistributed in whole or significant part.
# ------------------------------------------------------------------------
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.installer.installer');

// Load Component JA Amazon S3 language file
$lang = &JFactory::getLanguage();
$lang->load('com_jaamazons3');
$component_name = JText::_('COMPONENT_JA_AMAZON_S3');

$status = new JObject();
$status->modules = array ();
$status->plugins = array ();

if($this->manifest->package_elements->modules) {
	$modules = $this->manifest->package_elements->modules;
} else {
	$modules = null;
}

if($this->manifest->package_elements->plugins) {
	$plugins = $this->manifest->package_elements->plugins;
} else {
	$plugins = null;
}
//other extensions type..

//uninstall modules
if ($modules && count((array) $modules)) {
	foreach ($modules as $module) {
		$mname = $module->attributes()->module;
		$db = & JFactory::getDBO();
		$query = "SELECT `id` FROM `#__extensions` WHERE `type`='module' AND element = ".$db->Quote($mname)."";
		$db->setQuery($query);
		$modules2 = $db->loadResultArray();
		if (count($modules2)) {
			foreach ($modules2 as $module) {
				$installer = new JInstaller;
				$result = $installer->uninstall('module', $module, 0);
			}
		}
		$status->modules[] = array ('name'=>$mname, 'client'=>'Site', 'result'=>$result);
	}
}

//uninstall plugins
if ($plugins && count((array) $plugins)) {
	foreach ($plugins as $plugin) {
		$pname = $plugin->attributes()->plugin;
		$pgroup = $plugin->attributes()->group;
		$db = & JFactory::getDBO();
		$query = "SELECT `id` FROM #__extensions WHERE `type`='plugin' AND element = ".$db->Quote($pname)." AND folder = ".$db->Quote($pgroup);
		$db->setQuery($query);
		$plugins2 = $db->loadResultArray();
		if (count($plugins2)) {
			foreach ($plugins2 as $plugin) {
				$installer = new JInstaller;
				$result = $installer->uninstall('plugin', $plugin, 0);
			}
		}
		$status->plugins[] = array ('name'=>$pname, 'group'=>$pgroup, 'result'=>$result);
	}
}

?>

<?php $rows = 0;?>
<h2><?php echo JText::_('JA_AMAZON_S3_REMOVAL_STATUS'); ?></h2>
<table class="adminlist">
  <thead>
    <tr>
      <th class="title" colspan="2"><?php echo JText::_('EXTENSION'); ?></th>
      <th width="30%"><?php echo JText::_('STATUS'); ?></th>
    </tr>
  </thead>
  <tfoot>
    <tr>
      <td colspan="3"></td>
    </tr>
  </tfoot>
  <tbody>
    <tr class="row0">
      <td class="key" colspan="2"><?php echo $component_name; ?></td>
      <td><strong><?php echo JText::_('REMOVED'); ?></strong></td>
    </tr>
    <?php if (count($status->modules)) : ?>
    <tr>
      <th><?php echo JText::_('MODULE'); ?></th>
      <th><?php echo JText::_('CLIENT'); ?></th>
      <th></th>
    </tr>
    <?php foreach ($status->modules as $module) : ?>
    <tr class="row<?php echo (++ $rows % 2); ?>">
      <td class="key"><?php echo $module['name']; ?></td>
      <td class="key"><?php echo ucfirst($module['client']); ?></td>
      <td><strong><?php echo ($module['result'])?JText::_('REMOVED'):JText::_('NOT_REMOVED'); ?></strong></td>
    </tr>
    <?php endforeach;?>
    <?php endif; ?>
    <?php if (count($status->plugins)) : ?>
    <tr>
      <th><?php echo JText::_('PLUGIN'); ?></th>
      <th><?php echo JText::_('GROUP'); ?></th>
      <th></th>
    </tr>
    <?php foreach ($status->plugins as $plugin) : ?>
    <tr class="row<?php echo (++ $rows % 2); ?>">
      <td class="key"><?php echo ucfirst($plugin['name']); ?></td>
      <td class="key"><?php echo ucfirst($plugin['group']); ?></td>
      <td><strong><?php echo ($plugin['result'])?JText::_('REMOVED'):JText::_('NOT_REMOVED'); ?></strong></td>
    </tr>
    <?php endforeach; ?>
    <?php endif; ?>
  </tbody>
</table>

<!-- End -->